;-============-------------------------------------------------------------
   3DMAZE.ASM                                                  Main module
  ============                             

  Copyright (c) 1997, Isthmus
  http://www.jeffsys.net/~isthmus/
  e-mail: isthmus@jeffsys.net

  If you plan to use this code please notify us first, and, more
  importantly, be sure to give credit where credit is due.  :-)  You may
  not sell any products based on this code without first obtaining
  permission from Isthmus.  Cheers!


  This code can be built two different ways: hi-res, and low-res.
  Hi-res looks way better, but has more video compatibility problems.
  Low-res has a cool "fox head" sprite overlay.


  ------ CODE
	MainLoop
	InitVars
	TestWithJoy
	TestViews
	NewTest

  ------ DATA

	<none>

-;

;================================== LAYOUT ================================
LAYOUT

$0801:          SysStart

$0810:          ;TestWithJoy
		MainLoop

		InitVars
		InitVIC

		VidInterruptR         ; only used for hi-res
		VidInterruptE

		DrawAView
		DrawItNormal
		DrawItFlipped

		DrawPolyAL
		DrawPolyAR
		DrawPolyBL
		DrawPolyBR

		MultiplyAX
		DivideByA

		WaitForKey
		Pause
		ReadKey

		; --- DATA ---

		BlockIndex
		AttrPatches
		ScreenRows
		ColorShades
		Views216


$2000:		CMTData


$4000: 		; [SCREENS 0-3]

$4c00:		dmidhead
		dlefthead
		drighthead

$6000:		; [Bmp Memory]

$8000:          Views30
		ScaleTable

;$D000:

ENDL

;=============================== ALIASES ==================================

ALIASB _CLC		= $18
ALIASB _SEC		= $38
ALIASB _ADCz		= $65
ALIASB _SBCz		= $E5

; Variables:

ALIASB PolyA       	= $10
ALIASB PolyC       	= $11
ALIASB PolyX    	= $12
ALIASB PolyW       	= $13
ALIASB PolyClip		= $14   ; number of columns to clip
ALIASB PolyDir		= $15
ALIASB PolyIsShadow	= $16
ALIASB PolyTextL      	= $17
ALIASB PolyTextH      	= $18

ALIASB vy       	= $19
ALIASB vx       	= $1A
ALIASB r        	= $1B
ALIASB sx       	= $1C
ALIASB sy       	= $1D
ALIASB TColor    	= $1E	; color of top half
ALIASB BColor   	= $1F   ; color of bottom half
ALIASB hd      		= $20
ALIASB temp1   		= $21
ALIASB temp2   		= $22
ALIASB temp3   		= $23
ALIASB temp4   		= $24
ALIASB NewVidPageH 	= $25

ALIASB math_accL        = $26
ALIASB math_accH        = $27

ALIASB ThiefL        	= $28
ALIASB ThiefH        	= $29
ALIASB AnswerL      	= $2A
ALIASB AnswerH      	= $2B
ALIASB Robber        	= $2C

ALIASB shade        	= $2D
ALIASB hddiv2        	= $2E
ALIASB TempX		= $2F
ALIASB TempY		= $30

ALIASB FSmlX		= $31
ALIASB FSmlY		= $32
ALIASB FBigX		= $33
ALIASB FBigY		= $34
ALIASB FRot		= $35

ALIASB PolyTbl1L	= $36
ALIASB PolyTbl1H	= $37

ALIASB PolyTbl2L	= $38
ALIASB PolyTbl2H	= $39

ALIASB PolyTbl3L	= $3A
ALIASB PolyTbl3H	= $3B

ALIASB PolyTblIdx	= $3C

ALIASB MapX		= $3D
ALIASB MapY		= $3E
ALIASB MapSide		= $3F

ALIASB FlipScreen	= $40

ALIASB inttemp1		= $41
ALIASB columncount	= $42
ALIASB RowCount		= $43
ALIASB TOPscreenL	= $44
ALIASB TOPscreenH   	= $45
ALIASB BOTscreenL	= $46
ALIASB BOTscreenH   	= $47

ALIASB CurAttr		= $48

ALIASB OldKey		= $49
ALIASB Column		= $4A
ALIASB joydir		= $4B
ALIASB videomode	= $4C
ALIASB headwavecount	= $4D
ALIASB limits		= $4E

ALIASB NewSmlX		= $4F
ALIASB NewSmlY		= $50

ALIASB _Ceil1 		= $33	; Ceiling colors
ALIASB _Ceil2 		= $e3
ALIASB _Ceil3 		= $ee
ALIASB _Ceil4 		= $6e
ALIASB _Ceil5 		= $66
ALIASB _Ceil6 		= $60

ALIASB _Floor6 		= $b0	; Floor colors
ALIASB _Floor5 		= $bb
ALIASB _Floor4 		= $bc
ALIASB _Floor3 		= $cc
ALIASB _Floor2 		= $cf
ALIASB _Floor1 		= $ff



;=============================== LIBRARIES ================================

@TEXTURE
@DRAWVIEW
@MISC

; Uncomment either HICODE and HIDATA or LOCODE and LODATA.  Low-res mode
; is really bad resolution, but includes sprites of the fox's head.
; Hi-res mode is decent resolution, but has only been tested on the C64S
; emulator (it does not yet work properly on a real C64).

@HICODE
@HIDATA
;@LOCODE
;@LODATA

;================================= MAIN ===================================

;-------------------------------------------------------------------------;
CODE MainLoop
;-------------------------------------------------------------------------;

; THIS SELECTS VIDEO MODE
;lda #$00
;sta videomode

	jsr InitVars
	jsr InitVIC

; THIS DEPENDS ON VIDEO MODE
;lda #$49
;sta NewVidPageH

	lda #$41
	sta NewVidPageH

	lda $d018
	eor #$20
	sta $d018


; THESE SET THE FOX'S INITIAL POSITION
lda #$01
sta FSmlX
lda #$01
sta FSmlY

lda $2400   ; THESE GET SET FROM THE MAP DATA
sta FBigX
lda $2401
sta FBigY
lda $2402
sta FRot

bigloop:

	;-------- read the joystick ------;

		lda $dc00
		sta JoyDir		; (used by the fox head routines)

JoyUp:		lda joydir  		; forward
		and #$01
		jne joydown
		ldx FRot
		jsr goforward
		jmp joyleft

JoyDown:	lda joydir			; back
		and #$02
		bne JoyLeft
		lda FRot		; spin the FRot around 180 degs
		clc
		adc #12
		cmp #24
		bcc +
		sbc #24
&		tax
		jsr GoForward

JoyLeft:        lda joydir			; left
		and #$04
		bne JoyRight
		lda joydir
		and #$10
		bne rotateL
strafeL:        lda frot
		clc
		adc #6
		cmp #24
		bcc +
		sbc #24
&		tax
		jsr goforward
		jmp joydone
rotateL:	inc FRot
		lda FRot
		cmp #24
		bne JoyDone
		lda #$00
		sta FRot
		jmp JoyDone

JoyRight:       lda joydir			; right
		and #$08
		bne JoyDone
		lda joydir
		and #$10
		bne rotateR
strafeR:        lda frot
		sec
		sbc #6
		bcs +
		adc #24
&		tax
		jsr goforward
		jmp joydone
rotateR:	dec FRot
		lda FRot
		cmp #$ff
		bne JoyDone
		lda #23
		sta FRot
		jmp JoyDone

JoyDone:

	;--------- clear screen -------------;


done:		lda videomode
		beq clearlores
		jmp clearhires

clearlores:	lda NewVidpageH
		cmp #$49
		beq screentwoL

screenoneL:     ldx #$4f
&		lda #_Ceil1
		sta $4000,x
		lda #_Ceil2
		sta $4050,x
		lda #_Ceil3
		sta $40a0,x
		lda #_Ceil4
		sta $40f0,x
		lda #_Ceil5
		sta $4140,x
		lda #_Ceil6
		sta $4190,x
;;;;;
		lda #$00
		sta $41e0,x
;;;;;;
		lda #_Floor6
		sta $4230,x
		lda #_Floor5
		sta $4280,x
		lda #_Floor4
		sta $42d0,x
		lda #_Floor3
		sta $4320,x
		lda #_Floor2
		sta $4370,x
		dex
		bpl -
		ldx #$27
		lda #_Floor1
&		sta $43c0,x
		dex
		bpl -
		jmp drawit

screentwoL:     ldx #$4f
&		lda #_Ceil1
		sta $4800,x
		lda #_Ceil2
		sta $4850,x
		lda #_Ceil3
		sta $48a0,x
		lda #_Ceil4
		sta $48f0,x
		lda #_Ceil5
		sta $4940,x
		lda #_Ceil6
		sta $4990,x
;;;;;
		lda #$00
		sta $49e0,x
;;;;;;
		lda #_Floor6
		sta $4a30,x
		lda #_Floor5
		sta $4a80,x
		lda #_Floor4
		sta $4ad0,x
		lda #_Floor3
		sta $4b20,x
		lda #_Floor2
		sta $4b70,x
		dex
		bpl -

		ldx #$27
		lda #_Floor1
&		sta $4bc0,x
		dex
		bpl -
		jmp drawit

clearhires:	lda NewVidPageH
		cmp #$49
		beq screentwoH
screenoneH:     ldx #$f9
		lda #$00
&	        sta $4400,x
		sta $44fa,x
		sta $45f4,x
		sta $46ee,x
		sta $4000,x
		sta $40fa,x
		sta $41f4,x
		sta $42ee,x
		dex
		cpx #$ff
		bne -
		jmp drawit

screentwoH:     ldx #$fa
		lda #$00
&		sta $4800,x
		sta $48fa,x
		sta $49f4,x
		sta $4aee,x
		sta $4c00,x
		sta $4cfa,x
		sta $4df4,x
		sta $4eee,x
		dex
		cpx #$ff
		bne -

	;-------- draw the new view --------;
drawit:

;&		lda $dc00		; wait for joystick to stop
;		and #%00011111
;		cmp #%00011111
;		bne -

		jsr DrawAView

	;--------- flip video pages --------;

		lda #$20
raster:		cmp $d012
		bne raster
		lda $d018
		eor #$20
		sta $d018
		lda NewVidPageH
		eor #$08
		sta NewVidPageH


animate:	dec animationcounters
		bne +
		lda #$02
		sta animationcounters
		inc DrawAView|currentframe
		lda DrawAView|currentframe
		cmp #$03
		bne +
		lda #$00
		sta DrawAView|currentframe


&		jmp bigloop

;--------------------------- MOVED JOY ROUTINES -------------------------;

GoForward:      lda FSmlX               ; Calculate DX+X and save for later
		clc
		adc XChanges,x
		sta NewSmlX

		lda FSmlY               ; Calculate DY+Y and save for later
		clc
		adc YChanges,x
		sta NewSmlY

		lda fbigX
		sta temp3
		lda fbigY
		sta temp4

MoveX:          lda newsmlX
		cmp #$ff
		bne +
		dec temp3
		lda #$02
		sta newSmlX
		jmp MoveY
&		cmp #$03
		bne +
		inc temp3
		lda #$00
		sta newSmlX
&
MoveY:          lda newsmlY
		cmp #$ff
		bne +
		inc temp4
		lda #$02
		sta newSmlY
		jmp goober
&		cmp #$03
		bne +
		dec temp4
		lda #$00
		sta newSmlY
&
goober:         lda #$09        ; check all together
		sta temp2
		lda temp4
		asl acc
		asl acc
		asl acc
		asl acc
		rol temp2
		asl acc
		rol temp2
		sta temp1
		ldy temp3
		lda (temp1),y
		bne +
		jsr legalX
		jmp legalY

&		ldy FbigX       ; check Y only
		lda (temp1),y
		beq legalY

		lda #$09        ; check X only
		sta temp2
		lda fbigY
		asl acc
		asl acc
		asl acc
		asl acc
		rol temp2
		asl acc
		rol temp2
		sta temp1
		ldy temp3
		lda (temp1),y
		beq legalX
		rts

legalX:		lda newsmlX
		sta fsmlX
		lda temp3
		sta fbigX
		rts

legalY:		lda newsmlY
		sta fsmlY
		lda temp4
		sta fbigY
		rts

;------------------------------------------------------------------------;


DATA
XChanges:
	    $01 $01
	$01 $01 $01
	$00 $00 $00
	$ff $ff $ff
	$ff $ff $ff
	$ff $ff $ff
	$00 $00 $00
	$01 $01 $01 $01

YChanges:
	    $00 $00
	$01 $01 $01
	$01 $01 $01
	$01 $01 $01
	$00 $00 $00
	$ff $ff $ff
	$ff $ff $ff
	$ff $ff $ff $00

;-
LimitCheckX: 	$20  ; NewSmlX = 0
LimitCheckY: 	$41  ; NewSmlY = 0
		$22  ; NewSmlX = 2
		$01  ; NewSmlY = 2

		     ; (X,Y)
LimitCheckDiag:	$40  ; (0,0)
		$42  ; (2,0)
		$00  ; (0,2)
		$02  ; (2,2)
-;



ClipCheck:	$40 $41 $42 $41    ; indexed with FSmlY*4 + FSmlX
		$20 $20 $22 $22
		$00 $01 $02 $01
		$20 $20 $22 $22


animationcounters: $00 $00 $00 $00 $00 $00 $00 $00

ENDC

;-------------------------------------------------------------------------;
CODE InitVars
;-------------------------------------------------------------------------;

		sei

		lda #$07		; set up fox loc
		sta FBigX
		lda #$03
		sta FBigY

		lda #$03
		sta FRot
		lda #$01
		sta FSmlX
		sta FSmlY

		lda $dd00    		; move video bank to $8000
		and #$fc
		ora #$02
		sta $dd00

		lda #$46                ; switch out BASIC ROM, keep others
		sta $01

		lda #$60                ;set up grid
		sta marker1 + 2

		ldy #$00
		lda #$20
		sta temp1
		ldx #$00

loop1:          lda grid,y
marker1:        sta $6000,x
		inx
		txa
		and #$07
		tay
		cpx #$00
		bne loop1

		dec temp1
		beq more
		inc marker1 + 2
		jmp loop1

more:		ldx #$07
&		lda #$00
		sta DrawAView|currentframe,x
		lda #$01
		sta MainLoop|animationcounters,x
		dex
		bpl -

return:		rts

DATA
grid:		$aa $55 $aa $55 $aa $55 $aa $55


ENDC



;=============================== DEBUGGING ================================


;-------------------------------------------------------------------------;
CODE TestViews
;-------------------------------------------------------------------------;

		jsr InitVars
		jsr SetupScreen

;	lda #$41
;	sta NewVidPageH

lda #6
sta FRot
lda #1
sta FSmlX
sta FSmlY

lda #$01
sta FSmlX
lda #$01
sta FSmlY
lda #$10
sta FBigX
lda #$07
sta FBigY

		lda #0
		sta CurAttr

bigloop:

	;-------- read the keyboard ------;

&               jsr ReadKey

		bne +
		lda $dc00
		and #%00011111
		cmp #%00011111
		bne keydone
		jmp -

&		cmp #'Q'		; --FRot
		bne +
		dec FRot
		lda FRot
		cmp #$ff
		bne keydone
		lda #23
		sta FRot
		jmp keydone
		&

		cmp #'E'		; ++FRot
		bne +
		inc FRot
		lda FRot
		cmp #24
		bne keydone
		lda #0
		sta FRot
		jmp keydone
		&

		cmp #'X'		; ++FSmlX
		bne +
		ldx FSmlX
		lda NextSmlInc,x
		sta FSmlX
		jmp keydone
		&

		cmp #'Y'		; ++FSmlY
		bne +
		ldx FSmlY
		lda NextSmlInc,x
		sta FSmlY
		jmp keydone
		&

		cmp #'A'		; debug
		bne +
		dec CurAttr
		lda CurAttr
		and #$0f
		sta CurAttr
		jmp keydone
		&

		cmp #'S'		; debug
		bne +
		inc CurAttr
		lda CurAttr
		and #$0f
		sta CurAttr
		jmp keydone
		&

keydone:
	;-------- read the joystick ------;
		lda $dc00

		lsr acc			; up
		bcs ++
		lda FSmlY
		cmp #2
		beq +
		inc FSmlY
		jmp joydone
&		lda #0
		sta FSmlY
		inc FBigY
		jmp joydone
		&

		lsr acc			; down
		bcs ++
		lda FSmlY
		beq +
		dec FSmlY
		jmp joydone
&		lda #2
		sta FSmlY
		dec FBigY
		jmp joydone
		&

		lsr acc			; left
		bcs ++
		lda FSmlX
		beq +
		dec FSmlX
		jmp joydone
&		lda #2
		sta FSmlX
		dec FBigX
		jmp joydone
		&

		lsr acc			; right
		bcs ++
		lda FSmlX
		cmp #2
		beq +
		inc FSmlX
		jmp joydone
&		lda #0
		sta FSmlX
		inc FBigX
		jmp joydone
		&

joydone:
	;--------- clear screen -------------;

done:           lda NewVidPageH
		cmp #$49
		beq screentwo

screenone:      ldx #$fa
		lda #$00
&	        sta $8400,x
		sta $84fa,x
		sta $85f4,x
		sta $86ee,x
		sta $8000,x
		sta $80fa,x
		sta $81f4,x
		sta $82ee,x
		dex
		cpx #$ff
		bne -

		jmp drawit

screentwo:      ldx #$fa
		lda #$00
&		sta $8800,x
		sta $88fa,x
		sta $89f4,x
		sta $8aee,x
		sta $8c00,x
		sta $8cfa,x
		sta $8df4,x
		sta $8eee,x
		dex
		cpx #$ff
		bne -

	;-------- draw the new view --------;
drawit:
		jsr DrawAView


	;--------- flip video pages --------;

		lda $d018
		eor #$20
		sta $d018
		lda NewVidPageH
		eor #$08
		sta NewVidPageH

		jmp bigloop

DATA
NextSmlInc: 1 2 0

ENDC


;-------------------------------------------------------------------------;
CODE NewTest
;-------------------------------------------------------------------------;
		jsr InitVars
		jsr SetupScreen

		lda #$41
		sta NewVidPageH

		lda #0
		sta $7000

	lda #<GameTextures|Num4
	sta PolyTextL
	lda #>GameTextures|Num4
	sta PolyTextH


Again:
		ldx #$fa
		lda #$00
&	        sta $8400,x
		sta $84fa,x
		sta $85f4,x
		sta $86ee,x
		eor #$06
		sta $8000,x
		sta $80fa,x
		sta $81f4,x
		sta $82ee,x
		dex
		cpx #$ff
		bne -

jmp DoIt
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

&

lda #$06
sta PolyA
lda #$03
sta PolyC
lda #$04
sta PolyW
lda #$09
sta PolyX
;lda #$01
;sta PolyDir

;jsr DrawItNormal
jsr DrawPolyAL

jsr WAITFORKEY
		ldx #$fa
		lda #$00
&	        sta $8400,x
		sta $84fa,x
		sta $85f4,x
		sta $86ee,x
		eor #$06
		sta $8000,x
		sta $80fa,x
		sta $81f4,x
		sta $82ee,x
		dex
		cpx #$ff
		bne -

jmp --


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
DoIt:

		ldy #5
&		lda P1-1,y
		sta $0010-1,y
		dey
		bne -

		jsr DrawIt
		jsr WaitForKey

;;---------
		ldy #5
&		lda P2-1,y
		sta $0010-1,y
		dey
		bne -

		jsr DrawIt
		jsr WaitForKey

;;---------
		ldy #5
&		lda P3-1,y
		sta $0010-1,y
		dey
		bne -

		jsr DrawIt
		jsr WaitForKey

;;---------
		ldy #5
&		lda P4-1,y
		sta $0010-1,y
		dey
		bne -

		jsr DrawIt
		jsr WaitForKey

;;---------
		ldy #5
&		lda P5-1,y
		sta $0010-1,y
		dey
		bne -

		jsr DrawIt
		jsr WaitForKey

		lda $7000
		eor #1
		and #1
		sta $7000

		jmp Again


DrawIt:         lda $7000
		beq +
		jmp DrawItNormal
&		jmp DrawItFlipped


DATA
P1:	$0c $00 $01 $0B $01
P2:	$0B $02 $1A $08 $00
P3:	$0B $01 $1A $13 $01
P4:	$07 $01 $16 $0A $01
P5:	$09 $06 $02 $0A $00
ENDC


;-------------------------------------------------------------------------;
CODE TestWithJoy
;-------------------------------------------------------------------------;

lda #$00
sta videomode
		jsr InitVars
		jsr InitVIC

	lda #$41
	sta NewVidPageH

	lda #<Textures
	sta PolyTextL
	lda #>Textures
	sta PolyTextH

	lda #$00
	sta PolyIsShadow

lda #6
sta PolyA
lda #3
sta PolyC
lda #4
sta PolyW
lda #10
sta PolyX
lda #3		; AL
sta PolyDir
lda #0
sta PolyClip
lda #0
sta FlipScreen

lda #130
sta PolyA
lda #120
sta PolyC


;;;---------------
lda #38
sta PolyA
lda #67
sta PolyW
lda #31
sta PolyX
lda #0
sta PolyC
lda #1
sta PolyDir
;;----------------;

		jmp done

wait:           jsr ReadKey
		beq nokey

&	        cmp #'+'
		bne +
		inc PolyA
		jmp done
&	        cmp #'-'
		bne +
		dec PolyA
		jmp done

&		cmp #'D'
		bne +
		inc PolyDir
		lda PolyDir
		and #1
		sta PolyDir
		jmp done

&		cmp #'S'
		bne +
		ldx #0
		lda PolyIsShadow
		bne makezero
		inx
makezero:	stx PolyIsShadow
		jmp done

&		cmp #'0'
		bne +
		inc PolyX
		jmp done

&		cmp #'9'
		bne +
		dec PolyX
		jmp done

&		cmp #'7'
		bne +
		inc PolyClip
		jmp done
&		cmp #'8'
		bne +
		dec PolyClip
		jmp done

&		cmp #'1'
		bne +
		dec PolyTextH
		jmp done
&		cmp #'2'
		bne +
		inc PolyTextH
		jmp done

&		cmp #' '
		bne nokey
		lda FlipScreen
		eor #01
		and #01
		sta FlipScreen
		jmp done

nokey:          lda $dc00
		and #%00011111
		cmp #%00011111
		jeq wait

UP:             lsr acc
		bcs DOWN
		inc PolyC
DOWN:           lsr acc
		bcs LEFT
		dec PolyC
LEFT:           lsr acc
		bcs RIGHT
		dec PolyW
RIGHT:          lsr acc
		bcs done
		inc PolyW

done:           lda NewVidPageH
		cmp #$48
;		beq screentwo

screenone:      ldx #$fa
		lda #$00
smoother1:      sta $4400,x
		sta $44fa,x
		sta $45f4,x
		sta $46ee,x
		;eor #$06
		sta $4000,x
		sta $40fa,x
		sta $41f4,x
		sta $42ee,x
		dex
		cpx #$ff
		bne smoother1

		lda #$00
		ldx #40
&		sta $45df,x
		sta $41df,x
		dex
		bne -

		jmp skip1

screentwo:      ldx #$fa
		lda #$00
smoother2:      sta $4800,x
		sta $48fa,x
		sta $49f4,x
		sta $4aee,x
		;eor #$06
		sta $4c00,x
		sta $4cfa,x
		sta $4df4,x
		sta $4eee,x
		dex
		cpx #$ff
		bne smoother2

		lda #$00
		ldx #40
&		sta $49df,x
		sta $4ddf,x
		dex
		bne -

skip1:

;-
		lda PolyDir
		lsr acc
		bcs ALorAR
		lsr acc
		bcs BR
		jsr DrawPolyBL
		jmp NextPoly
BR:		jsr DrawPolyBR
		jmp NextPoly

ALorAR:		lsr acc
		bcs AL
		jsr DrawPolyAR

		jmp NextPoly
AL:		jsr DrawPolyAL
		jmp NextPoly
-;

		lda #$e0
		sta TOPscreenL
		lda NewVidPageH
		sta TOPscreenH

;--- test points
		ldy #20
		lda #'8'
		sta (TOPscreenL),y
		ldy #31
		sta (TOPscreenL),y
		ldy #39
		sta (TOPscreenL),y
------;


;lda #0
;sta PolyClip
;jsr DrawPolyBR
		lda FlipScreen
		cmp #0
		bne +
		jsr DrawItNormal
		jmp NextPoly
&		jsr DrawItFlipped

		; undo flipping
		lda #39
		sec
		sbc PolyX
		sta PolyX            	; 39-PolyX -> PolyX
		lda PolyDir
		eor #1
		sta PolyDir

NextPoly:

&	        lda $dc00
		and #%00011111
		cmp #%00011111
		bne -


	;-	lda $d018
		eor #$30
		sta $d018
		lda NewVidPageH
		eor #$0c
		sta NewVidPageH
	-;

		jmp wait
ENDC

