;       three parallaxing planes
;
;;----------------------------------------------------------------------------

LAYOUT
;;----

$0801:		dsysstart

$0810:		ssetup
		smain
		srun
		sjump
		sfall
		sglide
		slimits
		sallsprite
		sscroll

$1000:		dmap


$2000:		;-screen1-;
$2400:		;-screen2-;

$2800:		dchars
$3000:		foxsprites

$4c00:		background
$5a00:		stillground
$6000:		charcolors

ENDL

ALIASB		totalheight	= 22


ALIASB          temp1		= $fb
ALIASB          temp2 		= $fc
ALIASB          temp3 		= $fd
ALIASB          temp4 		= $fe
ALIASB		columncountTOP	= $10
ALIASB		columncountBOTT	= $11
ALIASB		blockTOPL	= $12
ALIASB		blockTOPH	= $13
ALIASB		blockBOTTL	= $14
ALIASB		blockBOTTH	= $15
ALIASB		scrolldir       = $16
ALIASB		newscreen	= $17
ALIASB		backoffset	= $18

ALIASB		back1L		= $19
ALIASB		back1H		= $1a
ALIASB		back2L		= $1b
ALIASB		back2H		= $1c
ALIASB		back3L		= $1d
ALIASB		back3H		= $1e
ALIASB		back4L		= $1f
ALIASB		back4H		= $20
ALIASB		back5L		= $21
ALIASB		back5H		= $22

ALIASB		nextlineBG	= $23
ALIASB		newB		= $24
ALIASB		runstep		= $25
ALIASB		shift		= $26
ALIASB		joydir		= $27
ALIASB		jumpstep	= $28
ALIASB		fallstep	= $29
ALIASB		limits		= $2a
ALIASB		Xoffset		= $2b
ALIASB		width		= $2c
ALIASB		Yoffset		= $2d
ALIASB		height		= $2e
ALIASB		screenL		= $2f
ALIASB		screenH		= $30
ALIASB		mapX		= $31

ALIASW		screen1		= $2000
ALIASW		screen2		= $2400
ALIASW		foreground	= $4800

ALIASW		colorbuffer	= $6200
ALIASW		linebuffer	= $6700



CODE ssetup
;;--------

start:          sei
		ldx #$f9
&		lda #$00
		sta foreground,x
		sta foreground + $00fa,x
		sta foreground + $01f4,x
		sta foreground + $02ee,x
		dex
		cpx #$ff
		bne -

		lda #$8a
		sta $d018
		lda #$02
		sta columncountTOP
		lda #$06
		sta columncountBOTT
		lda #$24
		lda #$18
		sta $d016

		lda #$00
		sta $d020
		sta $d021
		sta backoffset
		sta newB
		sta runstep
		sta shift
		sta mapX
		lda #$0b
		sta $d022
		lda #$0e
		sta $d023

		lda #$0f
		sta $d015
		lda #$40
		sta $d004
		sta $d006
		clc
		adc #$2a
		sta $d000
		sta $d002
		lda #$90
		sta $d001
		sta $d003
		sta $d005
		sta $d007
		lda #$00
		sta $d027
		sta $d029
		lda #$0c
		sta $d028
		lda #$0c
		sta $d02a
		lda #$0f
		sta $d01d
		sta $d017

		lda #$24
		sta newscreen
		jsr sscroll|newblock

ENDC


CODE smain
;;-------

start:          jsr sscroll|FOXRIGHT
		jsr slimits
		lda $dc00
		sta joydir
pointer:	jsr srun
		jmp start


ENDC

CODE srun
;;-------

setup:          lda #<start
		sta smain|pointer + 1
		lda #>start
		sta smain|pointer + 2
		lda #$00
		sta runstep

start:          lda #$02
		bit limits
		bne button
		jmp sfall|setup
button:		lda #$10
		bit joydir
		bne glider
		jmp sjump|setup
glider:		lda #$03
		jsr sglide
newsprite:	lda runstep
		clc
		adc #$c0
		jsr sallsprite
		lda runstep
		cmp #$04
		bne +
		lda #$00
		sta runstep
		rts
&		inc runstep
		rts

ENDC

CODE sjump
;;--------

setup:		lda #<start
		sta smain|pointer + 1
		lda #>start
		sta smain|pointer + 2
		lda #$00
		sta jumpstep
		lda #$c2
		jsr sallsprite

start:		lda #$10
		bit joydir
		beq nofall
		lda jumpstep
		cmp #$06
		bcs nofall
		lda #$06
		sta jumpstep
nofall:         lda #$04
		jsr sglide
		ldx jumpstep
		lda $d001
		sec
		sbc sinus,x
		sta $d001
		sta $d003
		sta $d005
		sta $d007

		lda jumpstep
		cmp #$08
		bne +
		jmp sfall|setup
&		inc jumpstep
		rts

DATA

sinus:		14 12 11 10 8 6 3 2 0


ENDC


CODE sfall
;;--------

setup:		lda #<start
		sta smain|pointer + 1
		lda #>start
		sta smain|pointer + 2
		lda #$07
		sta fallstep
		lda #$c3
		jsr sallsprite

start:          lda #$02
		bit limits
		beq norun
		lda $d001
		and #$f8
		sta $d001
		sta $d003
		sta $d005
		sta $d007
		jmp srun|setup

norun:          lda #$04
		jsr sglide
		ldx fallstep
		lda $d001
		clc
		adc sjump|sinus,x
		sta $d001
		sta $d003
		sta $d005
		sta $d007

		lda fallstep
		bne +
		jmp srun|setup
		rts
&		dec fallstep
		rts


ENDC


CODE sallsprite
;;-------------

		sta screen1 + $03f8
		sta screen2 + $03f8
		clc
		adc #$05
		sta screen1 + $03f9
		sta screen2 + $03f9
		clc
		adc #$05
		sta screen1 + $03fa
		sta screen2 + $03fa
		clc
		adc #$05
		sta screen1 + $03fb
		sta screen2 + $03fb
		rts

ENDC


CODE sglide
;;---------
		sta temp1
LEFT:		lda #$04
		bit joydir
		bne RIGHT
		lda shift
		sec
		sbc temp1
		bcc DONE
		sta shift
		jmp moveLR
RIGHT:		lda #$08
		bit joydir
		bne DONE
		lda shift
		clc
		adc temp1
		cmp #$60
		bcs DONE
		sta shift
moveLR:		lda #$30
		clc
		adc shift
		sta $d004
		sta $d006
		clc
		adc #$2a
		sta $d000
		sta $d002
DONE:		rts

ENDC


CODE slimits
;;----------

start:          lda $d000
		sec
		sbc #$18
		lsr acc
		lsr acc
		lsr acc
		tay
		lda $d001
		sec
		sbc #$2e
		lsr acc
		lsr acc
		lsr acc
		tax
		lda screenrowL,x
		sta temp3
		lda screenrowH,x
		sta temp4

		lda #$00
		sta limits
		tya
		clc
		adc #$c8
		tay
		lda #$01
		lda (temp3),y
		bne +
		iny
		iny
		lda (temp3),y
		bne +
		iny
		iny
		lda (temp3),y
		bne +
		iny
		iny
		lda (temp3),y
		beq noground
&		lda #$02
		sta limits
noground:	rts

;-

limitup:	ldy #$00
		lda (temp4),y
		ldy #$00
		beq limitdown
		ldy #$00
		lda (temp4),y
		beq limitdown
		ldy #$00
		lda (temp4),y
		beq limitdown
		lda #$01
		sta limits

limitdown:	ldy #$00
		lda (temp4),y
		ldy #$00
		beq limitleft
		ldy #$00
		lda (temp4),y
		beq limitleft
		ldy #$00
		lda (temp4),y
		beq limitleft
		lda #$02
		sta limits

limitleft:	ldy #$00
		lda (temp4),y
		ldy #$00
		beq limitright
		ldy #$00
		lda (temp4),y
		beq limitright
		ldy #$00
		lda (temp4),y
		beq limitright
		lda limits
		ora #$04
		sta limits

limitright:	ldy #$00
		lda (temp4),y
		ldy #$00
		beq done
		ldy #$00
		lda (temp4),y
		beq done
		ldy #$00
		lda (temp4),y
		beq done
		lda limits
		ora #$08
		sta limits
-;;



		rts

DATA

screenrowL:     $00 $28 $50 $78 $a0 $c8 $f0 $18 $40 $68 $90 $b8 $e0
		$08 $30 $58 $80 $a8 $d0 $f8 $20 $48 $70 $98 $c0 $e8

screenrowH:     $48 $48 $48 $48 $48 $48 $48 $49 $49 $49 $49 $49 $49
		$4a $4a $4a $4a $4a $4a $4a $4b $4b $4b $4b $4b $4b

ENDC



CODE sscroll
;;---------

FOXRIGHT:       jsr screenleft
		inc backoffset
		lda backoffset
		cmp #$50
		bcc noreset
reset:		lda #$00
		sta backoffset

noreset:	lda #>background
		sta back1H
		clc
		adc #$02
		sta back2H
		clc
		adc #$02
		sta back3H
		clc
		adc #$03
		sta back4H
		clc
		adc #$02
		sta back5H

		lda backoffset
		sta back1L
		clc
		adc #$08
		sta back4L
		clc
		adc #$50
		sta back2L
		clc
		adc #$08
		sta back5L
		clc
		adc #$50
		sta back3L

		lda #$27
		sta nextlineBG
		ldy #$00

		ldx newscreen
		stx main1 + 2
		stx main2 + 2
		inx
		stx main3 + 2
		inx
		stx main4 + 2
		inx
		stx main5 + 2

priorityloop:   lda foreground,y
		bne +
		lda (back1L),y
		bne +
		lda stillground,y
&
main1:		sta $0000,y
		tax
		lda charcolors,x
		sta colorbuffer,y

		lda foreground + $c8,y
		bne +
		lda (back2L),y
		bne +
		lda stillground + $c8,y
&
main2:		sta $00c8,y
		tax
		lda charcolors,x
		sta colorbuffer + $c8,y

		lda foreground + $0190,y
		bne +
		lda (back3L),y
		bne +
		lda stillground + $0190,y
&
main3:		sta $0190,y
		tax
		lda charcolors,x
		sta colorbuffer + $0190,y

		lda foreground + $0258,y
		bne +
		lda (back4L),y
		bne +
		lda stillground + $0258,y
&
main4:		sta $0258,y
		tax
		lda charcolors,x
		sta colorbuffer + $0258,y

		lda foreground + $0320,y
		bne +
		lda (back5L),y
		bne +
		lda stillground + $0320,y
&
main5:		sta $0320,y
		tax
		lda charcolors,x
		sta colorbuffer + $0320,y

		iny
		cpy #$c8
		beq docolor

		dec nextlineBG
		bpl priorityloop
		lda #$27
		sta nextlineBG
		lda back1L
		clc
		adc #$50
		sta back1L
		bcc +
		inc back1H
& 		lda back2L
		clc
		adc #$50
		sta back2L
		bcc +
		inc back2H
& 		lda back3L
		clc
		adc #$50
		sta back3L
		bcc +
		inc back3H
& 		lda back4L
		clc
		adc #$50
		sta back4L
		bcc +
		inc back4H
& 		lda back5L
		clc
		adc #$50
		sta back5L
		bcc +
		inc back5H
&               jmp priorityloop

docolor:	lda $d011
		bmi docolor

		lda #$32
&		cmp $d012
		bne -

		ldx #$80
&		dex
		bne -

fillcolor:	ldx #$00
&		lda colorbuffer,x
		sta $d800,x
		inx
		bne -
&		lda colorbuffer + $0100,x
		sta $d900,x
		inx
		bne -
&		lda colorbuffer + $0200,x
		sta $da00,x
		inx
		bne -
		ldx #$e8
&		lda colorbuffer + $02ff,x
		sta $daff,x
		dex
		bne -

flipit:		lda newscreen
		eor #$04
		sta newscreen
		lda $d018
		eor #$10
		sta $d018
		rts

screenleft:     lda foreground + $fa
		sta linebuffer
		lda foreground + $fb
		sta linebuffer + 1
		lda foreground + $01f4
		sta linebuffer + 2
		lda foreground + $01f5
		sta linebuffer + 3
		lda foreground + $02ee
		sta linebuffer + 4
		lda foreground + $02ef
		sta linebuffer + 5
		ldx #$00
&		lda foreground + $02,x
		sta foreground,x
		lda foreground + $fc,x
		sta foreground + $fa,x
		lda foreground + $01f6,x
		sta foreground + $01f4,x
		lda foreground + $02f0,x
		sta foreground + $02ee,x
		inx
		cpx #$fa
		bne -
		lda linebuffer
		sta foreground + $f8
		lda linebuffer + 1
		sta foreground + $f9
		lda linebuffer + 2
		sta foreground + $01f2
		lda linebuffer + 3
		sta foreground + $01f3
		lda linebuffer + 4
		sta foreground + $02ec
		lda linebuffer + 5
		sta foreground + $02ed

newdataonright:
bottom:
line1:		lda #totalheight
		sta temp1
		ldy #$00
		lda #<foreground + $0026
		sta screenL
		lda #>foreground + $0026
		sta screenH
		lda Xoffset
		beq draw1
empty1:		jsr emptyline
		dec Xoffset
		jmp line2
draw1:		lda width
		bne +
last1:		jsr middleline	;lastline
		jsr newblock
		jmp line2
&		jsr middleline
		dec width

line2:		lda #totalheight
		sta temp1
		ldy #$00
		lda #<foreground + $0027
		sta screenL
		lda #>foreground + $0027
		sta screenH
		lda Xoffset
		beq draw2
empty2:		jsr emptyline
		dec Xoffset
		rts
draw2:		lda width
		bne +
last2:		jsr middleline	;lastline
		jsr newblock
		rts
&		jsr middleline
		dec width
		rts

newblock:       inc mapX
		ldx mapX
		cpx #$0f
		bne +
		ldx #$00
		stx mapX
&		lda $00,x	;dmap|byte1,x
		and #$0f
		sta width
		lda $00,x	;dmap|byte1,x
		lsr acc
		lsr acc
		lsr acc
		lsr acc
		sta Xoffset
		lda $80,x	;dmap|byte2,x
		and #$0f
		sta height
		lda $80,x	;dmap|byte2,x
		lsr acc
		lsr acc
		lsr acc
		lsr acc
		sta Yoffset
		lda height
		clc
		adc Yoffset
		cmp #totalheight - 1
		bcc noclip
		lda #totalheight - 1
		sec
		sbc Yoffset
		sta height
noclip:		lda height
		beq +
		cmp #$04
		bcs +
		lda #$03
		sta height
&		rts

FIRSTLINE:	ldx Yoffset
		beq TLcorner
space1:		lda #$00
		sta (screenL),y
		jsr nextrow
		dex
		bne space1
TLcorner:	lda #$88
		sta (screenL),y
		jsr nextrow
		ldx height
leftside:	lda #$87
		sta (screenL),y
		jsr nextrow
		dex
		bne leftside
BLcorner:       lda #$86
		sta (screenL),y
		rts

MIDDLELINE:	ldx Yoffset
		beq top

space2:		lda #$00
		sta (screenL),y
		jsr nextrow
		dex
		bne space2

top:		ldx height
		beq earth2

		lda #$81
		sta (screenL),y
		jsr nextrow
		dex

middle:		lda #$89
		sta (screenL),y
		jsr nextrow
		dex
		bpl middle

bottle:		lda #$85
		sta (screenL),y
		jsr nextrow
		beq +
		bmi +

earth2:		lda #$00
		sta (screenL),y
		jsr nextrow
		bpl earth2
&		rts

LASTLINE:	ldx Yoffset
		beq TRcorner
space3:		lda #$00
		sta (screenL),y
		jsr nextrow
		dex
		bne space3
TRcorner:	lda #$82
		sta (screenL),y
		jsr nextrow
		ldx height
rightside:	lda #$83
		sta (screenL),y
		jsr nextrow
		dex
		bne rightside
BRcorner:	lda #$84
		sta (screenL),y
		rts

EMPTYLINE:	ldx #totalheight
blankin:	lda #$00
		sta (screenL),y
		jsr nextrow
		dex
		bne blankin
		rts

nextrow:	tya
		clc
		adc #$28
		tay
		bcc +
		inc screenH
&               dec temp1
		rts

;-FOXLEFT:	lda #$04
		bit scrolldir
		bne screenright
		jmp FOXRIGHT

screenright:    lda $04fa
		sta linebuffer
		lda $04fb
		sta linebuffer + 1
		lda $05f4
		sta linebuffer + 2
		lda $05f5
		sta linebuffer + 3
		lda $06ee
		sta linebuffer + 4
		lda $06ef
		sta linebuffer + 5

		ldx #$f9
&		lda $0400,x
		sta $0402,x
		lda $04fa,x
		sta $04fc,x
		lda $05f4,x
		sta $05f6,x
		lda $06ee,x
		sta $06f0,x
		dex
		cpx #$ff
		bne -

		lda linebuffer
		sta $04fc
		lda linebuffer + 1
		sta $04fd
		lda linebuffer + 2
		sta $05f6
		lda linebuffer + 3
		sta $05f7
		lda linebuffer + 4
		sta $06f0
		lda linebuffer + 5
		sta $06f1
		rts
-;

ENDC


DATA dmap
;;-------

;Xoffset:width

byte1:  $11 $22 $33 $44 $55 $66 $77
	$88 $99 $aa $bb $cc $dd $ee $ff


;Yoffset:height

byte2:	$11 $22 $33 $44 $55 $66 $77
	$88 $99 $aa $bb $cc $dd $ee $ff

;$ff $ee $dd $cc $bb $aa $99 $88
;	$77 $66 $55 $44 $33 $22 $11

ENDD



DATA charcolors
;;-------------

	$09 $09 $09 $09 $09 $09 $09 $09
	$09 $09 $09 $09 $09 $09 $09 $09
	$09 $09 $09 $09 $09 $09 $09 $09
	$09 $09 $09 $09 $09 $09 $09 $09
	$09 $09 $09

	$0b $0b $0b $0b $0b $0b $0b $0b
	$0b $0b $0b $0b $0b $0b $0b $0b
	$0b $0b $0b $0b $0b $0b $0b $0b
	$0b $0b

	$0a $0a $0a $0c $0c
	$0a $0a $0a $0c $0c

	$0d $0d $0d $0d $0d $0d $0d $0d
	$0d $0d $0d $0d $0d $0d $0d $0d
	$0d $0d $0d $0d $0d $0d $0d $0d
	$0d $0d $0d $0d

	$0a $0a $0a $0c $0c
	$0a $0a $0a $0c $0c

	$0c $0c $0c $0c $0c $0c $0e $0e
	$0c $0e $0e $0c

	$0e $0c $0e $0e $0c $0e $0c $0e

	$07 $07 $07 $07 $07 $07 $07 $07
	$07 $0f $07 $07 $07 $07 $07 $07

ENDD


DATA dchars
;;---------

	$AA $AA $AA $AA $AA $AA $AA $AA
	$55 $55 $55 $55 $55 $55 $55 $55
	$00 $00 $00 $00 $00 $00 $00 $00
	$AA $AA $AA $AA $A8 $A1 $85 $15
	$AA $A8 $81 $15 $55 $55 $55 $55
	$80 $15 $55 $55 $55 $55 $55 $55
	$55 $55 $55 $55 $55 $55 $50 $05
	$55 $55 $55 $50 $45 $15 $55 $55
	$54 $51 $05 $55 $55 $55 $55 $55
	$FF $5F $55 $55 $55 $55 $55 $55
	$FF $FF $FF $7F $57 $55 $55 $55
	$FF $FF $FF $FF $FF $55 $55 $55
	$AA $AA $AA $AA $AA $A8 $83 $3F
	$AA $AA $A0 $8F $3F $FF $FF $FF
	$A0 $0F $FF $FF $FF $FF $FF $FF
	$FF $FF $FF $FF $FF $FF $FF $FF
	$FF $FF $FF $FF $FF $FF $FF $55
	$0A $F2 $FC $FF $FF $FF $FF $FF
	$AA $AA $2A $CA $F2 $FC $FF $FF
	$AA $AA $AA $AA $AA $AA $0A $F0
	$FF $FF $FF $FF $FF $FD $D5 $55
	$FF $FF $FF $FF $D5 $55 $55 $55
	$FF $FD $F5 $55 $55 $55 $55 $55
	$15 $41 $54 $55 $55 $55 $55 $55
	$55 $55 $55 $05 $51 $54 $55 $55
	$55 $55 $55 $55 $55 $15 $41 $54
	$0A $50 $55 $55 $55 $55 $55 $55
	$AA $AA $0A $50 $55 $55 $55 $55
	$AA $AA $AA $AA $2A $4A $52 $54
	$00 $00 $10 $00 $00 $00 $00 $04
	$11 $04 $11 $40 $11 $04 $11 $40
	$11 $44 $11 $44 $11 $44 $11 $44
	$11 $55 $44 $55 $11 $55 $44 $55
	$55 $15 $55 $55 $51 $55 $55 $55
	$55 $55 $55 $55 $45 $55 $55 $55
	$AA $AF $BF $BF $FF $FF $FF $FF
	$AA $FA $FE $FE $FF $FF $FF $FF
	$FF $FF $FF $FF $BF $BF $AF $AA
	$FF $FF $FF $FF $FE $FE $FA $AA
	$AA $AA $AA $AB $AB $AB $AA $AA
	$BF $FF $FF $FF $FF $FF $FF $BF
	$AA $EA $EA $FA $FA $FA $EA $AA
	$AA $AA $AA $AA $BE $FF $BE $AA
	$FF $FF $FF $FF $FF $BF $BF $AF
	$AA $AA $AA $AA $AA $AA $AA $AB
	$AA $AA $AA $AA $AA $AF $FF $FF
	$AA $AA $AA $AA $FF $FF $FF $FF
	$AA $AA $AA $AA $AA $FA $FF $FF
	$AA $AA $AA $AA $AA $AA $AA $FA
	$AA $AA $AB $AF $AF $BF $BF $FF
	$BF $FF $FF $FF $FF $FF $FF $FF
	$FE $FF $FF $FF $FF $FF $FF $FF
	$AA $AA $EA $FA $FA $FE $FE $FF
	$FF $FF $FF $FF $FF $BF $BF $AF
	$FF $FF $FF $FF $FF $FF $FE $FA
	$FF $AF $AA $AA $AA $AA $AA $AA
	$FF $FF $AF $AA $AA $AA $AA $AA
	$FF $FF $FF $AA $AA $AA $AA $AA
	$FF $FF $AA $AA $AA $AA $AA $AA
	$FF $FA $AA $AA $AA $AA $AA $AA
	$FF $FF $FF $FF $FF $FF $FF $FF
	$10 $BC $2C $1F $1F $1F $BE $1F
	$7C $7C $3C $30 $30 $01 $07 $07
	$00 $00 $0C $00 $00 $00 $00 $C3
	$03 $00 $00 $C0 $00 $04 $04 $0D
	$D2 $D0 $D0 $D0 $10 $00 $00 $08
	$2F $1F $1F $8C $0C $0C $20 $81
	$07 $03 $10 $10 $70 $7C $7C $FC
	$00 $00 $00 $00 $30 $30 $30 $00
	$3D $0D $0D $0C $00 $00 $C0 $00
	$0C $3C $3C $3E $3D $0C $0C $40
	$FF $FF $FF $FF $FF $FF $FF $FF
	$3F $8F $8F $A3 $A3 $A8 $AA $AA
	$FF $FF $FF $AB $FF $FF $3F $8F
	$FF $FF $FF $FF $FF $FF $FF $AA
	$A3 $A8 $AA $AA $AA $AA $AA $AA
	$FF $FF $3F $83 $A8 $AA $AA $AA
	$FF $AA $FF $FE $3F $83 $A8 $AA
	$FF $AB $FF $AA $FF $FE $0F $A0
	$FF $FA $FF $AA $FF $AA $FF $00
	$FF $FF $FA $FF $FF $FF $FA $FF
	$FF $FF $FF $FF $FF $FF $AA $FF
	$FF $FF $FF $AA $FF $AA $FF $00
	$FF $AA $FF $AA $FF $AB $FC $00
	$FF $AA $FF $AA $FF $C0 $01 $10
	$FF $FF $FF $FF $FF $FF $EA $FF
	$FF $FF $FF $AB $FF $FF $AA $FF
	$FF $AA $FF $AA $FF $03 $00 $00
	$FF $AA $FF $AA $FF $FA $0F $00
	$FF $AA $FF $AA $FF $AA $FF $00
	$FF $FF $FF $FF $FF $FF $FE $FF
	$FF $AB $FF $AA $FF $AA $FF $00
	$FF $FF $FF $EA $FF $AF $F0 $0A
	$FF $EA $FF $AB $FF $C0 $2A $AA
	$FF $AA $FF $F0 $0A $AA $AA $AA
	$F2 $CA $2A $AA $AA $AA $AA $AA
	$FF $FF $FF $FF $FF $FF $FA $FF
	$FF $FF $FA $FF $FF $FF $AB $FC
	$FF $FC $B2 $F2 $CA $CA $2A $AA
	$00 $04 $00 $1F $00 $2F $00 $0F
	$00 $00 $00 $04 $00 $1C $00 $0F
	$00 $00 $00 $00 $00 $10 $00 $00
	$00 $34 $00 $0C $00 $00 $00 $00
	$00 $02 $00 $34 $00 $F4 $00 $F4
	$1F $00 $9B $1F $0C $00 $8C $00
	$1F $00 $0C $00 $01 $00 $07 $07
	$30 $00 $30 $00 $00 $00 $00 $00
	$04 $04 $00 $3D $3C $0C $00 $00
	$30 $30 $00 $02 $00 $10 $00 $F2
	$77 $DD $77 $DD $77 $DD $77 $DD
	$17 $1D $17 $1D $17 $1D $17 $1D
	$80 $05 $15 $15 $17 $1D $17 $1D
	$77 $5D $77 $DD $77 $DD $77 $DD
	$AA $AA $AA $AA $AA $AA $AA $AA
	$80 $05 $15 $15 $17 $1D $17 $1D
	$02 $50 $54 $D4 $74 $D4 $74 $D4
	$AA $AA $AA $AA $AA $AA $AA $AA
	$75 $DD $75 $DD $77 $DD $77 $DD
	$02 $50 $54 $D4 $74 $D4 $74 $D4
	$54 $D4 $74 $D4 $74 $D4 $74 $D4
	$77 $DD $77 $DD $75 $DD $75 $DD
	$47 $4D $47 $4D $37 $1D $37 $1D
	$77 $DD $75 $D5 $74 $D4 $53 $51
	$55 $50 $47 $1D $77 $DD $77 $DD
	$55 $05 $71 $DC $77 $DD $77 $DD
	$77 $DD $77 $5D $17 $15 $47 $C5
	$71 $D1 $71 $D1 $74 $DC $74 $DC
	$77 $DD $77 $5D $77 $5D $77 $5D
	$77 $DD $77 $DD $77 $DD $77 $DD


	[........]
	[xxxxxxxx]
	[........]
	[xxxxxxxx]
	[xxxxxxxx]
	[xxxxxxxx]
	[xxxxxxxx]
	[xxxxxxxx]

	[........]
	[xxxxxx..]
	[.....xx.]
	[xxxxx.x.]
	[xxxxxxx.]
	[xxxxxxx.]
	[xxxxxxx.]
	[xxxxxxx.]

	[xxxxxxx.]
	[xxxxxxx.]
	[xxxxxxx.]
	[xxxxxxx.]
	[xxxxxxx.]
	[xxxxxxx.]
	[xxxxxxx.]
	[xxxxxxx.]

	[xxxxxxx.]
	[xxxxxxx.]
	[xxxxxxx.]
	[xxxxxxx.]
	[xxxxxxx.]
	[xxxxxxx.]
	[xxxxxx..]
	[........]

	[xxxxxxxx]
	[xxxxxxxx]
	[xxxxxxxx]
	[xxxxxxxx]
	[xxxxxxxx]
	[xxxxxxxx]
	[xxxxxxxx]
	[........]

	[.x.xxxxx]
	[.x.xxxxx]
	[.x.xxxxx]
	[.x.xxxxx]
	[.x.xxxxx]
	[.xx.xxxx]
	[..xxxxxx]
	[........]

	[.x.xxxxx]
	[.x.xxxxx]
	[.x.xxxxx]
	[.x.xxxxx]
	[.x.xxxxx]
	[.x.xxxxx]
	[.x.xxxxx]
	[.x.xxxxx]

	[........]
	[..xxxxxx]
	[.xx.....]
	[.x.xxxxx]
	[.x.xxxxx]
	[.x.xxxxx]
	[.x.xxxxx]
	[.x.xxxxx]

	[xxxxxxxx]
	[xxxxxxxx]
	[xxxxxxxx]
	[xxxxxxxx]
	[xxxxxxxx]
	[xxxxxxxx]
	[xxxxxxxx]
	[xxxxxxxx]

	[.x.x.x.x]
	[.x.x.x.x]
	[.x.x.x.x]
	[.x.x.x.x]
	[.x.x.x.x]
	[.x.x.x.x]
	[.x.x.x.x]
	[.x.x.x.x]




	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00

ENDD


DATA stillground
;;--------------

	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $2C $2D $2E
	$2E $2E $2F $30 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $31 $32 $3C $3C
	$3C $3C $3C $33 $34 $00 $23 $3C
	$24 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $2A $00
	$27 $28 $29 $00 $35 $3C $3C $3C
	$3C $3C $3C $3C $36 $00 $25 $3C
	$26 $27 $28 $29 $2A $00 $00 $00
	$30 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $37 $38 $39
	$39 $39 $3A $3B $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$33 $34 $00 $00 $23 $24 $00 $00
	$2A $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$3C $36 $00 $00 $25 $26 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$3B $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $0C $0D $0E $11 $12
	$13 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$1B $1C $00 $00 $00 $00 $00 $00
	$0C $0D $0E $0F $0F $0F $0F $0F
	$0F $11 $12 $13 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$01 $01 $1A $1B $1C $0C $0D $0E
	$0F $0F $0F $0F $0F $0F $0F $0F
	$0F $0F $0F $0F $11 $12 $13 $00
	$00 $00 $00 $00 $00 $0C $0D $0E
	$11 $12 $13 $00 $00 $00 $00 $00
	$01 $01 $06 $07 $08 $09 $0A $0B
	$10 $10 $0F $0F $0F $0F $0F $0F
	$0F $0F $10 $10 $14 $15 $16 $1A
	$1B $1C $03 $04 $05 $09 $0A $0B
	$0B $15 $16 $1A $1B $1C $03 $04
	$07 $08 $01 $01 $01 $01 $01 $01
	$01 $01 $01 $01 $01 $01 $01 $01
	$01 $01 $01 $01 $01 $01 $01 $01
	$01 $01 $17 $18 $19 $01 $01 $01
	$01 $01 $01 $06 $07 $08 $01 $01
	$01 $01 $01 $01 $01 $01 $01 $01
	$01 $01 $01 $01 $01 $01 $01 $01
	$01 $01 $01 $01 $01 $01 $01 $01
	$01 $01 $01 $01 $01 $17 $18 $19
	$06 $07 $08 $01 $01 $01 $01 $01
	$01 $01 $01 $01 $01 $01 $01 $01
	$01 $01 $01 $01 $01 $01 $01 $01
	$01 $01 $01 $01 $01 $01 $01 $01
	$01 $01 $01 $01 $01 $01 $01 $01
	$17 $18 $19 $01 $01 $01 $01 $01
	$01 $01 $01 $01 $01 $01 $01 $01
	$01 $01 $01 $01 $01 $01 $01 $01
	$01 $01 $01 $01 $01 $01 $01 $01
	$01 $01 $01 $01 $01 $01 $01 $01
	$01 $01 $01 $17 $18 $19 $01 $01
	$06 $07 $08 $17 $18 $19 $01 $01
	$01 $01 $01 $01 $01 $01 $22 $01
	$01 $01 $01 $01 $01 $01 $01 $01
	$01 $01 $01 $01 $01 $01 $01 $01
	$01 $01 $01 $01 $01 $01 $17 $18
	$01 $01 $01 $01 $01 $01 $17 $18
	$19 $01 $01 $01 $01 $01 $21 $21
	$01 $01 $01 $01 $01 $01 $01 $01
	$01 $01 $01 $01 $01 $01 $01 $01
	$01 $01 $01 $01 $01 $01 $01 $01
	$01 $01 $01 $01 $01 $01 $01 $01
	$01 $17 $18 $19 $01 $01 $01 $21
	$01 $01 $01 $01 $01 $01 $01 $01
	$01 $01 $01 $01 $01 $01 $01 $01
	$22 $22 $01 $01 $01 $01 $01 $01
	$01 $01 $01 $01 $22 $01 $01 $01
	$01 $22 $01 $01 $17 $18 $19 $21
	$01 $01 $01 $22 $01 $01 $01 $01
	$01 $01 $01 $01 $01 $01 $01 $01
	$01 $01 $21 $21 $01 $01 $01 $01
	$01 $21 $01 $01 $01 $21 $01 $01
	$01 $22 $01 $01 $01 $01 $01 $17
	$18 $19 $01 $01 $21 $01 $01 $01
	$01 $01 $01 $01 $01 $01 $01 $01
	$01 $01 $01 $01 $21 $21 $21 $01
	$21 $01 $21 $21 $21 $21 $01 $01
	$01 $01 $01 $21 $01 $01 $01 $01
	$01 $01 $17 $18 $19 $21 $01 $01
	$01 $01 $01 $21 $21 $22 $01 $01
	$01 $01 $01 $01 $01 $01 $21 $21
	$21 $21 $21 $21 $21 $21 $21 $21
	$01 $01 $01 $01 $21 $21 $01 $01
	$01 $01 $01 $01 $01 $17 $18 $19
	$01 $01 $01 $01 $01 $21 $21 $01
	$01 $01 $01 $01 $01 $21 $21 $21
	$21 $21 $21 $21 $21 $21 $21 $21
	$21 $21 $21 $21 $21 $21 $21 $21
	$21 $21 $21 $01 $01 $01 $01 $01
	$17 $18 $19 $01 $01 $01 $21 $21
	$21 $22 $21 $21 $21 $21 $21 $1D
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$A0 $A1 $00 $00 $00 $00 $00 $00


ENDD

DATA background
;;--------------
	$47 $47 $47 $47 $47 $47 $47 $47
	$47 $47 $47 $47 $47 $47 $47 $47
	$47 $47 $47 $47 $47 $47 $47 $47
	$47 $47 $47 $47 $47 $47 $47 $47
	$47 $47 $47 $47 $47 $47 $47 $47
	$47 $47 $47 $47 $47 $47 $47 $47
	$47 $47 $47 $47 $47 $47 $47 $47
	$47 $47 $47 $47 $47 $47 $47 $47
	$47 $47 $47 $47 $47 $47 $47 $47
	$47 $47 $47 $47 $47 $47 $47 $47
$47 $47 $47 $47 $47 $47 $47 $47
	$47 $47 $47 $47 $47 $47 $47 $47
	$47 $47 $47 $47 $47 $47 $47 $47
	$47 $47 $47 $47 $47 $47 $47 $47
	$47 $47 $47 $47 $47 $47 $47 $47


	$48 $49 $4A $47 $47 $47 $47 $47
	$47 $47 $47 $47 $47 $47 $47 $47
	$47 $47 $47 $47 $47 $47 $47 $47
	$47 $47 $47 $47 $47 $47 $47 $47
	$47 $47 $47 $47 $47 $47 $47 $47
	$47 $47 $47 $47 $47 $47 $47 $47
	$47 $47 $47 $47 $47 $47 $47 $47
	$47 $47 $47 $47 $47 $47 $47 $47
	$47 $47 $47 $47 $47 $47 $47 $47
	$47 $47 $47 $47 $47 $60 $61 $62
$48 $49 $4A $47 $47 $47 $47 $47
	$47 $47 $47 $47 $47 $47 $47 $47
	$47 $47 $47 $47 $47 $47 $47 $47
	$47 $47 $47 $47 $47 $47 $47 $47
	$47 $47 $47 $47 $47 $47 $47 $47



	$00 $4B $4C $4D $4E $4F $56 $47
	$47 $47 $47 $47 $47 $47 $47 $47
	$47 $47 $47 $47 $47 $47 $47 $47
	$47 $47 $47 $47 $47 $47 $47 $47
	$47 $47 $47 $47 $47 $47 $47 $55
	$56 $47 $47 $47 $47 $47 $47 $47
	$47 $47 $47 $47 $47 $47 $47 $47
	$47 $47 $47 $47 $47 $47 $47 $47
	$47 $47 $47 $47 $47 $47 $47 $47
	$47 $55 $5B $53 $54 $54 $5F $00
$00 $4B $4C $4D $4E $4F $56 $47
	$47 $47 $47 $47 $47 $47 $47 $47
	$47 $47 $47 $47 $47 $47 $47 $47
	$47 $47 $47 $47 $47 $47 $47 $47
	$47 $47 $47 $47 $47 $47 $47 $55




	$00 $00 $00 $00 $00 $00 $48 $49
	$4A $47 $47 $47 $47 $47 $47 $47
	$47 $47 $47 $47 $47 $47 $47 $47
	$47 $47 $47 $47 $47 $47 $47 $47
	$47 $47 $47 $47 $60 $61 $61 $62
	$48 $49 $4A $47 $47 $47 $47 $47
	$47 $47 $47 $47 $47 $47 $47 $47
	$47 $47 $47 $47 $47 $47 $47 $47
	$47 $47 $47 $47 $47 $47 $47 $60
	$61 $62 $63 $64 $66 $67 $00 $00
$00 $00 $00 $00 $00 $00 $48 $49
	$4A $47 $47 $47 $47 $47 $47 $47
	$47 $47 $47 $47 $47 $47 $47 $47
	$47 $47 $47 $47 $47 $47 $47 $47
	$47 $47 $47 $47 $60 $61 $61 $62


	$00 $00 $00 $00 $00 $00 $00 $4B
	$4C $4D $4E $4F $56 $47 $47 $47
	$47 $47 $47 $47 $47 $47 $47 $47
	$47 $47 $47 $47 $47 $55 $52 $53
	$54 $57 $58 $5B $5D $5E $5F $00
	$00 $4B $4C $4D $4E $56 $47 $47
	$47 $47 $47 $47 $47 $47 $47 $47
	$47 $47 $47 $47 $47 $47 $47 $47
	$47 $47 $56 $5B $5B $5C $5D $5E
	$5F $00 $68 $69 $40 $6C $00 $00
$00 $00 $00 $00 $00 $00 $00 $4B
	$4C $4D $4E $4F $56 $47 $47 $47
	$47 $47 $47 $47 $47 $47 $47 $47
	$47 $47 $47 $47 $47 $55 $52 $53
	$54 $57 $58 $5B $5D $5E $5F $00


	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $48 $49 $4A $47
	$47 $47 $47 $47 $55 $56 $47 $47
	$47 $47 $47 $60 $61 $62 $63 $64
	$65 $66 $67 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $48 $49 $4A
	$47 $47 $47 $47 $47 $55 $56 $47
	$47 $47 $47 $55 $55 $56 $47 $47
	$60 $61 $62 $00 $00 $00 $00 $00
	$00 $00 $42 $43 $40 $41 $00 $00
$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $48 $49 $4A $47
	$47 $47 $47 $47 $55 $56 $47 $47
	$47 $47 $47 $60 $61 $62 $63 $64
	$65 $66 $67 $00 $00 $00 $00 $00


	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $4B $4C $4D
	$4E $4F $52 $53 $54 $57 $58 $59
	$5B $5C $5D $5E $5F $00 $68 $69
	$6A $6B $6C $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $4B $4C
	$4D $4E $4F $5C $4E $4F $57 $58
	$52 $53 $54 $57 $58 $5B $5C $5D
	$5E $5F $00 $00 $00 $00 $00 $00
	$00 $00 $3D $3E $40 $46 $00 $00
$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $4B $4C $4D
	$4E $4F $52 $53 $54 $57 $58 $59
	$5B $5C $5D $5E $5F $00 $68 $69
	$6A $6B $6C $00 $00 $00 $00 $00


	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $63 $64 $65 $02 $02 $66 $67
	$00 $00 $00 $00 $00 $00 $3D $3E
	$3F $40 $41 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $63 $64 $65
	$02 $02 $02 $02 $66 $67 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $42 $43 $40 $41 $00 $00
$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $63 $64 $65 $02 $02 $66 $67
	$00 $00 $00 $00 $00 $00 $3D $3E
	$3F $40 $41 $00 $00 $00 $00 $00


	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $68 $69 $6A $02 $02 $6B $6C
	$00 $00 $00 $00 $00 $00 $42 $43
	$44 $45 $46 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $68 $69 $6A
	$02 $02 $02 $02 $6B $6C $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $42 $3E $40 $46 $00 $00
$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $68 $69 $6A $02 $02 $6B $6C
	$00 $00 $00 $00 $00 $00 $42 $43
	$44 $45 $46 $00 $00 $00 $00 $00


	$00 $00 $00 $00 $00 $00 $72 $73
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $3D $3E $3F $02 $02 $40 $41
	$00 $00 $00 $00 $00 $00 $3D $3E
	$3F $40 $41 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $72 $3D $3E $3F
	$02 $02 $02 $02 $40 $41 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $3D $43 $40 $41 $00 $00
$00 $00 $00 $00 $00 $00 $72 $73
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $3D $3E $3F $02 $02 $40 $41
	$00 $00 $00 $00 $00 $00 $3D $3E
	$3F $40 $41 $00 $00 $00 $00 $00


	$00 $00 $00 $00 $00 $6F $70 $75
	$76 $00 $00 $00 $00 $00 $00 $00
	$00 $42 $43 $44 $02 $02 $45 $46
	$00 $00 $00 $00 $00 $00 $42 $43
	$44 $45 $46 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $6F $70 $42 $43 $44
	$02 $02 $02 $02 $45 $46 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $42 $3E $40 $46 $00 $00
$00 $00 $00 $00 $00 $6F $70 $75
	$76 $00 $00 $00 $00 $00 $00 $00
	$00 $42 $43 $44 $02 $02 $45 $46
	$00 $00 $00 $00 $00 $00 $42 $43
	$44 $45 $46 $00 $00 $00 $00 $00


	$00 $00 $00 $00 $00 $6E $6D $6D
	$77 $00 $00 $00 $00 $00 $00 $00
	$00 $3D $3E $3F $02 $02 $40 $41
	$00 $00 $00 $00 $00 $00 $3D $3E
	$3F $40 $41 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $6E $6D $3D $3E $3F
	$02 $02 $02 $02 $40 $41 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $3D $43 $40 $41 $00 $00
$00 $00 $00 $00 $00 $6E $6D $6D
	$77 $00 $00 $00 $00 $00 $00 $00
	$00 $3D $3E $3F $02 $02 $40 $41
	$00 $00 $00 $00 $00 $00 $3D $3E
	$3F $40 $41 $00 $00 $00 $00 $00


	$00 $00 $00 $00 $72 $6D $6D $6D
	$6D $73 $00 $00 $00 $00 $00 $00
	$00 $42 $43 $44 $02 $02 $45 $46
	$00 $00 $00 $00 $00 $00 $42 $43
	$44 $45 $46 $73 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $72 $6D $6D $42 $43 $44
	$02 $02 $02 $02 $45 $46 $00 $00
	$00 $00 $72 $73 $00 $00 $00 $00
	$00 $00 $42 $3E $40 $46 $00 $00
$00 $00 $00 $00 $72 $6D $6D $6D
	$6D $73 $00 $00 $00 $00 $00 $00
	$00 $42 $43 $44 $02 $02 $45 $46
	$00 $00 $00 $00 $00 $00 $42 $43
	$44 $45 $46 $73 $00 $00 $00 $00


	$00 $00 $00 $6F $70 $6D $6D $6D
	$6D $75 $76 $00 $00 $00 $00 $00
	$00 $3D $3E $3F $02 $02 $40 $41
	$00 $00 $00 $00 $00 $00 $3D $3E
	$3F $40 $41 $6D $76 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $6F $70 $6D $6D $3D $3E $3F
	$02 $02 $02 $02 $40 $41 $00 $00
	$00 $6F $70 $75 $76 $00 $00 $00
	$00 $6F $3D $3E $40 $46 $00 $00
$00 $00 $00 $6F $70 $6D $6D $6D
	$6D $75 $76 $00 $00 $00 $00 $00
	$00 $3D $3E $3F $02 $02 $40 $41
	$00 $00 $00 $00 $00 $00 $3D $3E
	$3F $40 $41 $6D $76 $00 $00 $00


	$00 $00 $00 $6E $6D $6D $6D $6D
	$6D $6D $77 $00 $00 $00 $00 $00
	$00 $42 $43 $44 $02 $02 $45 $46
	$00 $00 $00 $00 $00 $00 $42 $43
	$44 $45 $46 $6D $77 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $6E $6D $6D $6D $42 $43 $44
	$02 $02 $02 $02 $45 $46 $00 $00
	$00 $6E $6D $6D $77 $00 $00 $00
	$00 $6E $42 $43 $40 $41 $00 $00
$00 $00 $00 $6E $6D $6D $6D $6D
	$6D $6D $77 $00 $00 $00 $00 $00
	$00 $42 $43 $44 $02 $02 $45 $46
	$00 $00 $00 $00 $00 $00 $42 $43
	$44 $45 $46 $6D $77 $00 $00 $00


	$00 $00 $72 $6D $6D $6D $6D $6D
	$6D $6D $6D $73 $00 $00 $00 $00
	$00 $3D $3E $3F $02 $02 $40 $41
	$73 $00 $00 $00 $00 $00 $3D $3E
	$3F $40 $41 $6D $6D $73 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$72 $6D $6D $6D $6D $3D $3E $3F
	$02 $02 $02 $02 $40 $41 $00 $00
	$72 $6D $6D $6D $75 $73 $00 $00
	$72 $6D $3D $3E $40 $46 $00 $00
$00 $00 $72 $6D $6D $6D $6D $6D
	$6D $6D $6D $73 $00 $00 $00 $00
	$00 $3D $3E $3F $02 $02 $40 $41
	$73 $00 $00 $00 $00 $00 $3D $3E
	$3F $40 $41 $6D $6D $73 $00 $00


	$00 $6F $70 $6D $6D $6D $6D $6D
	$6D $6D $6D $75 $76 $00 $00 $00
	$00 $42 $43 $44 $02 $02 $45 $46
	$6D $76 $00 $00 $00 $00 $42 $43
	$44 $45 $46 $6D $6D $6D $76 $00
	$00 $00 $00 $00 $00 $00 $00 $6F
	$70 $6D $6D $6D $6D $42 $43 $44
	$02 $02 $02 $02 $45 $46 $00 $6F
	$70 $6D $6D $6D $6D $75 $76 $6F
	$70 $6D $42 $43 $40 $41 $76 $00
$00 $6F $70 $6D $6D $6D $6D $6D
	$6D $6D $6D $75 $76 $00 $00 $00
	$00 $42 $43 $44 $02 $02 $45 $46
	$6D $76 $00 $00 $00 $00 $42 $43
	$44 $45 $46 $6D $6D $6D $76 $00


	$00 $6E $6D $6D $6D $6D $6D $6D
	$6D $6D $6D $6D $77 $00 $00 $00
	$00 $3D $3E $3F $02 $02 $40 $41
	$6D $77 $00 $00 $00 $00 $3D $3E
	$3F $40 $41 $6D $6D $6D $77 $00
	$00 $00 $00 $00 $00 $00 $00 $6E
	$6D $6D $6D $6D $6D $3D $3E $3F
	$02 $02 $02 $02 $40 $41 $00 $6E
	$6D $6D $6D $6D $6D $6D $77 $6E
	$6D $6D $3D $3E $40 $46 $77 $00
$00 $6E $6D $6D $6D $6D $6D $6D
	$6D $6D $6D $6D $77 $00 $00 $00
	$00 $3D $3E $3F $02 $02 $40 $41
	$6D $77 $00 $00 $00 $00 $3D $3E
	$3F $40 $41 $6D $6D $6D $77 $00


	$72 $6D $6D $6D $7A $7B $7C $7D
	$6D $6D $6D $6D $6D $73 $00 $00
	$72 $42 $43 $44 $02 $02 $45 $46
	$6D $6D $73 $00 $00 $00 $42 $43
	$44 $45 $46 $6D $6D $6D $6D $73
	$00 $00 $00 $00 $00 $00 $72 $6D
	$6D $6D $6D $6D $6D $42 $43 $44
	$02 $02 $02 $02 $45 $46 $72 $6D
	$6D $6D $7A $7B $7C $7D $6D $6D
	$6D $6D $42 $43 $40 $41 $6D $73
$72 $6D $6D $6D $7A $7B $7C $7D
	$6D $6D $6D $6D $6D $73 $00 $00
	$72 $42 $43 $44 $02 $02 $45 $46
	$6D $6D $73 $00 $00 $00 $42 $43
	$44 $45 $46 $6D $6D $6D $6D $73


	$70 $6D $6D $78 $79 $80 $80 $7E
	$7F $6D $6D $6D $6D $75 $76 $6F
	$6D $3D $3E $3F $02 $02 $40 $41
	$6D $6D $6D $76 $00 $00 $3D $3E
	$44 $40 $41 $6D $6D $6D $6D $6D
	$73 $00 $00 $00 $00 $6F $70 $6D
	$6D $6D $6D $6D $6D $3D $3E $3F
	$02 $02 $02 $02 $40 $41 $70 $6D
	$6D $78 $79 $80 $80 $7E $7F $6D
	$6D $6D $3D $3E $40 $46 $6D $6D
$70 $6D $6D $78 $79 $80 $80 $7E
	$7F $6D $6D $6D $6D $75 $76 $6F
	$6D $3D $3E $3F $02 $02 $40 $41
	$6D $6D $6D $76 $00 $00 $3D $3E
	$44 $40 $41 $6D $6D $6D $6D $6D


	$6D $6D $7A $7B $80 $80 $80 $80
	$7C $7D $6D $6D $6D $6D $77 $6E
	$6D $42 $43 $44 $02 $02 $45 $46
	$6D $6D $6D $77 $00 $00 $42 $43
	$44 $45 $46 $6D $6D $6D $6D $6D
	$75 $76 $00 $00 $00 $6E $6D $6D
	$6D $6D $6D $6D $6D $42 $43 $44
	$02 $02 $02 $02 $45 $46 $6D $6D
	$7A $7B $80 $80 $80 $80 $7C $7D
	$6D $6D $42 $43 $40 $41 $6D $6D
$6D $6D $7A $7B $80 $80 $80 $80
	$7C $7D $6D $6D $6D $6D $77 $6E
	$6D $42 $43 $44 $02 $02 $45 $46
	$6D $6D $6D $77 $00 $00 $42 $43
	$44 $45 $46 $6D $6D $6D $6D $6D


	$6D $78 $79 $80 $80 $80 $80 $80
	$80 $7E $7F $6D $6D $6D $6D $6D
	$6D $3D $3E $3F $02 $02 $40 $41
	$6D $6D $6D $6D $73 $00 $3D $3E
	$3F $40 $41 $7C $7D $6D $6D $6D
	$6D $77 $00 $00 $72 $6D $7A $7B
	$7C $7D $6D $6D $6D $3D $3E $3F
	$02 $02 $02 $02 $40 $41 $6D $78
	$79 $80 $80 $80 $80 $80 $80 $7E
	$7F $6D $3D $3E $40 $46 $6D $6D
$6D $78 $79 $80 $80 $80 $80 $80
	$80 $7E $7F $6D $6D $6D $6D $6D
	$6D $3D $3E $3F $02 $02 $40 $41
	$6D $6D $6D $6D $73 $00 $3D $3E
	$3F $40 $41 $7C $7D $6D $6D $6D


	$7A $7B $80 $80 $80 $80 $80 $80
	$80 $80 $7C $7D $6D $6D $6D $6D
	$6D $42 $43 $44 $02 $02 $45 $46
	$6D $6D $6D $6D $6D $76 $42 $43
	$44 $45 $46 $80 $7E $7F $6D $6D
	$6D $6D $73 $6F $70 $78 $79 $80
	$80 $7E $7F $6D $6D $42 $43 $44
	$02 $02 $02 $02 $45 $46 $7A $7B
	$80 $80 $80 $80 $80 $80 $80 $80
	$7C $7D $42 $43 $40 $41 $6D $6D
$7A $7B $80 $80 $80 $80 $80 $80
	$80 $80 $7C $7D $6D $6D $6D $6D
	$6D $42 $43 $44 $02 $02 $45 $46
	$6D $6D $6D $6D $6D $76 $42 $43
	$44 $45 $46 $80 $7E $7F $6D $6D


	$79 $80 $80 $80 $80 $80 $80 $80
	$80 $80 $80 $7E $7F $6D $6D $6D
	$6D $3D $3E $3F $02 $02 $40 $41
	$6D $6D $6D $6D $6D $77 $3D $3E
	$3F $40 $41 $80 $80 $7C $7D $6D
	$6D $6D $77 $6E $7A $7B $80 $80
	$80 $80 $7C $7D $6D $3D $3E $3F
	$02 $02 $02 $02 $40 $41 $79 $80
	$80 $80 $80 $80 $80 $80 $80 $80
	$80 $7E $3D $3E $40 $46 $7F $6D
$79 $80 $80 $80 $80 $80 $80 $80
	$80 $80 $80 $7E $7F $6D $6D $6D
	$6D $3D $3E $3F $02 $02 $40 $41
	$6D $6D $6D $6D $6D $77 $3D $3E
	$3F $40 $41 $80 $80 $7C $7D $6D


	$80 $80 $80 $80 $80 $80 $80 $80
	$80 $80 $80 $80 $7C $7D $6D $6D
	$6D $42 $43 $44 $02 $02 $45 $46
	$6D $6D $6D $6D $6D $6D $42 $43
	$44 $45 $46 $80 $80 $80 $7E $7F
	$6D $6D $6D $78 $79 $80 $80 $80
	$80 $80 $80 $7E $7F $42 $43 $44
	$02 $02 $02 $02 $45 $46 $80 $80
	$80 $80 $80 $80 $80 $80 $80 $80
	$80 $80 $42 $43 $40 $41 $7C $7D
$80 $80 $80 $80 $80 $80 $80 $80
	$80 $80 $80 $80 $7C $7D $6D $6D
	$6D $42 $43 $44 $02 $02 $45 $46
	$6D $6D $6D $6D $6D $6D $42 $43
	$44 $45 $46 $80 $80 $80 $7E $7F


	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$A0 $A1 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00

	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$A0 $A1 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00


	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$A0 $A1 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00



ENDD



DATA foxsprites
;;-------------

	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $01 $DC $00
	$03 $70 $00 $03 $60 $00 $0C $40
	$3F $F0 $20 $C2 $00 $10 $00 $00
	$90 $08 $0F $20 $30 $F0 $D0 $E1
	$C0 $38 $50 $80 $00 $5F $60 $00
	$E8 $D8 $00 $58 $0C $00 $B8 $0C
	$00 $4E $00 $00 $03 $80 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $02
	$00 $00 $04 $60 $00 $0D $C0 $00
	$0D $40 $00 $15 $80 $0F $E1 $00
	$74 $00 $00 $80 $02 $00 $01 $8C
	$00 $20 $73 $00 $78 $20 $E0 $FF
	$8C $00 $1C $70 $80 $08 $0F $20
	$02 $00 $50 $06 $00 $38 $0E $00
	$18 $1C $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $02 $00 $00 $06
	$00 $00 $0C $00 $00 $1A $00 $0F
	$39 $00 $F0 $C0 $00 $08 $02 $00
	$00 $00 $78 $01 $1F $F0 $20 $F0
	$00 $78 $4C $00 $FE $33 $00 $2F
	$8F $80 $11 $E2 $00 $0E $1D $C0
	$00 $03 $F0 $00 $00 $30 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $01 $20 $00 $01 $90 $00 $00
	$D8 $00 $00 $E4 $00 $00 $40 $00
	$1E $44 $00 $F1 $80 $78 $00 $0F
	$F0 $00 $30 $00 $41 $70 $00 $E3
	$F8 $00 $9F $C4 $00 $A0 $32 $00
	$50 $0C $80 $20 $03 $60 $18 $00
	$DC $18 $00 $0E $0E $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $02 $00 $00 $04 $C0 $00
	$0B $80 $00 $0B $00 $00 $0B $00
	$C0 $10 $80 $3F $E0 $00 $10 $01
	$00 $00 $04 $00 $00 $0B $80 $04
	$70 $78 $C7 $E0 $00 $6F $E0 $00
	$F0 $A0 $00 $58 $A0 $00 $80 $C0
	$00 $80 $60 $00 $60 $38 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $01 $DC $00
	$02 $B0 $00 $02 $A0 $00 $0F $80
	$3F $FF $E0 $FF $FF $F0 $FF $FF
	$70 $F7 $FB $E0 $EF $70 $F0 $DE
	$40 $38 $8F $80 $00 $90 $E0 $00
	$38 $38 $00 $60 $0C $00 $C8 $0C
	$00 $8E $00 $00 $03 $80 $00 $88
	$00 $00 $00 $00 $00 $00 $00 $02
	$00 $00 $06 $60 $00 $0A $C0 $00
	$0A $C0 $00 $1A $80 $0F $FF $00
	$7F $FF $80 $FF $FD $80 $FE $7F
	$C0 $DF $93 $E0 $E7 $E0 $E0 $F8
	$7C $00 $00 $0F $80 $0C $00 $E0
	$06 $00 $30 $06 $00 $38 $0E $00
	$18 $1C $00 $00 $00 $00 $00 $88
	$00 $00 $00 $00 $02 $00 $00 $06
	$00 $00 $0A $00 $00 $14 $00 $0F
	$27 $00 $FF $FF $80 $FF $FD $C0
	$FF $FF $F8 $FE $FF $F0 $DF $70
	$00 $E7 $80 $00 $F9 $CF $00 $10
	$73 $80 $0E $1E $00 $00 $03 $C0
	$00 $00 $70 $00 $00 $30 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $88
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $01 $20 $00 $01 $90 $00 $00
	$D8 $00 $00 $BE $00 $00 $7F $00
	$1E $7B $C0 $FF $FF $F8 $FF $FF
	$F0 $FF $F0 $00 $BE $E0 $00 $DD
	$88 $00 $7B $38 $00 $60 $0E $00
	$30 $03 $80 $30 $00 $E0 $18 $00
	$3C $18 $00 $0E $0E $00 $00 $88
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $02 $00 $00 $06 $C0 $00
	$0F $80 $00 $0D $00 $00 $0D $00
	$C0 $1F $80 $FF $FF $C0 $FF $FE
	$C0 $FF $FF $E0 $FF $FB $F0 $FF
	$F0 $78 $3B $C0 $00 $B7 $80 $00
	$00 $40 $00 $D8 $C0 $00 $80 $C0
	$00 $80 $60 $00 $60 $38 $00 $88
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$78 $00 $7E $7E $01 $83 $3D $0E
	$00 $0A $F0 $05 $06 $1F $08 $01
	$E1 $1F $00 $01 $10 $00 $00 $90
	$00 $00 $A0 $00 $00 $70 $00 $00
	$38 $00 $00 $0C $00 $00 $07 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $07 $00 $00
	$78 $00 $3F $81 $7F $C8 $10 $F4
	$30 $3F $7C $E0 $40 $00 $83 $80
	$01 $7F $00 $03 $8C $00 $06 $18
	$00 $0C $30 $00 $0E $1C $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $03 $00 $00 $FC
	$00 $07 $00 $1F $F8 $00 $70 $20
	$02 $F7 $E0 $7F $F8 $60 $E0 $C0
	$83 $C0 $02 $7F $00 $08 $3E $00
	$18 $E0 $00 $33 $00 $00 $E4 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $FE $00
	$1F $09 $F0 $7D $7C $0F $3F $88
	$00 $00 $08 $82 $00 $34 $F0 $01
	$C0 $7F $06 $D0 $70 $0C $48 $E0
	$00 $67 $00 $00 $60 $00 $00 $C0
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $60
	$00 $00 $F0 $00 $00 $F8 $07 $F0
	$66 $38 $2F $31 $C0 $00 $10 $30
	$22 $0F $D0 $10 $00 $14 $12 $00
	$0A $3F $00 $06 $2C $00 $02 $77
	$00 $04 $04 $00 $03 $F8 $00 $00
	$60 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$78 $00 $7E $7E $01 $FF $3F $0F
	$FF $0F $FF $FB $07 $F1 $F7 $01
	$E1 $F7 $00 $01 $F0 $00 $00 $E0
	$00 $00 $60 $00 $00 $60 $00 $00
	$30 $00 $00 $0C $00 $00 $07 $98
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $07 $00 $00
	$7F $00 $3F $FF $7F $F7 $EF $FF
	$CF $DF $78 $1F $80 $00 $FE $00
	$01 $E1 $00 $03 $0C $00 $06 $18
	$00 $0C $30 $00 $0E $1C $00 $98
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $03 $00 $00 $FF
	$00 $07 $FF $1F $FF $FF $7F $FF
	$FF $7E $1F $BF $F8 $1F $60 $C0
	$FC $00 $03 $81 $00 $0E $30 $00
	$18 $C0 $00 $33 $00 $00 $E4 $00
	$00 $00 $00 $00 $00 $00 $00 $98
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $FE $00
	$1F $FF $F0 $7F $E7 $FF $3E $07
	$FF $00 $07 $7F $00 $3B $7F $01
	$7F $8F $07 $6F $B0 $0C $67 $60
	$00 $62 $00 $00 $60 $00 $00 $C0
	$00 $00 $00 $00 $00 $00 $00 $98
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $60
	$00 $00 $F0 $00 $00 $F8 $07 $F0
	$7E $3F $FF $3F $FF $FF $0F $CF
	$DF $00 $0F $EF $00 $0B $EF $00
	$05 $DF $00 $01 $C0 $00 $01 $8F
	$00 $03 $FC $00 $00 $00 $00 $00
	$40 $00 $00 $00 $00 $00 $00 $98





ENDD


DATA dSysStart
;;------------

		   lEndOfLine
		   1995
		   $9E
		   "(2064)"
		   0
lEndOfLine:   0 0


ENDD


;---------------------------------------------;

