LAYOUT
;;----

$0801:	dsysstart
$0c00:	setup
	main
	sundercursor
	keyread

$1000:  dbackground	;stillground
$2000:	dchars
$2800:	dlittlesquareW
$2840:	dlittlesquareB
$2900: 	charcolors


ENDL

ALIASB	temp1		= $fb
ALIASB	temp2		= $fc
ALIASB	temp3		= $fd
ALIASB	temp4		= $fe

ALIASB	currentchar     = $10
ALIASB	column		= $11
ALIASB	oldkey		= $12
ALIASB	fast		= $13
ALIASB	mode		= $14
ALIASB	Xsave		= $15
ALIASB	Ysave		= $16
ALIASB	Xhisave		= $17

DATA dSysStart
;;------------

		   lEndOfLine
		   1996
		   $9E
		   "(3072)"
		   0
lEndOfLine:   0 0


ENDD


CODE setup
;;--------

start:		sei

		ldx #$f9
&		lda #$09
		sta $d800,x
		sta $d8fa,x
		sta $d9f4,x
		sta $daee,x
		lda #$00
		sta $0400,x
		sta $04fa,x
		sta $05f4,x
		sta $06ee,x
		dex
		cpx #$ff
		bne -

		ldx #$00
&		txa
		sta $0540,x
		tay
		lda charcolors,y
		sta $d940,x

		dex
		bne -

		ldx #$f9
&		lda $1000,x
		sta $0800,x
		tay
		lda charcolors,y
		sta $d800,x
		lda $10fa,x
		sta $08fa,x
		tay
		lda charcolors,y
		sta $d8fa,x
		lda $11f4,x
		sta $09f4,x
		tay
		lda charcolors,y
		sta $d9f4,x
		lda $12ee,x
		sta $0aee,x
		tay
		lda charcolors,y
		sta $daee,x
		dex
		cpx #$ff
		bne -


		lda #$00
		sta $d020
		sta $d021
		lda #$0b
		sta $d022
		lda #$0e
		sta $d023
		lda #$18
		sta $d016

		lda #$28
		sta $d018

		lda #$a0
		sta $0bf8
		sta $07f8
		lda #$a1
		sta $0bf9
		sta $07f9


		lda #$17
		sta $d000
		sta $d002
		sta Xsave
		lda #$31
		sta $d001
		sta $d003
		sta Ysave
		lda #$00
		sta Xhisave

		lda #$00
		sta $d027
		lda #$01
		sta $d028

		lda #$03
		sta $d015

		lda #$00
		sta currentchar
		sta $0be7
		sta fast
		sta mode

ENDC


CODE main
;;-------

start:
		jsr keyread
		jeq checkjoy

&		cmp #'F'
		bne +
		lda fast
		eor #$01
		sta fast

&		cmp #' '
		bne +

		lda $d000
		sta temp1
		lda $d001
		sta temp2
		lda $d010
		sta temp3
		lda Xsave
		sta $d000
		sta $d002
		lda Ysave
		sta $d001
		sta $d003
		lda Xhisave
		sta $d010
		lda temp1
		sta Xsave
		lda temp2
		sta Ysave
		lda temp3
		sta Xhisave
		lda mode
		eor #$01
		sta mode
		lda $d018
		eor #$30
		sta $d018

&
checkjoy:       lda $dc00
		and #$1f
		cmp #$1f
		jeq start
		sta temp1
UP:		lsr temp1
		bcs DOWN
		lda $d001
		sec
		sbc #$08
		sta $d001
		sta $d003
DOWN:		lsr temp1
		bcs LEFT
		lda $d001
		clc
		adc #$08
		sta $d001
		sta $d003
LEFT:		lsr temp1
		bcs RIGHT
		lda $d000
		sec
		sbc #$08
		sta $d000
		sta $d002
		bcs RIGHT
		lda $d010
		eor #$03
		sta $d010
RIGHT:          lsr temp1
		bcs BUTTON
		lda $d000
		clc
		adc #$08
		sta $d000
		sta $d002
		bcc BUTTON
		lda $d010
		eor #$03
		sta $d010

BUTTON:         lsr temp1
		bcs slowdown

		jsr sundercursor

		lda mode
		bne getchar

placechar:	lda currentchar
		sta (temp3),y
		jmp slowdown

getchar:        lda temp4
		sec
		sbc #$04
		sta temp4
		lda (temp3),y
		sta currentchar

slowdown:       lda fast
		bne phast

		ldx #$50
		ldy #$00
&		dey
		bne -
		dex
		bne -
		jmp start

phast:          ldx #$20
		ldy #$00
&		dey
		bne -
		dex
		bne -
		jmp start

ENDC


CODE Keyread
;;----------
		ldx #63

		lda #$fe
		sta Column

nextcol:	sta $DC00
		lda $DC01
		ldy #$08
nextrow:
		lsr acc
		bcs +
		lda KeyCodes,x

		cmp oldkey
		beq samekey
		sta oldkey
		jmp return

&       	dex
		beq nokey
		dey
		bne nextrow
		lda Column
		sec
		rol acc
		sta Column
		jmp nextcol

samekey:	lda #$00
		jmp return

nokey:		lda #$00
		sta oldkey

return:		ldx #$7f
		stx $dc00
		rts

DATA

keycodes:
Col7: 	' Q? 2??1'
Col6: 	'/?=??;*&'
Col5: 	',?:>-LP+'
Col4: 	'NOKM0JI9'
Col3: 	'VUHB8GY7'
Col2: 	'XTFC6DR5'
Col1: 	'?ESZ4AW3'
Col0: 	'?5317???'


ENDC



CODE sundercursor
;;---------------

start:          lda #$00
		sta marker1 + 1
		lda $d010
		lsr acc
		ror marker1 + 1
		lda $d000
		sec
		sbc #$17
		bcs +
		ldx #$00
		stx marker1 + 1
&		lsr acc
marker1:	ora #$00
		lsr acc
		lsr acc
		tay
		lda $d001
		sec
		sbc #$31
		lsr acc
		lsr acc
		lsr acc
		tax
		lda screenL,x
		sta temp3
		sta temp1
		lda screenH,x
		sta temp4
		rts

DATA

screenL:        $00 $28 $50 $78 $a0 $c8 $f0 $18 $40 $68 $90 $b8 $e0
		$08 $30 $58 $80 $a8 $d0 $f8 $20 $48 $70 $98 $c0 $e8

screenH:        $08 $08 $08 $08 $08 $08 $08 $09 $09 $09 $09 $09 $09
		$0a $0a $0a $0a $0a $0a $0a $0b $0b $0b $0b $0b $0b

ENDC



DATA dlittlesquareW
;;-----------------

		[XX..XX.. XX...... ........]
		[........ ........ ........]
		[........ ........ ........]
		[X....... .X...... ........]
		[X....... .X...... ........]
		[........ ........ ........]
		[........ ........ ........]
		[X....... .X...... ........]
		[X....... .X...... ........]
		[..XX..XX ........ ........]
		[........ ........ ........]
		[........ ........ ........]

ENDD


DATA dlittlesquareB
;;-----------------

		[..XX..XX ........ ........]
		[X....... .X...... ........]
		[X....... .X...... ........]
		[........ ........ ........]
		[........ ........ ........]
		[X....... .X...... ........]
		[X....... .X...... ........]
		[........ ........ ........]
		[........ ........ ........]
		[XX..XX.. XX...... ........]
		[........ ........ ........]
		[........ ........ ........]

ENDD


DATA charcolors
;;-------------


		$09 $09 $09 $09 $09 $09 $09 $09
		$09 $09 $09 $09 $09 $09 $09 $09
		$09 $09 $09 $09 $09 $09 $09 $09
		$09 $09 $09 $09 $09 $09 $09 $09
		$09 $09 $09

		$0b $0b $0b $0b $0b $0b $0b $0b
		$0b $0b $0b $0b $0b $0b $0b $0b
		$0b $0b $0b $0b $0b $0b $0b $0b
		$0b $0b

		$0a $0a $0a $0c $0c
		$0a $0a $0a $0c $0c

		$0d $0d $0d $0d $0d $0d $0d $0d
		$0d $0d $0d $0d $0d $0d $0d $0d
		$0d $0d $0d $0d $0d $0d $0d $0d
		$0d $0d $0d $0d

		$0a $0a $0a $0c $0c
		$0a $0a $0a $0c $0c

		$0c $0c $0c $0c $0c $0c $0c $0c
		$0c $0c $0e $0c

		$0e $0c $0e $0e $0c $0e $0c $0e




ENDD


DATA dchars
;;---------

	$AA $AA $AA $AA $AA $AA $AA $AA
	$55 $55 $55 $55 $55 $55 $55 $55
	$00 $00 $00 $00 $00 $00 $00 $00
	$AA $AA $AA $AA $A8 $A1 $85 $15
	$AA $A8 $81 $15 $55 $55 $55 $55
	$80 $15 $55 $55 $55 $55 $55 $55
	$55 $55 $55 $55 $55 $55 $50 $05
	$55 $55 $55 $50 $45 $15 $55 $55
	$54 $51 $05 $55 $55 $55 $55 $55
	$FF $5F $55 $55 $55 $55 $55 $55
	$FF $FF $FF $7F $57 $55 $55 $55
	$FF $FF $FF $FF $FF $55 $55 $55
	$AA $AA $AA $AA $AA $A8 $83 $3F
	$AA $AA $A0 $8F $3F $FF $FF $FF
	$A0 $0F $FF $FF $FF $FF $FF $FF
	$FF $FF $FF $FF $FF $FF $FF $FF
	$FF $FF $FF $FF $FF $FF $FF $55
	$0A $F2 $FC $FF $FF $FF $FF $FF
	$AA $AA $2A $CA $F2 $FC $FF $FF
	$AA $AA $AA $AA $AA $AA $0A $F0
	$FF $FF $FF $FF $FF $FD $D5 $55
	$FF $FF $FF $FF $D5 $55 $55 $55
	$FF $FD $F5 $55 $55 $55 $55 $55
	$15 $41 $54 $55 $55 $55 $55 $55
	$55 $55 $55 $05 $51 $54 $55 $55
	$55 $55 $55 $55 $55 $15 $41 $54
	$0A $50 $55 $55 $55 $55 $55 $55
	$AA $AA $0A $50 $55 $55 $55 $55
	$AA $AA $AA $AA $2A $4A $52 $54
	$00 $00 $10 $00 $00 $00 $00 $04
	$11 $04 $11 $40 $11 $04 $11 $40
	$11 $44 $11 $44 $11 $44 $11 $44
	$11 $55 $44 $55 $11 $55 $44 $55
	$55 $15 $55 $55 $51 $55 $55 $55
	$55 $55 $55 $55 $45 $55 $55 $55
	$AA $AF $BF $BF $FF $FF $FF $FF
	$AA $FA $FE $FE $FF $FF $FF $FF
	$FF $FF $FF $FF $BF $BF $AF $AA
	$FF $FF $FF $FF $FE $FE $FA $AA
	$AA $AA $AA $AB $AB $AB $AA $AA
	$BF $FF $FF $FF $FF $FF $FF $BF
	$AA $EA $EA $FA $FA $FA $EA $AA
	$AA $AA $AA $AA $BE $FF $BE $AA
	$FF $FF $FF $FF $FF $BF $BF $AF
	$AA $AA $AA $AA $AA $AA $AA $AB
	$AA $AA $AA $AA $AA $AF $FF $FF
	$AA $AA $AA $AA $FF $FF $FF $FF
	$AA $AA $AA $AA $AA $FA $FF $FF
	$AA $AA $AA $AA $AA $AA $AA $FA
	$AA $AA $AB $AF $AF $BF $BF $FF
	$BF $FF $FF $FF $FF $FF $FF $FF
	$FE $FF $FF $FF $FF $FF $FF $FF
	$AA $AA $EA $FA $FA $FE $FE $FF
	$FF $FF $FF $FF $FF $BF $BF $AF
	$FF $FF $FF $FF $FF $FF $FE $FA
	$FF $AF $AA $AA $AA $AA $AA $AA
	$FF $FF $AF $AA $AA $AA $AA $AA
	$FF $FF $FF $AA $AA $AA $AA $AA
	$FF $FF $AA $AA $AA $AA $AA $AA
	$FF $FA $AA $AA $AA $AA $AA $AA
	$FF $FF $FF $FF $FF $FF $FF $FF
	$10 $BC $2C $1F $1F $1F $BE $1F
	$7C $7C $3C $30 $30 $01 $07 $07
	$00 $00 $0C $00 $00 $00 $00 $C3
	$03 $00 $00 $C0 $00 $04 $04 $0D
	$D2 $D0 $D0 $D0 $10 $00 $00 $08
	$2F $1F $1F $8C $0C $0C $20 $81
	$07 $03 $10 $10 $70 $7C $7C $FC
	$00 $00 $00 $00 $30 $30 $30 $00
	$3D $0D $0D $0C $00 $00 $C0 $00
	$0C $3C $3C $3E $3D $0C $0C $40
	$FF $FF $FF $FF $FF $FF $FF $FF
	$3F $8F $8F $A3 $A3 $A8 $AA $AA
	$FF $FF $FF $AB $FF $FF $3F $8F
	$FF $FF $FF $FF $FF $FF $FF $AA
	$A3 $A8 $AA $AA $AA $AA $AA $AA
	$FF $FF $3F $83 $A8 $AA $AA $AA
	$FF $AA $FF $FE $3F $83 $A8 $AA
	$FF $AB $FF $AA $FF $FE $0F $A0
	$FF $FA $FF $AA $FF $AA $FF $00
	$FF $FF $FA $FF $FF $FF $FA $FF
	$FF $FF $FF $FF $FF $FF $AA $FF
	$FF $FF $FF $AA $FF $AA $FF $00
	$FF $AA $FF $AA $FF $AB $FC $00
	$FF $AA $FF $AA $FF $C0 $01 $10
	$FF $FF $FF $FF $FF $FF $EA $FF
	$FF $FF $FF $AB $FF $FF $AA $FF
	$FF $AA $FF $AA $FF $03 $00 $00
	$FF $AA $FF $AA $FF $FA $0F $00
	$FF $AA $FF $AA $FF $AA $FF $00
	$FF $FF $FF $FF $FF $FF $FE $FF
	$FF $AB $FF $AA $FF $AA $FF $00
	$FF $FF $FF $EA $FF $AF $F0 $0A
	$FF $EA $FF $AB $FF $C0 $2A $AA
	$FF $AA $FF $F0 $0A $AA $AA $AA
	$F2 $CA $2A $AA $AA $AA $AA $AA
	$FF $FF $FF $FF $FF $FF $FA $FF
	$FF $FF $FA $FF $FF $FF $AB $FC
	$FF $FC $B2 $F2 $CA $CA $2A $AA
	$00 $04 $00 $1F $00 $2F $00 $0F
	$00 $00 $00 $04 $00 $1C $00 $0F
	$00 $00 $00 $00 $00 $10 $00 $00
	$00 $34 $00 $0C $00 $00 $00 $00
	$00 $02 $00 $34 $00 $F4 $00 $F4
	$1F $00 $9B $1F $0C $00 $8C $00
	$1F $00 $0C $00 $01 $00 $07 $07
	$30 $00 $30 $00 $00 $00 $00 $00
	$04 $04 $00 $3D $3C $0C $00 $00
	$30 $30 $00 $02 $00 $10 $00 $F2
	$77 $dd $77 $dd $77 $dd $77 $dd
	$17 $1D $17 $1D $17 $1D $17 $1D
	$A1 $A1 $A1 $85 $85 $85 $87 $85
	$77 $5D $77 $DD $77 $DD $77 $DD
	$AA $AA $AA $AA $AA $AA $A8 $A8
	$A8 $A1 $85 $85 $17 $15 $57 $5D
	$2A $4A $52 $52 $54 $D4 $75 $D5
	$AA $AA $AA $AA $AA $AA $2A $2A
	$75 $DD $75 $DD $77 $DD $77 $DD
	$4A $4A $4A $52 $52 $52 $52 $52
	$54 $D4 $74 $D4 $74 $D4 $74 $D4
	$77 $DD $77 $DD $75 $DD $75 $DD
	$47 $4D $47 $4D $37 $1D $37 $1D
	$77 $DD $75 $D5 $74 $D4 $51 $51
	$55 $50 $47 $1D $77 $DD $77 $DD
	$55 $05 $71 $DC $77 $DD $77 $DD
	$77 $DD $77 $5D $17 $15 $47 $45
	$71 $D1 $71 $D1 $74 $DC $74 $DC
	$77 $DD $77 $5D $77 $5D $77 $5D
	$77 $dd $77 $dd $77 $dd $77 $dd
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00



ENDD


DATA dstillground
;;--------------

	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $2C $2D $2E
	$2E $2E $2F $30 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $31 $32 $3C $3C
	$3C $3C $3C $33 $34 $00 $23 $3C
	$24 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $2A $00
	$27 $28 $29 $00 $35 $3C $3C $3C
	$3C $3C $3C $3C $36 $00 $25 $3C
	$26 $27 $28 $29 $2A $00 $00 $00
	$30 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $37 $38 $39
	$39 $39 $3A $3B $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$33 $34 $00 $00 $23 $24 $00 $00
	$2A $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$3C $36 $00 $00 $25 $26 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$3B $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $0C $0D $0E $11 $12
	$13 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$1B $1C $00 $00 $00 $00 $00 $00
	$0C $0D $0E $0F $0F $0F $0F $0F
	$0F $11 $12 $13 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$01 $01 $1A $1B $1C $0C $0D $0E
	$0F $0F $0F $0F $0F $0F $0F $0F
	$0F $0F $0F $0F $11 $12 $13 $00
	$00 $00 $00 $00 $00 $0C $0D $0E
	$11 $12 $13 $00 $00 $00 $00 $00
	$01 $01 $06 $07 $08 $09 $0A $0B
	$10 $10 $0F $0F $0F $0F $0F $0F
	$0F $0F $10 $10 $14 $15 $16 $1A
	$1B $1C $03 $04 $05 $09 $0A $0B
	$0B $15 $16 $1A $1B $1C $03 $04
	$07 $08 $01 $01 $01 $01 $01 $01
	$01 $01 $01 $01 $01 $01 $01 $01
	$01 $01 $01 $01 $01 $01 $01 $01
	$01 $01 $17 $18 $19 $01 $01 $01
	$01 $01 $01 $06 $07 $08 $01 $01
	$01 $01 $01 $01 $01 $01 $01 $01
	$01 $01 $01 $01 $01 $01 $01 $01
	$01 $01 $01 $01 $01 $01 $01 $01
	$01 $01 $01 $01 $01 $17 $18 $19
	$06 $07 $08 $01 $01 $01 $01 $01
	$01 $01 $01 $01 $01 $01 $01 $01
	$01 $01 $01 $01 $01 $01 $01 $01
	$01 $01 $01 $01 $01 $01 $01 $01
	$01 $01 $01 $01 $01 $01 $01 $01
	$17 $18 $19 $01 $01 $01 $01 $01
	$01 $01 $01 $01 $01 $01 $01 $01
	$01 $01 $01 $01 $01 $01 $01 $01
	$01 $01 $01 $01 $01 $01 $01 $01
	$01 $01 $01 $01 $01 $01 $01 $01
	$01 $01 $01 $17 $18 $19 $01 $01
	$06 $07 $08 $17 $18 $19 $01 $01
	$01 $01 $01 $01 $01 $01 $22 $01
	$01 $01 $01 $01 $01 $01 $01 $01
	$01 $01 $01 $01 $01 $01 $01 $01
	$01 $01 $01 $01 $01 $01 $17 $18
	$01 $01 $01 $01 $01 $01 $17 $18
	$19 $01 $01 $01 $01 $01 $21 $21
	$01 $01 $01 $01 $01 $01 $01 $01
	$01 $01 $01 $01 $01 $01 $01 $01
	$01 $01 $01 $01 $01 $01 $01 $01
	$01 $01 $01 $01 $01 $01 $01 $01
	$01 $17 $18 $19 $01 $01 $01 $21
	$01 $01 $01 $01 $01 $01 $01 $01
	$01 $01 $01 $01 $01 $01 $01 $01
	$22 $22 $01 $01 $01 $01 $01 $01
	$01 $01 $01 $01 $22 $01 $01 $01
	$01 $22 $01 $01 $17 $18 $19 $21
	$01 $01 $01 $22 $01 $01 $01 $01
	$01 $01 $01 $01 $01 $01 $01 $01
	$01 $01 $21 $21 $01 $01 $01 $01
	$01 $21 $01 $01 $01 $21 $01 $01
	$01 $22 $01 $01 $01 $01 $01 $17
	$18 $19 $01 $01 $21 $01 $01 $01
	$01 $01 $01 $01 $01 $01 $01 $01
	$01 $01 $01 $01 $21 $21 $21 $01
	$21 $01 $21 $21 $21 $21 $01 $01
	$01 $01 $01 $21 $01 $01 $01 $01
	$01 $01 $17 $18 $19 $21 $01 $01
	$01 $01 $01 $21 $21 $22 $01 $01
	$01 $01 $01 $01 $01 $01 $21 $21
	$21 $21 $21 $21 $21 $21 $21 $21
	$01 $01 $01 $01 $21 $21 $01 $01
	$01 $01 $01 $01 $01 $17 $18 $19
	$01 $01 $01 $01 $01 $21 $21 $01
	$01 $01 $01 $01 $01 $21 $21 $21
	$21 $21 $21 $21 $21 $21 $21 $21
	$21 $21 $21 $21 $21 $21 $21 $21
	$21 $21 $21 $01 $01 $01 $01 $01
	$17 $18 $19 $01 $01 $01 $21 $21
	$21 $22 $21 $21 $21 $21 $21 $1D
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$A0 $A1 $00 $00 $00 $00 $00 $00


ENDD

DATA dbackground
;;--------------

	$47 $78 $08 $47 $47 $47 $47 $47
	$47 $47 $47 $47 $47 $47 $47 $47
	$47 $47 $47 $47 $47 $47 $47 $47
	$47 $47 $47 $47 $47 $47 $47 $47
	$47 $47 $47 $47 $47 $47 $47 $47

	$47 $47 $47 $47 $47 $47 $47 $47
	$47 $47 $47 $47 $47 $47 $47 $47
	$47 $47 $47 $47 $47 $47 $47 $47
	$47 $47 $47 $47 $47 $47 $47 $47
	$47 $47 $47 $47 $47 $60 $61 $62

	$56 $47 $47 $47 $47 $47 $47 $47
	$47 $47 $47 $47 $47 $47 $47 $47
	$47 $47 $47 $47 $47 $47 $47 $47
	$47 $47 $47 $47 $47 $47 $47 $47
	$47 $5A $5B $5C $5D $5E $5F $00

	$9B $08 $4A $47 $47 $47 $47 $47
	$47 $47 $47 $47 $47 $47 $47 $47
	$47 $47 $47 $47 $47 $47 $47 $47
	$47 $47 $47 $47 $47 $47 $47 $60
	$61 $62 $00 $00 $00 $00 $00 $00

	$00 $4B $4C $4D $4E $56 $47 $47
	$47 $47 $47 $47 $47 $47 $47 $47
	$47 $47 $47 $47 $47 $47 $47 $47
	$47 $47 $56 $5B $5B $5C $5D $5E
	$5F $00 $00 $00 $00 $00 $00 $00

	$00 $00 $00 $00 $00 $48 $49 $4A
	$47 $47 $47 $47 $47 $55 $56 $47
	$47 $47 $47 $55 $55 $56 $47 $47
	$60 $61 $62 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00

	$00 $00 $00 $00 $00 $00 $4B $4C
	$4D $4E $4F $5C $4E $4F $57 $58
	$52 $53 $54 $57 $58 $5B $5C $5D
	$5E $5F $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00

	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $3D $3E $3F
	$02 $02 $02 $02 $40 $41 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00

	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $42 $43 $44
	$02 $02 $02 $02 $45 $46 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00

	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $72 $3D $3E $3F
	$02 $02 $02 $02 $40 $41 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00

	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $6F $70 $42 $43 $44
	$02 $02 $02 $02 $45 $46 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00

	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $6E $6D $3D $3E $3F
	$02 $02 $02 $02 $40 $41 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00

	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $72 $6D $6D $42 $43 $44
	$02 $02 $02 $02 $45 $46 $00 $00
	$00 $00 $72 $73 $00 $00 $00 $00
	$00 $00 $72 $73 $00 $00 $00 $00

	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $6F $70 $6D $6D $3D $3E $3F
	$02 $02 $02 $02 $40 $41 $00 $00
	$00 $6F $70 $75 $76 $00 $00 $00
	$00 $6F $70 $75 $76 $00 $00 $00

	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $6E $6D $6D $6D $42 $43 $44
	$02 $02 $02 $02 $45 $46 $00 $00
	$00 $6E $6D $6D $77 $00 $00 $00
	$00 $6E $6D $6D $77 $00 $00 $00

	$00 $00 $00 $00 $00 $00 $00 $00
	$72 $6D $6D $6D $6D $3D $3E $3F
	$02 $02 $02 $02 $40 $41 $00 $00
	$72 $6D $6D $6D $75 $73 $00 $00
	$72 $6D $6D $6D $75 $73 $00 $00

	$00 $00 $00 $00 $00 $00 $00 $6F
	$70 $6D $6D $6D $6D $42 $43 $44
	$02 $02 $02 $02 $45 $46 $00 $6F
	$70 $6D $6D $6D $6D $75 $76 $6F
	$70 $6D $6D $6D $6D $75 $76 $00

	$00 $00 $00 $00 $00 $00 $00 $6E
	$6D $6D $6D $6D $6D $3D $3E $3F
	$02 $02 $02 $02 $40 $41 $00 $6E
	$6D $6D $6D $6D $6D $6D $77 $6E
	$6D $6D $6D $6D $6D $6D $77 $00

	$00 $00 $00 $00 $00 $00 $72 $6D
	$6D $6D $6D $6D $6D $42 $43 $44
	$02 $02 $02 $02 $45 $46 $72 $6D
	$6D $6D $7A $7B $7C $7D $6D $6D
	$6D $6D $6D $6D $6D $6D $6D $73


	$73 $00 $00 $00 $00 $6F $70 $6D
	$6D $6D $6D $6D $6D $3D $3E $3F
	$02 $02 $02 $02 $40 $41 $70 $6D
	$6D $78 $79 $80 $80 $7E $7F $6D
	$6D $6D $6D $6D $6D $6D $6D $6D

	$75 $76 $00 $00 $00 $6E $6D $6D
	$6D $6D $6D $6D $6D $42 $43 $44
	$02 $02 $02 $02 $45 $46 $6D $6D
	$7A $7B $80 $80 $80 $80 $7C $7D
	$6D $6D $6D $6D $6D $6D $6D $6D

	$6D $77 $00 $00 $72 $6D $7A $7B
	$7C $7D $6D $6D $6D $3D $3E $3F
	$02 $02 $02 $02 $40 $41 $6D $78
	$79 $80 $80 $80 $80 $80 $80 $7E
	$7F $6D $6D $6D $6D $6D $6D $6D

	$6D $6D $73 $6F $70 $78 $79 $80
	$80 $7E $7F $6D $6D $42 $43 $44
	$02 $02 $02 $02 $45 $46 $7A $7B
	$80 $80 $80 $80 $80 $80 $80 $80
	$7C $7D $7A $7B $7C $7D $6D $6D

	$6D $6D $77 $6E $7A $7B $80 $80
	$80 $80 $7C $7D $6D $3D $3E $3F
	$02 $02 $02 $02 $40 $41 $79 $80
	$80 $80 $80 $80 $80 $80 $80 $80
	$80 $7E $79 $80 $80 $7E $7F $6D

	$6D $6D $6D $78 $79 $80 $80 $80
	$80 $80 $80 $7E $7F $42 $43 $44
	$02 $02 $02 $02 $45 $46 $80 $80
	$80 $80 $80 $80 $80 $80 $80 $80
	$80 $80 $80 $80 $80 $80 $7C $7D

	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $6D $6D $00 $00 $00 $00 $00
	$A0 $A1 $00 $00 $00 $00 $00 $00


;-	$47 $47 $47 $47 $47 $47 $47 $47
	$47 $47 $47 $47 $47 $47 $47 $47
	$47 $47 $47 $47 $47 $47 $47 $47
	$47 $47 $47 $47 $47 $47 $47 $47
	$47 $47 $47 $47 $47 $47 $47 $47
	$48 $49 $4A $47 $47 $47 $47 $47
	$47 $47 $47 $47 $47 $47 $47 $47
	$47 $47 $47 $47 $47 $47 $47 $47
	$47 $47 $47 $47 $47 $47 $47 $47
	$47 $47 $47 $47 $47 $47 $47 $47
	$00 $4B $4C $4D $4E $4F $56 $47
	$47 $47 $47 $47 $47 $47 $47 $47
	$47 $47 $47 $47 $47 $47 $47 $47
	$47 $47 $47 $47 $47 $47 $47 $47
	$47 $47 $47 $47 $47 $47 $47 $55
	$00 $00 $00 $00 $00 $00 $48 $49
	$4A $47 $47 $47 $47 $47 $47 $47
	$47 $47 $47 $47 $47 $47 $47 $47
	$47 $47 $47 $47 $47 $47 $47 $47
	$47 $47 $47 $47 $60 $61 $61 $62
	$00 $00 $00 $00 $00 $00 $00 $4B
	$4C $4D $4E $4F $56 $47 $47 $47
	$47 $47 $47 $47 $47 $47 $47 $47
	$47 $47 $47 $47 $47 $55 $52 $53
	$54 $57 $58 $5B $5D $5E $5F $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $48 $49 $4A $47
	$47 $47 $47 $47 $55 $56 $47 $47
	$47 $47 $47 $60 $61 $62 $63 $64
	$65 $66 $67 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $4B $4C $4D
	$4E $4F $52 $53 $54 $57 $58 $59
	$5B $5C $5D $5E $5F $00 $68 $69
	$6A $6B $6C $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $63 $64 $65 $02 $02 $66 $67
	$00 $00 $00 $00 $00 $00 $3D $3E
	$3F $40 $41 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $68 $69 $6A $02 $02 $6B $6C
	$00 $00 $00 $00 $00 $00 $42 $43
	$44 $45 $46 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $72 $73
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $3D $3E $3F $02 $02 $40 $41
	$00 $00 $00 $00 $00 $00 $3D $3E
	$3F $40 $41 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $6F $70 $75
	$76 $00 $00 $00 $00 $00 $00 $00
	$00 $42 $43 $44 $02 $02 $45 $46
	$00 $00 $00 $00 $00 $00 $42 $43
	$44 $45 $46 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $6E $6D $6D
	$77 $00 $00 $00 $00 $00 $00 $00
	$00 $3D $3E $3F $02 $02 $40 $41
	$00 $00 $00 $00 $00 $00 $3D $3E
	$3F $40 $41 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $72 $6D $6D $6D
	$6D $73 $00 $00 $00 $00 $00 $00
	$00 $42 $43 $44 $02 $02 $45 $46
	$00 $00 $00 $00 $00 $00 $42 $43
	$44 $45 $46 $73 $00 $00 $00 $00
	$00 $00 $00 $6F $70 $6D $6D $6D
	$6D $75 $76 $00 $00 $00 $00 $00
	$00 $3D $3E $3F $02 $02 $40 $41
	$00 $00 $00 $00 $00 $00 $3D $3E
	$3F $40 $41 $6D $76 $00 $00 $00
	$00 $00 $00 $6E $6D $6D $6D $6D
	$6D $6D $77 $00 $00 $00 $00 $00
	$00 $42 $43 $44 $02 $02 $45 $46
	$00 $00 $00 $00 $00 $00 $42 $43
	$44 $45 $46 $6D $77 $00 $00 $00
	$00 $00 $72 $6D $6D $6D $6D $6D
	$6D $6D $6D $73 $00 $00 $00 $00
	$00 $3D $3E $3F $02 $02 $40 $41
	$73 $00 $00 $00 $00 $00 $3D $3E
	$3F $40 $41 $6D $6D $73 $00 $00
	$00 $6F $70 $6D $6D $6D $6D $6D
	$6D $6D $6D $75 $76 $00 $00 $00
	$00 $42 $43 $44 $02 $02 $45 $46
	$6D $76 $00 $00 $00 $00 $42 $43
	$44 $45 $46 $6D $6D $6D $76 $00
	$00 $6E $6D $6D $6D $6D $6D $6D
	$6D $6D $6D $6D $77 $00 $00 $00
	$00 $3D $3E $3F $02 $02 $40 $41
	$6D $77 $00 $00 $00 $00 $3D $3E
	$3F $40 $41 $6D $6D $6D $77 $00
	$72 $6D $6D $6D $7A $7B $7C $7D
	$6D $6D $6D $6D $6D $73 $00 $00
	$72 $42 $43 $44 $02 $02 $45 $46
	$6D $6D $73 $00 $00 $00 $42 $43
	$44 $45 $46 $6D $6D $6D $6D $73
	$70 $6D $6D $78 $79 $80 $80 $7E
	$7F $6D $6D $6D $6D $75 $76 $6F
	$6D $3D $3E $3F $02 $02 $40 $41
	$6D $6D $6D $76 $00 $00 $3D $3E
	$44 $40 $41 $6D $6D $6D $6D $6D
	$6D $6D $7A $7B $80 $80 $80 $80
	$7C $7D $6D $6D $6D $6D $77 $6E
	$6D $42 $43 $44 $02 $02 $45 $46
	$6D $6D $6D $77 $00 $00 $42 $43
	$44 $45 $46 $6D $6D $6D $6D $6D
	$6D $78 $79 $80 $80 $80 $80 $80
	$80 $7E $7F $6D $6D $6D $6D $6D
	$6D $3D $3E $3F $02 $02 $40 $41
	$6D $6D $6D $6D $73 $00 $3D $3E
	$3F $40 $41 $7C $7D $6D $6D $6D
	$7A $7B $80 $80 $80 $80 $80 $80
	$80 $80 $7C $7D $6D $6D $6D $6D
	$6D $42 $43 $44 $02 $02 $45 $46
	$6D $6D $6D $6D $6D $76 $42 $43
	$44 $45 $46 $80 $7E $7F $6D $6D
	$79 $80 $80 $80 $80 $80 $80 $80
	$80 $80 $80 $7E $7F $6D $6D $6D
	$6D $3D $3E $3F $02 $02 $40 $41
	$6D $6D $6D $6D $6D $77 $3D $3E
	$3F $40 $41 $80 $80 $7C $7D $6D
	$80 $80 $80 $80 $80 $80 $80 $80
	$80 $80 $80 $80 $7C $7D $6D $6D
	$6D $42 $43 $44 $02 $02 $45 $46
	$6D $6D $6D $6D $6D $6D $42 $43
	$44 $45 $46 $80 $80 $80 $7E $7F
	$00 $00 $00 $00 $00 $00 $00 $00
	$00 $00 $00 $00 $00 $00 $00 $00
-;;	$A0 $A1 $00 $00 $00 $00 $00 $00


ENDD

