#include <graphics.h>
#include <dos.h>
#include <math.h>
#include <stdlib.h>
#include <stdio.h>
#include <fstream.h>
#include <conio.h>
#include <process.h>

/************************************************************************/
enum {
  GRAPHICS_MODE,
  TEXT_MODE
} CurrentMode = TEXT_MODE;

void GraphicsMode() {
  if (CurrentMode == GRAPHICS_MODE) return;

  int gdriver = VGA, gmode=VGAMED, errorcode;

  initgraph(&gdriver, &gmode, "C:\\PROG\\BC\\BGI\\");

  errorcode = graphresult();

  if (errorcode != grOk) {
    cout << "Graphics error: " << grapherrormsg(errorcode) << '\n';
    exit(1);
  }

  CurrentMode = GRAPHICS_MODE;
}

void TextMode() {
  if (CurrentMode == TEXT_MODE) return;
  closegraph();
}

/************************************************************************/

typedef long double wcoor;

float Scale = 100;
int EyeZLoc = -10;
int SeeAhead = 20; // 60;

float ViewAngle = 1;

int WallHeight = 10;
int GridSize = 10;

int FRot  = 8;  // 0-24
int FSmlX = 1;
int FSmlY = 1;

int CommodoreW = 40;
int CommodoreH = 40;

int boxulx;
int boxuly;
int boxlrx;
int boxlry;

int C64Coors = 0;

void XYZtoXY(wcoor wx,wcoor wy,wcoor wz,int& sx,int& sy) {
// converts world (x,y,z) to screen (x,y) using FRot and FSmlX/Y
/*
  sx = wx*4 + getmaxx()/2;
  sy = wz*4 + getmaxy()/2;
*/
  wz += -EyeZLoc;

  sx = (Scale * wx / wz) + getmaxx()/2;
  sy = (Scale * -wy / wz) + getmaxy()/2;

}

void XZtoRotatedXZ(wcoor& wx,wcoor& wz) {
  long double theta = ((30 - FRot) % 24) * M_PI / 12;

  wcoor rx = wx * cosl(theta) - wz * sinl(theta);
  wcoor rz = wz * cosl(theta) + wx * sinl(theta);
  wx = rx;
  wz = rz;
}

void XYZplot(wcoor wx,wcoor wy,wcoor wz) {
  int sx;
  int sy;
  XYZtoXY(wx,wy,wz,sx,sy);
  putpixel(sx,sy,getcolor());
  moveto(sx,sy);
}

void XYZlineto(wcoor wx,wcoor wy,wcoor wz) {
  int sx;
  int sy;
  XYZtoXY(wx,wy,wz,sx,sy);
  lineto(sx,sy);
}

void XYZline(wcoor wx1,wcoor wy1,wcoor wz1,wcoor wx2,wcoor wy2,wcoor wz2) {
  XYZplot(wx1,wy1,wz1);
  XYZlineto(wx2,wy2,wz2);
}

struct TC64Face {
  int A;
  int B;
  int C;
  int W;
  int X;
  int Dir;

  int MapX;
  int MapY;
  int MapSide;

  TC64Face& operator=(TC64Face& src) {
    A = src.A;
    B = src.B;
    C = src.C;
    W = src.W;
    X = src.X;
    Dir = src.Dir;
    MapX = src.MapX;
    MapY = src.MapY;
    MapSide = src.MapSide;
    return *this;
  }
};

struct TFace {
  int flx1;
  int fly1;
  int flx2;
  int fly2;

  int cex1;
  int cey1;
  int cex2;
  int cey2;

  TFace& operator=(TFace& src) {
    flx1 = src.flx1;
    fly1 = src.fly1;
    flx2 = src.flx2;
    flx2 = src.fly2;

    cex1 = src.cex1;
    cey1 = src.cey1;
    cex2 = src.cex2;
    cex2 = src.cey2;
    return *this;
  }
};

#define MAXPOLY 200
TC64Face PolyBuf[MAXPOLY];
unsigned PolyBufSize;

void StoreFace(TFace& face,int MapX,int MapY,int MapSide) {
  if (PolyBufSize >= MAXPOLY) {
    TextMode(); cout << "PolyBufSize error"; exit(1);
  }

  // Put it back into C64 MapSides
  if ((MapSide == 0) || (MapSide == 2)) MapSide = 2-MapSide;

  int col1 = face.fly1 - face.cey1 + 1;
  int col2 = face.fly2 - face.cey2 + 1;

  float A;
  float B;
  float C;
  float W;
  float X;

  W = abs(face.flx2 - face.flx1);

  if (col2 > col1) {
    A = col2/2;
    X = face.flx2;

    B = col1/2;
    C = A - B;

    if (face.flx2 > face.flx1)  // a is to right of b
      PolyBuf[PolyBufSize].Dir = 0;
    else PolyBuf[PolyBufSize].Dir = 1;
  } else {
    A = col1/2;
    X = face.flx1;

    B = col2/2;
    C = A - B;

    if (face.flx1 > face.flx2)  // a is to right of b
      PolyBuf[PolyBufSize].Dir = 0;
    else PolyBuf[PolyBufSize].Dir = 1;
  }

  // scale them
  PolyBuf[PolyBufSize].A = A * 40.0 / (CommodoreH*2.0);
  PolyBuf[PolyBufSize].B = B * 40.0 / (CommodoreH*2.0);
  PolyBuf[PolyBufSize].C = C * 40.0 / (CommodoreH*2.0);
  PolyBuf[PolyBufSize].X = (X-boxulx) * 40.0 / (CommodoreW*2.0);

  int x1 = (face.flx1 * 40.0 / (CommodoreW*2.0));
  int x2 = (face.flx2 * 40.0 / (CommodoreW*2.0));
  PolyBuf[PolyBufSize].W = abs(x1-x2);

  PolyBuf[PolyBufSize].MapX = MapX;
  PolyBuf[PolyBufSize].MapY = MapY;
  PolyBuf[PolyBufSize].MapSide = MapSide;
/*
  if (PolyBuf[PolyBufSize].Dir == 0) {
    PolyBuf[PolyBufSize].X--;
    PolyBuf[PolyBufSize].W--;
  } else {
    PolyBuf[PolyBufSize].W--;
  }
  if (PolyBuf[PolyBufSize].W < 0) PolyBuf[PolyBufSize].W = 0;
*/
  PolyBufSize++;
}

void DrawFace(TFace& face) {
  if (!C64Coors) {
    moveto(face.flx1,face.fly1);
    lineto(face.flx2,face.fly2);
    lineto(face.cex2,face.cey2);
    lineto(face.cex1,face.cey1);
    lineto(face.flx1,face.fly1);
  } else {
    PolyBufSize = 0;
    StoreFace(face,0,0,0);

    PolyBufSize = 0;
    PolyBuf[PolyBufSize].A *= 2;
    PolyBuf[PolyBufSize].B *= 2;
    PolyBuf[PolyBufSize].C *= 2;
    PolyBuf[PolyBufSize].X *= 3;
    PolyBuf[PolyBufSize].W *= 3;

    if (PolyBuf[PolyBufSize].Dir != 0) {
      moveto(PolyBuf[PolyBufSize].X+80,getmaxy()/2 - PolyBuf[PolyBufSize].A);
      lineto(PolyBuf[PolyBufSize].X+80,getmaxy()/2 + PolyBuf[PolyBufSize].A);
      lineto(PolyBuf[PolyBufSize].X+80 + PolyBuf[PolyBufSize].W,
	getmaxy()/2 + PolyBuf[PolyBufSize].B);
      lineto(PolyBuf[PolyBufSize].X+80 + PolyBuf[PolyBufSize].W,
	getmaxy()/2 - PolyBuf[PolyBufSize].B);
      lineto(PolyBuf[PolyBufSize].X+80,getmaxy()/2 - PolyBuf[PolyBufSize].A);
    } else {
      moveto(PolyBuf[PolyBufSize].X+80,getmaxy()/2 - PolyBuf[PolyBufSize].A);
      lineto(PolyBuf[PolyBufSize].X+80,getmaxy()/2 + PolyBuf[PolyBufSize].A);
      lineto(PolyBuf[PolyBufSize].X+80 - PolyBuf[PolyBufSize].W,
	getmaxy()/2 + PolyBuf[PolyBufSize].B);
      lineto(PolyBuf[PolyBufSize].X+80 - PolyBuf[PolyBufSize].W,
	getmaxy()/2 - PolyBuf[PolyBufSize].B);
      lineto(PolyBuf[PolyBufSize].X+80,getmaxy()/2 - PolyBuf[PolyBufSize].A);
    }
  }
}


int CoorVisible(wcoor wx,wcoor wz) {
  XZtoRotatedXZ(wx,wz);

  return ( (sqrt(wx*wx + wz*wz) < SeeAhead)
    && (wz >= ViewAngle * wx) && (wz >= -ViewAngle * wx));
}

void RotateXYZtoXY(wcoor wx,wcoor wy,wcoor wz,int& sx,int& sy) {
  XZtoRotatedXZ(wx,wz);
  XYZtoXY(wx,wy,wz,sx,sy);
}

void PlotCube(int mapx=0,int mapy=0,int calcing=0) {
  wcoor cubex = GridSize * ((-1.0/6) - (FSmlX/3.0) + mapx);
  wcoor cubez = GridSize * ((-1.0/6) - (FSmlY/3.0) + mapy);
  wcoor cubey = -WallHeight/2;

  wcoor cubex2 = GridSize + cubex;
  wcoor cubey2 = WallHeight/2;
  wcoor cubez2 = GridSize + cubez;

  TFace sides[4]; // 0=front, 1=right, 2=back, 3=left
  TFace& front = sides[0];
  TFace& right = sides[1];
  TFace& back  = sides[2];
  TFace& left  = sides[3];

  int visible[4] = { 0,0,0,0 };
  int anyvisible = 0;

  // front
  if (CoorVisible(cubex,cubez) || CoorVisible(cubex2,cubez))
    anyvisible = visible[0] = 1;

  // right
  if (CoorVisible(cubex2,cubez) || CoorVisible(cubex2,cubez2))
    anyvisible = visible[1] = 1;

  // back
  if (CoorVisible(cubex,cubez2) || CoorVisible(cubex2,cubez2))
    anyvisible = visible[2] = 1;

  // left
  if (CoorVisible(cubex,cubez) || CoorVisible(cubex,cubez2))
    anyvisible = visible[3] = 1;

  if (!anyvisible) return;  // nothin'

  // back
  RotateXYZtoXY(cubex, cubey, cubez2,back.flx2,back.fly2);
  RotateXYZtoXY(cubex, cubey2,cubez2,back.cex2,back.cey2);
  RotateXYZtoXY(cubex2,cubey, cubez2,back.flx1,back.fly1);
  RotateXYZtoXY(cubex2,cubey2,cubez2,back.cex1,back.cey1);

  // right
  RotateXYZtoXY(cubex2,cubey, cubez, right.flx1,right.fly1);
  RotateXYZtoXY(cubex2,cubey2,cubez, right.cex1,right.cey1);
  RotateXYZtoXY(cubex2,cubey, cubez2,right.flx2,right.fly2);
  RotateXYZtoXY(cubex2,cubey2,cubez2,right.cex2,right.cey2);

  // front
  RotateXYZtoXY(cubex2,cubey2,cubez, front.cex2,front.cey2);
  RotateXYZtoXY(cubex2,cubey, cubez, front.flx2,front.fly2);
  RotateXYZtoXY(cubex, cubey, cubez, front.flx1,front.fly1);
  RotateXYZtoXY(cubex, cubey2,cubez, front.cex1,front.cey1);

  // left
  RotateXYZtoXY(cubex, cubey, cubez2,left.flx1,left.fly1);
  RotateXYZtoXY(cubex, cubey2,cubez2,left.cex1,left.cey1);
  RotateXYZtoXY(cubex, cubey, cubez, left.flx2,left.fly2);
  RotateXYZtoXY(cubex, cubey2,cubez, left.cex2,left.cey2);

  // now, find two frontmost points:
  int front1 = 0;
  for (int i=1;i<4;i++) if (sides[i].fly1 > sides[front1].fly1) front1 = i;
  int front2 = (front1 == 0) ? 1 : 0;
  for (i=1;i<4;i++)
    if ((sides[i].fly1 > sides[front2].fly1) && (i != front1)) front2 = i;

  if (front1 > front2) { int temp=front1; front1 = front2; front2 = temp; }
  if ((front1 == 0) && (front2 == 3))
    { int temp=front1; front1 = front2; front2 = temp; }

  int minus1 = (front1 + 3) & 3;
  int plus1 = (front1 + 1) & 3;

  if (calcing) {
    if (visible[front1])
      StoreFace(sides[front1],mapx,mapy,front1);
    if (visible[minus1])
      if (sides[minus1].flx1 < sides[front1].flx1)
	StoreFace(sides[minus1],mapx,mapy,minus1);

    if (visible[plus1])
      if (sides[front1].flx2 < sides[plus1].flx2)
	StoreFace(sides[plus1],mapx,mapy,plus1);
  } else {
    if (visible[front1]) DrawFace(sides[front1]);

    if (visible[minus1])
      if (sides[minus1].flx1 < sides[front1].flx1) DrawFace(sides[minus1]);

    if (visible[plus1])
      if (sides[front1].flx2 < sides[plus1].flx2) DrawFace(sides[plus1]);
  }
}

void ShowView() {
  // draw wedge
  setcolor(2);

  wcoor y= -WallHeight/2;
  XYZline(0,y,0, 100/ViewAngle,y,100);
  XYZline(0,y,0, -100/ViewAngle,y,100);

  setcolor(15);

  int Radius = (SeeAhead / GridSize)+1;
  for (int mapx = -Radius; mapx <= Radius; mapx++)
  for (int mapy = -Radius; mapy <= Radius; mapy++)
    PlotCube(mapx,mapy);

//  PlotCube(0,0);
}

void DrawPoly(TC64Face& poly) {
  if (poly.Dir == 0) {
    moveto(poly.X,getmaxy()/2-poly.A);
    lineto(poly.X,getmaxy()/2+poly.A);
    lineto(poly.X-poly.W,getmaxy()/2+poly.B);
    lineto(poly.X-poly.W,getmaxy()/2-poly.B);
    lineto(poly.X,getmaxy()/2-poly.A);
  } else {
    moveto(poly.X,getmaxy()/2-poly.A);
    lineto(poly.X,getmaxy()/2+poly.A);
    lineto(poly.X+poly.W,getmaxy()/2+poly.B);
    lineto(poly.X+poly.W,getmaxy()/2-poly.B);
    lineto(poly.X,getmaxy()/2-poly.A);
  }
}

void WriteView(ostream& os,int lbl) {
  printf("\nWriting view %d... ",lbl);
  PolyBufSize = 0;

  int Radius = (SeeAhead / GridSize)+1;
  for (int mapx = -Radius; mapx <= Radius; mapx++)
  for (int mapy = -Radius; mapy <= Radius; mapy++)
    PlotCube(mapx,mapy,1);

  if (PolyBufSize > 256/3) {
    printf("Overflow! (%d bytes)",PolyBufSize * 3);
    sound(440);
    delay(1000);
    nosound();
    return;
  }

  for (int i=0;i<PolyBufSize;i++)
  for (int j=i+1;j<PolyBufSize;j++) {
    wcoor IAve = (PolyBuf[i].B + PolyBuf[i].A)/2.0;
    wcoor JAve = (PolyBuf[j].B + PolyBuf[j].A)/2.0;

    if (abs(IAve - JAve) < .1) {  // i.e. IAve == JAve
      if (PolyBuf[i].Dir == 0) IAve = PolyBuf[i].X - PolyBuf[i].W;
      else IAve = PolyBuf[i].X;
      if (PolyBuf[j].Dir == 0) JAve = PolyBuf[j].X - PolyBuf[j].W;
      else JAve = PolyBuf[j].X;
    }

    TC64Face temp;

    if (IAve < JAve) {  // swap them:
      temp = PolyBuf[i];
      PolyBuf[i] = PolyBuf[j];
      PolyBuf[j] = temp;
    }
  }


/*
    { ************** First Half *************** }

    WriteLn(File9,'');
    WriteLn(File9, 'View',Lbl,'A:');

    WriteLn(File9,'; (SX,SY,R) = (',FSmlXPos,',',FSmlYPos,',',FDirection,')');
    WriteLn(File9, ';-MapX MapY  C*  (*=Dir)---------;');

    FOR I := 0 TO NumPolys - 1 DO BEGIN
      IF (PolyList[I].W > 0) THEN BEGIN  { only write polygons with W>0}
	Write(File9,'   ',PolyList[I].MapX AND 255:3,'  ');
	Write(File9,(PolyList[I].MapY AND 255):3,' ');
	WriteLn(File9,( ((PolyList[I].C AND 63) * 4)
	  OR (PolyList[I].Dir AND 3) ):3,' ');
      END;
    END;

    WriteLn(File9,'    $80 ; END');

*/

  // ************** First Half ***************
  os << "\nView" << lbl << "A:\n";
  os << "; (SX,SY,R) = (" << FSmlX << "," << FSmlY << "," << FRot << ")\n";
  os << ";-MapX MapY  C*  (*=Dir)---------;\n";

  for (i=0; i<PolyBufSize; i++) {
    int writeit = 1;

    if (PolyBuf[i].A > 40) writeit = 0;
    if (PolyBuf[i].Dir == 0) {
      if ((PolyBuf[i].X - PolyBuf[i].W > 39) || (PolyBuf[i].X < 0)) writeit = 0;
    } else {
      if ((PolyBuf[i].X + PolyBuf[i].W < 0) || (PolyBuf[i].X > 39)) writeit = 0;
    }
    if (PolyBuf[i].W == 0) writeit = 0;

    if (writeit) {
      os << "   " << (PolyBuf[i].MapX & 255) << "  ";
      os << (PolyBuf[i].MapY & 255) << " ";
      os << ( ((PolyBuf[i].C & 63) * 4) | (PolyBuf[i].Dir & 1) ) << "\n";
    }
  }

  os << "   $80 ; END\n";

  // ************** Second Half ***************

  os << "\nView" << lbl << "B:";
  os << "\n; (SX,SY,R) = (" << FSmlX << ',' << FSmlY << ',' << FRot << ")\n";
  os << ";-   W ULX A*  (*=MapSide)---------;\n";

  for (i=0; i<PolyBufSize; i++) {
    int writeit = 1;

    if (PolyBuf[i].A > 40) writeit = 0;
    if (PolyBuf[i].Dir == 0) {
      if ((PolyBuf[i].X - PolyBuf[i].W > 39) || (PolyBuf[i].X < 0)) writeit = 0;
    } else {
      if ((PolyBuf[i].X + PolyBuf[i].W < 0) || (PolyBuf[i].X > 39)) writeit = 0;
    }
    if (PolyBuf[i].W == 0) writeit = 0;

    if (writeit) {
      os << "   " << PolyBuf[i].W << " ";
      os << (PolyBuf[i].X & 255) << "  ";
      os << ( ((PolyBuf[i].A & 63) * 4)
	  | (PolyBuf[i].MapSide & 3) ) << "\n";

/*

    { ************** Second Half *************** }

    WriteLn(File9,'');

    WriteLn(File9, 'View',Lbl,'B:');

    WriteLn(File9,'; (SX,SY,R) = (',FSmlXPos,',',FSmlYPos,',',FDirection,')');
    WriteLn(File9, ';-   W ULX A*  (*=MapSide)---------;');

    FOR I := 0 TO NumPolys - 1 DO BEGIN
      IF (PolyList[I].W > 0) THEN BEGIN  { only write polygons with W>0}
	Write(File9,'   ',PolyList[I].W:3,' ');
	Write(File9,(PolyList[I].ULX AND 255):3,'  ');
	WriteLn(File9,( ((PolyList[I].A AND 63) * 4)
	  OR (PolyList[I].MapSide AND 3) ):3,' ');
      END;
    END;
*/

    }
  }

  printf(" (%d bytes)",PolyBufSize * 3);
}

void DumpAll() {
  int Lbl = 0;

  clearviewport();

  ofstream os("table.dat");

  FSmlX = 1;  FSmlY = 1;
  for (FRot = 3; FRot <= 6; FRot++) { WriteView(os,Lbl); Lbl++; }

  FSmlX = 1;  FSmlY = 2;
  for (FRot = 18; FRot <= 23; FRot++) { WriteView(os,Lbl); Lbl++; }
  for (FRot = 0; FRot <= 6; FRot++) { WriteView(os,Lbl); Lbl++; }

  FSmlX = 2;  FSmlY = 2;
  for (FRot = 3; FRot <= 15; FRot++) { WriteView(os,Lbl); Lbl++; }
}


void main() {
  GraphicsMode();
  atexit(TextMode);

  do {
    clearviewport();
    ShowView();

    gotoxy(1,1);
    printf("(S[X],S[Y],[R]) = (%d,%d,%d) ",FSmlX,FSmlY,FRot);
    printf("[S]cale: %f  [V]iewAngle: %f\n",Scale,ViewAngle);
    printf("WallHeight: %d  GridSize: %d  EyeZLoc: %d\n",WallHeight,
      GridSize,EyeZLoc);
    printf("See[A]head: %d CommodoreBox[W]/[H]:(%d,%d)",SeeAhead,
      CommodoreW*2,CommodoreH*2);

  box:
    setcolor(0);
    moveto(boxulx,boxuly);
    lineto(boxulx,boxlry);
    lineto(boxlrx,boxlry);
    lineto(boxlrx,boxuly);
    lineto(boxulx,boxuly);

    boxulx = getmaxx()/2 - CommodoreW;
    boxlrx = getmaxx()/2 + CommodoreW;
    boxuly = getmaxy()/2 - CommodoreH;
    boxlry = getmaxy()/2 + CommodoreH;

    setcolor(12);
    moveto(boxulx,boxuly);
    lineto(boxulx,boxlry);
    lineto(boxlrx,boxlry);
    lineto(boxlrx,boxuly);
    lineto(boxulx,boxuly);
    int userkey = getch();

    switch (userkey) {
      case 's': Scale += 30; break;
      case 'S': Scale -= 30; break;

      case 'v': ViewAngle *= 1.3; break;
      case 'V': ViewAngle /= 1.3; break;

      case 'a': SeeAhead += 5; break;
      case 'A': SeeAhead -= 5; break;

      case 'z': EyeZLoc += 5; break;
      case 'Z': EyeZLoc -= 5; break;

      case 'r': FRot++;  break;
      case 'R': FRot--;  break;

      case 'x': FSmlX++; break;
      case 'X': FSmlX--; break;

      case 'y': FSmlY++; break;
      case 'Y': FSmlY--; break;
      case 27: return;

      case 'w': CommodoreW++; goto box;
      case 'W': CommodoreW--; goto box;

      case 'h': CommodoreH++; goto box;
      case 'H': CommodoreH--; goto box;

      case ' ': WriteView(ofstream("table.dat"),0); break;

      case '6': C64Coors = !C64Coors; break;

      case '*': DumpAll();
    }
  } while(1);
}
