#include "v64.h"
#include "video.h"
#include "structs.h"
#include "diskdump.h"

#include <graphics.h>
#include <dos.h>
#include <math.h>
#include <stdlib.h>
#include <stdio.h>
#include <fstream.h>
#include <conio.h>
#include <process.h>

/*
//#define MAX(X,Y) ( ((X)>(Y)) ? (X) : (Y))
#define MAX(X,Y) ( ((float) (X) + (float) (Y)) / 2.0 )
#define MIN(X,Y) ( ((X)<(Y)) ? (X) : (Y))
*/

/*
  This renders a view in IBM coordinates, based on the global (SX,SY,R)
  and the global perspective/scaling coordinates.
*

void ShowIBMView() {
  // draw wedge:
  setcolor(2);

  wcoor y= -WallHeight/2;
  XYZline(0,y,0, 100/ViewAngle,y,100);
  XYZline(0,y,0, -100/ViewAngle,y,100);

  setcolor(15);

  // now plot all the cubes:

  int Radius = (SeeAhead / GridSize)+1;
  for (int mapx = -Radius; mapx <= Radius; mapx++)
  for (int mapy = -Radius; mapy <= Radius; mapy++)
    CalcCube(mapx,mapy);

  // draw the commodore scaling box:
  //GridScalingW = 110/2;
  //GridScalingH = 72/2;
}
*/

int xchanges[] = {
     1, 1, 1, 1,
     1, 0, 0, 0,
    -1,-1,-1,-1,
    -1,-1,-1,-1,
    -1, 0, 0, 0,
     1, 1, 1, 1
};

int ychanges[] = {
     0, 0, 1, 1,
     1, 1, 1, 1,
     1, 1, 1, 0,
     0, 0,-1,-1,
    -1,-1,-1,-1,
    -1,-1,-1, 0
};

void NormalizePosition() {
  switch (FSmlY) {
    case -1: FSmlY = 2; mapy--; break;
    case  3: FSmlY = 0; mapy++; break;
  }
  switch (FSmlX) {
    case -1: FSmlX = 2; mapx--; break;
    case  3: FSmlX = 0; mapx++; break;
  }
}

void MainLoop() {
/*
  This allows you to view different (SX,SY,R) scenes in IBM coordinates,
  so that you can adjust the perspective and scaling.  The cubes are
  rendered in realtime, so there's a separate routine to draw them in
  IBM coordinates and to store them into a commodore buffer.
*/

  int ClearEachTime = 0;
  char ViewSaveFilename[] = "viewX.sav";

//  int Temp = 1;

  do {
    if (ClearEachTime) clearviewport();
/*
Temp = !Temp;
if (Temp) {
  ViewAttr = 0;
  FSmlX = 0;
  FSmlY = 2;
  FRot = 6;
} else {
  ViewAttr = 5;
  FSmlX = 2;
  FSmlY = 2;
  FRot = 6;
}
*/
    // Draw banner:

    gotoxy(1,1);
    printf("(S[X],S[Y],[R]) = (%d,%d,%d) ",FSmlX-1,FSmlY-1,FRot);
    printf("[S]cale: %.4f  [V]iewAngle: %.4f\n",(float)Scale,(float)ViewAngle);
    printf("WallHeight: %d  GridSize: %d  Eye[Z]Loc: %d  ",WallHeight,
      GridSize,EyeZLoc);
    if (rounding) printf(" PolyRou[n]ding: ON \n");
    else printf(" PolyRou[n]ding: OFF\n");

    printf("See[A]head: %d   Stretch Grid [W]/[H]:(%d,%d)  W[e]eding: ",
      SeeAhead,GridScalingW,GridScalingH);
    if (weeding) printf("YES\n"); else printf("NO \n");
    printf("[ijkl]MapX,Y=(%d,%d)  Poly[C]lipping: ",mapx,mapy);
    if (clipping) printf("ON "); else printf("OFF");
    printf("\n1-5=Load SHIFT+#=Save  \\=Dump   Wire[f]rame: ");
    if (WireFrame) printf("ON "); else printf("OFF");

    ShowC64View();

    while (kbhit()) getch();  // clear buffer
    int userkey = getch();

    switch (userkey) {
      // whether to stop drawing a poly when you hit an already drawn one
      case 'c': clipping = !clipping; break;
      // whether to round the y=A*B/C equation when drawing (not
      // texturing) polygon
      case 'n': rounding = !rounding; break;
      // whether to weed out polygons that are off the screen
      case 'e': weeding = !weeding; break;

      // roughy, lets you zoom in/out
      case 's': Scale += 30; break;
      case 'S': Scale -= 30; break;

      // angle of FOV (used to eliminate (presumably) invisible polygons)
      case 'v': ViewAngle *= 1.3; break;
      case 'V': ViewAngle /= 1.3; break;

      // radius of FOV
      case 'a': SeeAhead += 1; break;
      case 'A': SeeAhead -= 1; break;

      // roughly, adjusts perspective
      case 'z': EyeZLoc += 1; break;
      case 'Z': EyeZLoc -= 1; break;

      // which way he's facing (head swivels on neck)
      case 'r': FRot++;  FRot = ((FRot+24) % 24); break;
      case 'R': FRot--;  FRot = ((FRot+24) % 24); break;

      case 'x': FSmlX++; FSmlX = ((FSmlX+3) % 3); break;
      case 'X': FSmlX--; FSmlX = ((FSmlX+3) % 3); break;

      case 'y': FSmlY++; FSmlY = ((FSmlY+3) % 3); break;
      case 'Y': FSmlY--; FSmlY = ((FSmlY+3) % 3); break;
      case 27: return;  // [ESC] quits program
      case 13: clearviewport(); break;

      // yet another way to scale the view
      case 'w': GridScalingW++; break;
      case 'W': GridScalingW--; break;

      case 'h': GridScalingH++; break;
      case 'H': GridScalingH--; break;

      // enter "one-at-a-time" drawing mode
      case 'p': PauseAfterEach = !PauseAfterEach; break;

      // create TABLE.DAT
      case '~': DumpAll(); break;
      case ' ': ClearEachTime = !ClearEachTime; break;  // for slow systems

      // case ' ': PlotCube(mapx,mapy); goto skip;
      case 'I': //mapy++; break;
	FSmlY++; FSmlY = ((FSmlY+3) % 3);
	if (FSmlY == 0) mapy++; break;
      case 'J': //mapx--; break;
	FSmlX--; FSmlX = ((FSmlX+3) % 3);
	if (FSmlX == 2) mapx--; break;
      case 'K': //mapy--; break;
	FSmlY--; FSmlY = ((FSmlY+3) % 3);
	if (FSmlY == 2) mapy--; break;
      case 'L': //mapx++; break;
	FSmlX++; FSmlX = ((FSmlX+3) % 3);
	if (FSmlX == 0) mapx++; break;
      case 'i':
	FSmlX += xchanges[FRot];
	FSmlY += ychanges[FRot];
	NormalizePosition();
        break;
      case 'k':
	FSmlX -= xchanges[FRot];
	FSmlY -= ychanges[FRot];
	NormalizePosition();
	break;
      case 'l':
	FSmlY += xchanges[FRot];
	FSmlX += ychanges[FRot];
	NormalizePosition();
	break;
      case 'j':
	FSmlY -= xchanges[FRot];
	FSmlX -= ychanges[FRot];
	NormalizePosition();
	break;

      // save current (SX,SY,BX,BY,Rot)
      case '@':
	userkey = '"';  // to fit with ASCII
      case '!':
      case '#':
      case '$':
      case '%': {
	ViewSaveFilename[4] = userkey - '!' + '1';
	ofstream os(ViewSaveFilename);
	os << FRot << " " << FSmlX << " " << FSmlY << " " << mapx
	   << " " << mapy << "\n";
	break;
      }

      // load one
      case '1':
      case '2':
      case '3':
      case '4':
      case '5': {
	ViewSaveFilename[4] = userkey;
	ifstream is(ViewSaveFilename);
	is >> FRot >> FSmlX >> FSmlY >> mapx >> mapy;
	break;
      }

      // toggle IBM-resolution wireframing
      case 'f': WireFrame = !WireFrame; break;
    }
  } while(1);
}


void TestWithJoy() {
  TC64Poly Poly;

  Poly.A = 10;
  Poly.C = 5;
  Poly.W = 10;
  Poly.X = 10;
  Poly.Dir = 0;

  while(1) {
    C64ClearScr();
    gotoxy(1,1);
    printf("A=%d C=%d W=%d X=%d Dir=%d   \n",
      Poly.A,Poly.C,Poly.W,Poly.X,Poly.Dir);
    //printf("LVC=%d  \n",LargestVisibleColumn(Poly));


    DrawItNormal(Poly,4);
    DrawCorners(Poly,15);

    int userkey = getch();

    switch (userkey) {
      case 'a': Poly.A++; break;
      case 'A': Poly.A--; break;
      case 'c': Poly.C++; break;
      case 'C': Poly.C--; break;
      case 'w': Poly.W++; break;
      case 'W': Poly.W--; break;
      case 'x': Poly.X++; break;
      case 'X': Poly.X--; break;
      case 'd': Poly.Dir = !Poly.Dir; break;
      case 27: exit(0);
    }
  }
}

void main() {
  GraphicsMode();
  atexit(TextMode);
  clearviewport();

  MainLoop();
  //TestWithJoy();
}




