#include "structs.h"
#include "video.h"
#include "diskdump.h"
#include "v64.h"

#include <fstream.h>
#include <stdio.h>
#include <dos.h>
#include <process.h>
#include <conio.h>
/*
#define V64_ULX 180
#define V64_ULY 89
#define V64_PW 7		// pixel width
#define V64_PH 9		// pixel height
#define V64_W 40		// i.e. 0..39
#define V64_H 25
#define V64_MIDDLE 12

void ShowC64View() {
  CreateFaceBuf();

  C64ClearScr();

  int contpausing = 1;

  for (int i=0;i<FaceBufSize;i++) {
    if (PolyBuf[i].A != 63) {
      int color = GetMap(PolyBuf[i].MapX+mapx,PolyBuf[i].MapY+mapy);
      if (color) {
	DrawItNormal(PolyBuf[i],color);
	if (PauseAfterEach && contpausing) {
	  switch (getch()) {
	    case 27: exit(0);
	    case 'p': PauseAfterEach = 0;
	    case ' ': contpausing = 0; break;
	  }
	}
      }
    }
  }
}
*/


unsigned WriteView(ostream& os,int lbl) {
  printf("\nWriting view %d... ",lbl);

  CreateFaceBuf();

  // ************** First Half ***************
  os << "\nView" << lbl << "A:\n";
  os << "; (SX,SY,R) = (" << FSmlX << "," << FSmlY << "," << FRot << ")\n";
  os << ";-MapX MapY-------------------;\n";

  int numwritten = 0;
  int i;

  for (i=0; i<PolyBufSize; i++) {
    if (PolyBuf[i].A != 63) {
      os << "   " << (PolyBuf[i].MapX & 255) << "  ";
      os << (PolyBuf[i].MapY & 255) << "\n";
      numwritten++;
    }
  }

  if ((numwritten+1) >= 256/2) {
    printf("Overflow! (%d bytes)",numwritten * 6);
    sound(440);
    delay(1000);
    nosound();
    return 0;
  }

  os << "   $80 ; END\n";

  // ************** Second Half ***************

  os << "\nView" << lbl << "B:";
  os << "\n; (SX,SY,R) = (" << FSmlX << ',' << FSmlY << ',' << FRot << ")\n";
  os << ";-   W ULX ----------------;\n";

  for (i=0; i<PolyBufSize; i++) {
    if (PolyBuf[i].A != 63) {
      os << "   " << (PolyBuf[i].W & 127) << " ";
      os << (PolyBuf[i].X & 255) << '\n';
    }
  }

  // ************** Third Half ***************

  os << "\nView" << lbl << "C:";
  os << "\n; (SX,SY,R) = (" << FSmlX << ',' << FSmlY << ',' << FRot << ")\n";
  os << ";-   C*  A*  (*=MapSide) (*=Dir)------;\n";

  for (i=0; i<PolyBufSize; i++) {
    if (PolyBuf[i].A != 63) {
      os << "   "
	<< ( ((PolyBuf[i].C & 127) * 2) | (PolyBuf[i].Dir & 1) ) << " ";
      os << ( ((PolyBuf[i].A & 63) * 4)
	  | (PolyBuf[i].MapSide & 3) ) << "\n";
    }
  }

  printf(" (%d bytes)",numwritten * 6);

  return numwritten * 6;
}

void DumpAll() {
  int Lbl = 0;

  unsigned long tablesize = 0;

  clearviewport();

  ofstream os("table.dat");

  FSmlX = 1;  FSmlY = 1;
  for (FRot = 3; FRot <= 6; FRot++) tablesize += WriteView(os,Lbl++);

  FSmlX = 1;  FSmlY = 2;
  for (FRot = 18; FRot <= 23; FRot++) tablesize += WriteView(os,Lbl++);
  for (FRot = 0; FRot <= 6; FRot++) tablesize += WriteView(os,Lbl++);

  FSmlX = 2;  FSmlY = 2;
  for (FRot = 3; FRot <= 15; FRot++) tablesize += WriteView(os,Lbl++);

  printf("\nTotal table size = %x\n\nPress a key...\n\n",tablesize);

  getch();

  clearviewport();
}

