#include "video.h"
#include "v64.h"
#include "structs.h"

#include <graphics.h>
#include <iostream.h>
#include <process.h>
#include <math.h>
#include <conio.h>
#include <stdio.h>

long double Scale = 100;
int EyeZLoc = -12;
int SeeAhead = 87;

//long double ViewAngle = 1;   // i.e. 45 degrees on each side, so FOV=90 degrees
long double ViewAngle = 0.00000001;

int WallHeight = 10;
int GridSize = 10;

int FSmlX = 2;  // 0-2
int FSmlY = 0;  // 0-2
int FRot  = 6;  // 0-23   6=forward

int GridScalingW = 82;
int GridScalingH = 72;

int mapx=2;
int mapy=1;

int C64Coors = 0;  // phase out

int PauseAfterEach = 0;
int WireFrame = 0;
int weeding = 1;
char ViewAttr = 0;   // 1=Flip, 2=XY, 4=-X, 8=-Y

/************************************************************************/

TVideoMode CurrentMode = TEXT_MODE;

void GraphicsMode() {
  if (CurrentMode == GRAPHICS_MODE) return;

  int gdriver = VGA, gmode=VGAMED, errorcode;

  initgraph(&gdriver, &gmode, "C:\\PROG\\BC\\BGI\\");

  errorcode = graphresult();

  if (errorcode != grOk) {
    cout << "\n\nGraphics error: " << grapherrormsg(errorcode) << '\n';
    exit(1);
  }

  CurrentMode = GRAPHICS_MODE;
}

void TextMode() {
  if (CurrentMode == TEXT_MODE) return;
  closegraph();
}

/************************************************************************/


void XYZtoXY(wcoor wx,wcoor wy,wcoor wz,wcoor& sx,wcoor& sy) {
// converts world (x,y,z) to screen (x,y) using FRot and FSmlX/Y
/*
  sx = wx*4 + getmaxx()/2;
  sy = wz*4 + getmaxy()/2;
*/
  wz += -EyeZLoc;

  wcoor _sx;
  wcoor _sy;

  _sx = (Scale * wx / wz);
  _sy = (Scale * -wy / wz);

  sx = _sx;
  sy = _sy;
}

long double p_cosl(long double x) {
  static long double lastval = -33333;
  static long double lastans = 0;

  if (x == lastval) return lastans;
  lastval = x;
  return lastans = cosl(x);
}

long double p_sinl(long double x) {
  static long double lastval = -33333;
  static long double lastans = 0;

  if (x == lastval) return lastans;
  lastval = x;
  return lastans = sinl(x);
}

/*
  The fox rotates only around the Y axis:
*/
void XZtoRotatedXZ(wcoor& wx,wcoor& wz) {
  long double theta = ((30 - FRot) % 24) * M_PI / 12;

  wcoor rx = wx * p_cosl(theta) - wz * p_sinl(theta);
  wcoor rz = wz * p_cosl(theta) + wx * p_sinl(theta);
  wx = rx;
  wz = rz;
}

void XYZplot(wcoor wx,wcoor wy,wcoor wz) {
  wcoor sx;
  wcoor sy;
  XYZtoXY(wx,wy,wz,sx,sy);
  putpixel(sx,sy,getcolor());
  moveto(sx,sy);
}

void XYZlineto(wcoor wx,wcoor wy,wcoor wz) {
  wcoor sx;
  wcoor sy;
  XYZtoXY(wx,wy,wz,sx,sy);
  lineto(sx,sy);
}

void XYZline(wcoor wx1,wcoor wy1,wcoor wz1,wcoor wx2,wcoor wy2,wcoor wz2) {
  XYZplot(wx1,wy1,wz1);
  XYZlineto(wx2,wy2,wz2);
}

void StoreFace(TFace& face) {
  if (FaceBufSize >= MAXFACE) {
    //TextMode(); cout << "FaceBufSize error"; exit(1);
    gotoxy(1,1);
    printf(">> Too many faces <<");
    return;
  }

  FaceBuf[FaceBufSize++] = face;
}

void DrawFace(TC64Poly C64Face) {
  setcolor((((C64Face.MapX-5)*(C64Face.MapY-5))%15)+1);

  // Put it back into C64 MapSides
  // if ((MapSide == 0) || (MapSide == 2)) MapSide = 2-MapSide;

  int middle = 0;

  if (!C64Coors) {
    C64Face.A *= 2;
    C64Face.B *= 2;
    C64Face.C *= 2;
    C64Face.X *= 3;
    C64Face.W *= 3;
  }

  middle = getmaxy()/2;
  C64Face.X += 80;

  if (C64Face.Dir != 0) {
    moveto(C64Face.X,middle - C64Face.A);
    lineto(C64Face.X,middle + C64Face.A);
    lineto(C64Face.X + C64Face.W,
      middle + C64Face.B);
    lineto(C64Face.X + C64Face.W,
      middle - C64Face.B);
    lineto(C64Face.X,middle - C64Face.A);
  } else {
    moveto(C64Face.X,middle - C64Face.A);
    lineto(C64Face.X,middle + C64Face.A);
    lineto(C64Face.X - C64Face.W,
      middle + C64Face.B);
    lineto(C64Face.X - C64Face.W,
      middle - C64Face.B);
    lineto(C64Face.X,middle - C64Face.A);
  }
}

void RotateXYZtoXY(wcoor wx,wcoor wy,wcoor wz,wcoor& sx,wcoor& sy) {
  XZtoRotatedXZ(wx,wz);
  XYZtoXY(wx,wy,wz,sx,sy);
}

void ShowView() {
  // draw wedge:
  setcolor(2);

  wcoor y= -WallHeight/2;
  XYZline(0,y,0, 100/ViewAngle,y,100);
  XYZline(0,y,0, -100/ViewAngle,y,100);

  setcolor(15);

  // now plot all the cubes:

  int Radius = (SeeAhead / GridSize)+1;
  for (int mapx = -Radius; mapx <= Radius; mapx++)
  for (int mapy = -Radius; mapy <= Radius; mapy++)
    CalcCube(mapx,mapy);

}

void DrawPoly(TC64Poly& poly) {
  if (poly.Dir == 0) {
    moveto(poly.X,poly.A);
    lineto(poly.X,poly.A);
    lineto(poly.X-poly.W,poly.B);
    lineto(poly.X-poly.W,poly.B);
    lineto(poly.X,poly.A);
  } else {
    moveto(poly.X,poly.A);
    lineto(poly.X,poly.A);
    lineto(poly.X+poly.W,poly.B);
    lineto(poly.X+poly.W,poly.B);
    lineto(poly.X,poly.A);
  }
}

/*
  This determines whether a given X/Z coordinate, after rotated, will
  fall within the FOV/see-ahead pie slice.
*/
int CoorVisible(wcoor wx,wcoor wz) {
  XZtoRotatedXZ(wx,wz);

  return ( (sqrt(wx*wx + wz*wz) < SeeAhead)
    && (wz >= ViewAngle * wx) && (wz >= -ViewAngle * wx));
}

void CalcCube(int mapx,int mapy,int storeit) {

  // First, calculate the two endpoints of the cube in world coordinates:
  wcoor cubex = GridSize * ((-1.0/6) - (FSmlX/3.0) + mapx);
  wcoor cubez = GridSize * ((-1.0/6) - (FSmlY/3.0) + mapy);
  wcoor cubey = -WallHeight/2;

  wcoor cubex2 = GridSize + cubex;
  wcoor cubey2 = WallHeight/2;
  wcoor cubez2 = GridSize + cubez;

  TFace sides[4]; // 0=front, 1=right, 2=back, 3=left
  TFace& front = sides[0];
  TFace& right = sides[1];
  TFace& back  = sides[2];
  TFace& left  = sides[3];

  int visible[4] = { 0,0,0,0 };
  int anyvisible = 0;

  // front
  if (CoorVisible(cubex,cubez) || CoorVisible(cubex2,cubez))
    anyvisible = visible[0] = 1;

  // right
  if (CoorVisible(cubex2,cubez) || CoorVisible(cubex2,cubez2))
    anyvisible = visible[1] = 1;

  // back
  if (CoorVisible(cubex,cubez2) || CoorVisible(cubex2,cubez2))
    anyvisible = visible[2] = 1;

  // left
  if (CoorVisible(cubex,cubez) || CoorVisible(cubex,cubez2))
    anyvisible = visible[3] = 1;

  visible[0] = visible[1] = visible[2] = visible[3] = 1;

  if (!anyvisible) return;  // nothin'

  // front
  RotateXYZtoXY(cubex2,cubey2,cubez, front.cex2,front.cey2);
  RotateXYZtoXY(cubex2,cubey, cubez, front.flx2,front.fly2);
  RotateXYZtoXY(cubex, cubey, cubez, front.flx1,front.fly1);
  RotateXYZtoXY(cubex, cubey2,cubez, front.cex1,front.cey1);

  // right
  RotateXYZtoXY(cubex2,cubey, cubez, right.flx1,right.fly1);
  RotateXYZtoXY(cubex2,cubey2,cubez, right.cex1,right.cey1);
  RotateXYZtoXY(cubex2,cubey, cubez2,right.flx2,right.fly2);
  RotateXYZtoXY(cubex2,cubey2,cubez2,right.cex2,right.cey2);

  // back
  RotateXYZtoXY(cubex, cubey, cubez2,back.flx2,back.fly2);
  RotateXYZtoXY(cubex, cubey2,cubez2,back.cex2,back.cey2);
  RotateXYZtoXY(cubex2,cubey, cubez2,back.flx1,back.fly1);
  RotateXYZtoXY(cubex2,cubey2,cubez2,back.cex1,back.cey1);

  // left
  RotateXYZtoXY(cubex, cubey, cubez2,left.flx1,left.fly1);
  RotateXYZtoXY(cubex, cubey2,cubez2,left.cex1,left.cey1);
  RotateXYZtoXY(cubex, cubey, cubez, left.flx2,left.fly2);
  RotateXYZtoXY(cubex, cubey2,cubez, left.cex2,left.cey2);

  sides[0].CalcLeftRight();
  sides[1].CalcLeftRight();
  sides[2].CalcLeftRight();
  sides[3].CalcLeftRight();

  sides[0].SetMapInfo(mapx,mapy,2); // Use C64 mapsides (N,E,S,W)
  sides[1].SetMapInfo(mapx,mapy,1);
  sides[2].SetMapInfo(mapx,mapy,0);
  sides[3].SetMapInfo(mapx,mapy,3);

  // find frontmost face:

  int front1 = 0;

  for (int i=1;i<4;i++)
    if ( (sides[i].A() + sides[i].B())
      > (sides[front1].A() + sides[front1].B())) front1 = i;

  int minus1 = (front1 + 3) & 3;
  int plus1 = (front1 + 1) & 3;

  if (storeit) {
    if (visible[front1]) StoreFace(sides[front1]);
    if (visible[minus1])
      if (sides[minus1].rightx() <= sides[front1].leftx())
	StoreFace(sides[minus1]);

    if (visible[plus1])
      if (sides[plus1].leftx() >= sides[front1].rightx() )
	StoreFace(sides[plus1]);

  } else {
  /*
    if (visible[front1]) DrawFace(sides[front1]);
    if (visible[minus1])
      if (sides[minus1].rightx() <= sides[front1].leftx())
	DrawFace(sides[minus1]);

    if (visible[plus1])
      if (sides[plus1].leftx() >= sides[front1].rightx() )
	DrawFace(sides[plus1]);
  */
    exit(1);
  }
}

unsigned LargestVisibleColumn(TC64Poly& Poly) {  // (actually half-column)

  // If A is onscreen then it's the largest column:
  if ((Poly.X >= 0) && (Poly.X < V64_W)) {
    return Poly.A;
  }

  if (!Poly.W) return 0;  // no division by zero

  // If A is offscreen, then the tallest column is the one on the border:

  if (Poly.Dir == 1) {  // B is to right of A, A is offscreen
    int x;
    int y;

    x = -Poly.X;

    y = (x * -Poly.C / (float)Poly.W) + Poly.A + (rounding/2.0);  // y=mx+b

    return y;
  } else {   // A is to right of B, A is offscreen
    int x;
    int y;

    x = (Poly.X-V64_W)+1;

    y = (x * -Poly.C / (float)Poly.W) + Poly.A + (rounding/2.0);  // y=mx+b

    return y;
  }
}

void CreateFaceBuf() {
  FaceBufSize = 0;

  // Calculate them

  int i;
  int Radius = (SeeAhead / GridSize)+1;
  for (int mapx = -Radius; mapx <= Radius; mapx++)
  for (int mapy = -Radius; mapy <= Radius; mapy++)
    CalcCube(mapx,mapy,1);

  // Sort them front to back, left to right
  for (i=0;i<FaceBufSize;i++)
  for (int j=i+1;j<FaceBufSize;j++) {
    wcoor IAve = (FaceBuf[i].B() + FaceBuf[i].A())/2.0;
    wcoor JAve = (FaceBuf[j].B() + FaceBuf[j].A())/2.0;

    if (fabsl(IAve - JAve) < .000000001) {  // i.e. IAve == JAve
      // if they are equal front/back, then compare left/right
      IAve = FaceBuf[i].leftx();
      JAve = FaceBuf[j].leftx();
    }

    TFace temp;

    if (IAve < JAve) {  // swap them:
      temp = FaceBuf[i];
      FaceBuf[i] = FaceBuf[j];
      FaceBuf[j] = temp;
    }
  }

  // Put it into 64 coors:
  for (i=0; i<FaceBufSize; i++) {
    PolyBuf[i].Face2C64(FaceBuf[i]);
  }
  PolyBufSize = FaceBufSize;

  if (!weeding) return;


/*
Bounds for Polygons:

Math limitations:

PolyA	<=40       	(ScaleTable size / 2)
	<128		(if we're not concerned about the texture)
PolyW   <80	    	(ScaleTable size)
PolyX	<120		(screen width + max PolyW)
	>-80		(-MaxPolyW)

File limitations:

MapX	8 bits
MapY	8 bits

PolyW	7 bits
PolyX	8 bits

PolyC	7 bits
PolyDir	1 bits

PolyA	6 bits
MapSide	2 bits

*/

  int LeftmostColumn;
  int RightmostColumn;
  int ColsOnScreen;

  // Weed out the dummies:

  for (i=0; i<PolyBufSize; i++) {
    int writeit = 1;

    if (PolyBuf[i].A >= 128) writeit = 0;

    if (LargestVisibleColumn(PolyBuf[i]) >= 40) writeit = 0;

    // Make sure at least one column is on the screen:
    if (PolyBuf[i].Dir == 0) {
      // A is to the right of B
      LeftmostColumn = PolyBuf[i].X - PolyBuf[i].W;
      RightmostColumn = PolyBuf[i].X;
    } else {
      // B is to the right of A
      LeftmostColumn = PolyBuf[i].X;
      RightmostColumn = PolyBuf[i].X + PolyBuf[i].W;
    }
    ColsOnScreen = 0;
    if ((LeftmostColumn >= 0) && (LeftmostColumn < V64_W)) ColsOnScreen++;
    if ((RightmostColumn >= 0) && (RightmostColumn < V64_W)) ColsOnScreen++;
    if (!ColsOnScreen) writeit = 0;

    if (PolyBuf[i].W >= 80) writeit = 0;

    // Check for overflow:
    if ((PolyBuf[i].A < 0) || (PolyBuf[i].B < 0) || (PolyBuf[i].C < 0)
      || (PolyBuf[i].W < 0))
      writeit = 0;

    if (!writeit) PolyBuf[i].A = 63;
  }

  // make sure it's going to fit in the C64 table:
  for (i=0; i<PolyBufSize; i++) {
    int writeit = 1;

    if ((PolyBuf[i].MapX > 127) || (PolyBuf[i].MapX < -127)) writeit = 0;
    if ((PolyBuf[i].MapY > 127) || (PolyBuf[i].MapY < -127)) writeit = 0;

    if ((PolyBuf[i].W & 255) != PolyBuf[i].W) writeit = 0;

    if ((PolyBuf[i].X <= -80) || (PolyBuf[i].X >= 120)) writeit = 0;

    if ((PolyBuf[i].C & 63) != PolyBuf[i].C) writeit = 0;

    PolyBuf[i].Dir &= 1;
    if ((PolyBuf[i].A & 63) != PolyBuf[i].A) writeit = 0;
    PolyBuf[i].MapSide &= 3;

    if (!writeit) PolyBuf[i].A = 63;
  }

}

void ShowC64View() {
  int i;

  CreateFaceBuf();

  C64ClearScr();

  int contpausing = 1;

  // draw the floor grid
  for (i=0;i<PolyBufSize;i++)
    if (PolyBuf[i].A != 63) DrawFloorGrid(PolyBuf[i],7);

  for (i=0;i<PolyBufSize;i++) {
    if (PolyBuf[i].A != 63) {
      int _mapx = PolyBuf[i].MapX;
      int _mapy = PolyBuf[i].MapY;

      if (ViewAttr & 2) { // XY
	int temp = _mapx;
	_mapx = _mapy;
	_mapy = temp;
      }
      if (ViewAttr & 4) _mapx = -_mapx;
      if (ViewAttr & 8) _mapy = -_mapy;

      int color = GetMap(_mapx+mapx,_mapy+mapy);
      if (color) {
	DrawItNormal(PolyBuf[i],color);
	if (PauseAfterEach && contpausing) {
	  gotoxy(1,1);
	  printf("#%d  A=%d W=%d X=%d C=%d Dir=%d               ",
	    i,PolyBuf[i].A,PolyBuf[i].W,PolyBuf[i].X,PolyBuf[i].C,
	    PolyBuf[i].Dir);

	  switch (getch()) {
	    case 27: exit(0);
	    case 'p': PauseAfterEach = 0;
	    case ' ': contpausing = 0; break;
	  }
	}
      }
    }
  }
}

