#ifndef VIDEO_H
#define VIDEO_H

#include "structs.h"

enum TVideoMode {
  GRAPHICS_MODE,
  TEXT_MODE
};

extern TVideoMode CurrentMode;

/*
  These are the perspective/scaling parameters necessary for converting
  world coordinates into Commodore coordinates:
*/

extern long double Scale;
extern int EyeZLoc;
extern int SeeAhead;
extern long double ViewAngle;
extern int WallHeight;
extern int GridSize;
extern int GridScalingW;
extern int GridScalingH;
extern int C64Coors;
extern int mapx;
extern int mapy;
extern int PauseAfterEach;
extern int WireFrame;
extern int weeding;
extern char ViewAttr;  // 1=Flip, 2=XY, 4=-X, 8=-Y


/*
  These define the current scene we're looking at.  They're so central to
  all the calculations that I've made them globals.
*/
extern int FSmlX;
extern int FSmlY;
extern int FRot;

void GraphicsMode();
void TextMode();
void XYZtoXY(wcoor wx,wcoor wy,wcoor wz,wcoor& sx,wcoor& sy);
void XZtoRotatedXZ(wcoor& wx,wcoor& wz);
void XYZplot(wcoor wx,wcoor wy,wcoor wz);
void XYZlineto(wcoor wx,wcoor wy,wcoor wz);
void XYZline(wcoor wx1,wcoor wy1,wcoor wz1,wcoor wx2,wcoor wy2,wcoor wz2);
void CalcCube(int mapx=0,int mapy=0,int calcing=0);
void ShowView();
void CreateFaceBuf();
void ShowC64View();

#endif
