/*
  ALIAS.H - Written by Peter Gonzalez [pbgonz@mail.wm.edu], 1995

    CASM, CDASM, CLINK, and CDUMP are freeware; they may be freely
  distributed, provided that no fee is charged and I am given due
  credit for my work.  This source code is available directly from me upon
  request; please do not distribute the source code or any compiled
  modifications without my consent.  Support freeware!
*/

#ifndef _ALIAS_H
#define _ALIAS_H

#include "misc.h"
#include "hash.h"
#include "tokenize.h"


struct TAlias : public THashObject {
  unsigned Data;
  struct {
    char IsWord: 1;
    char IsConst: 1;
    char IsUsed: 1;
  } Attrs;
};
extern THash AliasList;

struct TAutoAlias {
  unsigned Addr;
  BOOL IsRange;
  TAutoAlias *Next;
};

extern TAutoAlias *AutoAliasesB;
extern TAutoAlias *AutoAliasesW;

void ReadVARS(TASMFileTokenizer& ftok);

class TBlock;

TAlias *ReadAliasDef(TASMFileTokenizer& ftok,BOOL IsConst,BOOL IsWord,
  TBlock *LocalBlock);
TAlias *ReadAutoAliasDef(TASMFileTokenizer& ftok,BOOL IsWord);

void ShowUnusedAliases();

#endif
