/* 
  GENERAL.CPP - Written by Peter Gonzalez [pbgonz@mail.wm.edu], 1995

    CASM, CDASM, CLINK, and CDUMP are freeware; they may be freely
  distributed, provided that no fee is charged and I am given due 
  credit for my work.  This source code is available directly from me upon 
  request; please do not distribute the source code or any compiled  
  modifications without my consent.  Support freeware!  
*/ 
 
#include "general.h"
#include "version.h"
#include "casm.h"

#include <dos.h>
#include <ctype.h>

TErrStr::Tende ENDE;
TErrStr::Tendw ENDW;
TErrStr::Tprogbug PROGBUG;
TErrStr ErrStr;

//--------------------------------------------------------------------------
TErrStr& TErrStr::operator <<(Tende) {
//--------------------------------------------------------------------------
  con.flush();
  *msg << ends;
  cout << "\n\nERROR: " << msg->str() << "\n";

  cout.flush();
  con << "\n";
  exit(1);

  return *this;
}

//--------------------------------------------------------------------------
TErrStr& TErrStr::operator <<(Tendw) {
//--------------------------------------------------------------------------
  if (!GP.HideWarnings) {
    con.flush();
    *msg << ends;
    cout << "\nWARNING: " << msg->str();
    cout.flush();
  }

  delete msg;
  msg = new ostrstream;
  if (!msg) { cout << "Out of memory!"; exit(1); }

  return *this;
}

//--------------------------------------------------------------------------
TErrStr& TErrStr::operator <<(Tprogbug) {
//--------------------------------------------------------------------------
  con.flush();

  *msg << ends;
  cout << "\n\nPROGRAM BUG: " << msg->str() << "\n";

  cout << "\nCongratulations!  You found a bug in CASM!  If you would like\n"
       << "to see the problem fixed, e-mail a copy of the .ASM file which caused\n"
       << "the foul-up, the CASM version number (" << VersionID() << "), and any\n"
       << "helpful comments to ";


  void (*_EXIT)(int) = (void (*)(int)) (void *) keep;
  if (WRITENAME(cout)) _EXIT = exit;

  cout << ".  Thanks!\n";

  cout.flush();
  con << "\n";
  _EXIT(1);

  return *this;
}

//--------------------------------------------------------------------------
void TErrStr::OutOfMemory() {
//--------------------------------------------------------------------------
  con.flush();
  cout << "\n\nERROR: Out of memory\n";

  cout.flush();
  con << "\n";
  exit(1);
}

//--------------------------------------------------------------------------
void TErrStr::QuoteCharacter(char c) {
//--------------------------------------------------------------------------
  (*this) << '\'';
  if isprint(c) (*this) << (char) c << '\'';
  else (*this) << "\\x" << hex << (unsigned) c << '\'';
}

constream con;
