/* 
  GENERAL.H - Written by Peter Gonzalez [pbgonz@mail.wm.edu], 1995 
 
    CASM, CDASM, CLINK, and CDUMP are freeware; they may be freely 
  distributed, provided that no fee is charged and I am given due 
  credit for my work.  This source code is available directly from me upon 
  request; please do not distribute the source code or any compiled  
  modifications without my consent.  Support freeware!  
*/ 
 
#ifndef _GENERAL_H
#define _GENERAL_H

/*
  General Definitions
*/
typedef int BOOL;

#define TRUE  1
#define FALSE 0

/*
  Error Handling
*/

#include <strstrea.h>
#include <process.h>
#include <constrea.h>

class TErrStr {
public:
  class Tende { };
  class Tendw { };
  class Tprogbug { };

  ostrstream *msg;
  TErrStr& operator <<(Tende input);
  TErrStr& operator <<(Tendw input);
  TErrStr& operator <<(Tprogbug input);
  void OutOfMemory();
  void QuoteCharacter(char c);

  TErrStr() {
    msg = new ostrstream;
    if (!msg) { cout << "Out of memory!"; exit(1); }
  }
  ~TErrStr() { delete msg; }
};

extern TErrStr::Tendw ENDW;
extern TErrStr::Tende ENDE;
extern TErrStr::Tprogbug PROGBUG;
extern TErrStr ErrStr;

template <class T> TErrStr& operator <<(TErrStr& str,T input) {
  (*str.msg) << input;
  return str;
}

extern constream con;  // remember to flush cout before using this!

#endif

