/* 
  HASH.H - Written by Peter Gonzalez [pbgonz@mail.wm.edu], 1995 
 
    CASM, CDASM, CLINK, and CDUMP are freeware; they may be freely 
  distributed, provided that no fee is charged and I am given due 
  credit for my work.  This source code is available directly from me upon 
  request; please do not distribute the source code or any compiled  
  modifications without my consent.  Support freeware!  
*/ 
 
#ifndef _HASH_H
#define _HASH_H

#include "petestr.h"

#define BTREENUMBRANCHES 2
#define MAXBTREEDEPTH 100

class THashObject {
  friend class THash;

public:
  FString Name;

  unsigned HashValue;
  THashObject *Branch[BTREENUMBRANCHES];
};


class THash {
  THashObject *root;

  unsigned GetDepth(const THashObject *loc);
  unsigned MakeHashValue(const char *cur);

  void EmptyTree(THashObject *loc);

public:
  THash() { root = 0; }
  ~THash() { EmptyTree(root); }

  unsigned GetDepth() { return GetDepth(root); }

  THashObject *GetRoot() { return root; }

  void Insert(THashObject *NewObj);
  THashObject *Find(const char *key);
};

#endif
