/* 
  MEMALLOC.CPP - Written by Peter Gonzalez [pbgonz@mail.wm.edu], 1995 
 
    CASM, CDASM, CLINK, and CDUMP are freeware; they may be freely 
  distributed, provided that no fee is charged and I am given due 
  credit for my work.  This source code is available directly from me upon 
  request; please do not distribute the source code or any compiled  
  modifications without my consent.  Support freeware!  
*/ 
 
#include <alloc.h>
#include <iostream.h>
#include <stdlib.h>

#include "memalloc.h"

unsigned char TBoolSet::mask(unsigned num) {
  static char table[] = {1,2,4,8,16,32,64,128};
  return table[num % 8];
}

void TBoolSet::SetBit(unsigned num,int newval) {
  if (num > size) ErrStr << "Set index out of range" << ENDE;
  if (newval) memory[num/8] |= mask(num % 8);
  else memory[num/8] &= ~mask(num % 8);
}

int TBoolSet::GetBit(unsigned num) {
  if (num > size) ErrStr << "Set index out of range" << ENDE;
  return !!(memory[num/8] & mask(num % 8));
}

unsigned TBoolSet::FirstFree() {
  // returns 0xffff if can't find one:
  unsigned i = 0;
  while (i <= (size/8)) {
    if (memory[i] != 0xff) {
      i *= 8;
      while (i < size) {
	if (!GetBit(i)) return i;
	i++;
      }
      return 0xffff;
    }
    i++;
  }
  return 0xffff;
}
/*
alias
  name
  16-bit valuee

label
  name
  pointer to sub referencing it

dynamicval
  starting value
  list of line labels to add/subtract
...
struct {
  string
  16bit value
}

void main() {

}

