/* 
  MEMALLOC.H - Written by Peter Gonzalez [pbgonz@mail.wm.edu], 1995 
 
    CASM, CDASM, CLINK, and CDUMP are freeware; they may be freely 
  distributed, provided that no fee is charged and I am given due 
  credit for my work.  This source code is available directly from me upon 
  request; please do not distribute the source code or any compiled  
  modifications without my consent.  Support freeware!  
*/ 
 
#ifndef _MEMALLOC_H
#define _MEMALLOC_H

#include "general.h"

class TBoolSet {
  unsigned char *memory;
  unsigned size;

protected:
  unsigned char mask(unsigned num);

public:
  TBoolSet(unsigned _size,int initval = 0) : size(_size) {
    memory = (unsigned char *)malloc(size/8 + 2);
    if (!memory) ErrStr.OutOfMemory();
    memset(memory,!!initval,size+1);
  }

  void SetBit(unsigned num,int newval = 1);
  void ClearBit(unsigned num) { SetBit(num,0); }

  int GetBit(unsigned num);
  unsigned FirstFree();
};

#endif

