/* 
  PARSER.CPP - Written by Peter Gonzalez [pbgonz@mail.wm.edu], 1995 
 
    CASM, CDASM, CLINK, and CDUMP are freeware; they may be freely 
  distributed, provided that no fee is charged and I am given due 
  credit for my work.  This source code is available directly from me upon 
  request; please do not distribute the source code or any compiled  
  modifications without my consent.  Support freeware!  
*/ 

#include "parser.h"
#include "alias.h"
#include "block.h"
#include "casm.h"

//--------------------------------------------------------------------------
void ReadAliasesAndBlocks(TASMFileTokenizer& ftok) {
//--------------------------------------------------------------------------
  TToken cur;

  do {
    cur = ftok.GetNextToken();

    /**/ if (cur == "ALIASB") AliasList.Insert(ReadAliasDef(ftok,FALSE,FALSE,0));
    else if (cur == "ALIASW") AliasList.Insert(ReadAliasDef(ftok,FALSE,TRUE,0));
    else if (cur == "CONSTB") AliasList.Insert(ReadAliasDef(ftok,TRUE,FALSE,0));
    else if (cur == "CONSTW") AliasList.Insert(ReadAliasDef(ftok,TRUE,TRUE,0));
    else if (cur == "VB") AliasList.Insert(ReadAutoAliasDef(ftok,FALSE));
    else if (cur == "VW") AliasList.Insert(ReadAutoAliasDef(ftok,TRUE));

    else if (cur == "DATA")   ReadBlock(ftok,TBlock::DATA);
    else if (cur == "CODE")    ReadBlock(ftok,TBlock::CODE);
    else if (cur == '@') {
      DString FileName = ftok.ReadToDelim("\n");
      FileName += ".LIB";
      FileName.AllUpper();
      ftok.Open(FileName);
    } else if ((cur == "") || (ftok.Eof())) return;
    else if (cur == "LAYOUT") {
      cur.WriteFileLine(ErrStr);
      ErrStr << "Misplaced LAYOUT block" << ENDE;
    } else {
      cur.WriteFileLine(ErrStr);
      if (IsID(cur.Text)) ErrStr << "Unknown block type: \"";
      else ErrStr << "Unknown symbol: \"";
      ErrStr << cur << '\"' << ENDE;
    }
  } while(1);
}

