#include "pgstr.h"

pgistream::pgistream() {
  peeked = FALSE;
  curp = 0;
  buftop = 0;
  peekch = 0;
  EOFhit = FALSE;
  status = FILECLOSED;
}

pgistream::~pgistream() {
  if ((status == FILEOPEN) || (status == EOF)) {
    fasdos_close(handle);
  }
}

void pgistream::open(const char *_fname) {
  fname = _fname;
  curp = 0;

  if ((status == FILEOPEN) || (status == FILEEOF)) fasdos_close(handle);

  handle = fasdos_open(fname.c_str());

  if (handle != 0xffff) status = FILEOPEN;
}

int pgistream::get() {
  if (status != FILEOPEN) return EOF;
  if (peeked) {
    peeked = FALSE;
    return peekch;
  }
  if (curp < buftop) return buf[curp++];

  // overflow:
  unsigned t = fasdos_read(handle,buf,BUFSIZE);
  if (t == 0xffff) {
    status = ERROR;
    return EOF;
  }
  if (t == 0) {
    status = FILEEOF;
    return EOF;
  }

  curp = 0;
  buftop = t;

  return buf[curp++];
}

int pgistream::peek() {
  if (peeked)  return peekch;
  peeked = TRUE;
  peekch = get();
  return peekch;
}

void pgistream::putback(int ch) {
  if (peeked) ErrStr << "stream problems" << PROGBUG;
  peekch = ch;
  peeked = TRUE;
}

void pgistream::close() {
  if (status == FILECLOSED) return;
  fasdos_close(handle);
  status = FILECLOSED;
  return;
}
