/* 
  TABLES.CPP - Written by Peter Gonzalez [pbgonz@mail.wm.edu], 1995 
 
    CASM, CDASM, CLINK, and CDUMP are freeware; they may be freely 
  distributed, provided that no fee is charged and I am given due 
  credit for my work.  This source code is available directly from me upon 
  request; please do not distribute the source code or any compiled  
  modifications without my consent.  Support freeware!  
*/ 
 
#include <string.h>

#include "tables.h"

char instrstr[][4] = {
  "brk", "ora", "asl", "php", "bpl", "clc", "jsr", "and", "bit", "rol",
  "plp", "bmi", "sec", "rti", "eor", "lsr", "pha", "jmp", "bvc", "cli",
  "rts", "adc", "pla", "ror", "bvs", "sei",

  "sta", "sty", "stx", "dey", "txa", "bcc", "tya", "txs", "ldy", "lda",
  "ldx", "tay", "tax", "bcs", "clv", "tsx", "cpy", "cmp", "dec", "iny",
  "dex", "bne", "cld", "sbc", "cpx", "inc", "inx", "nop", "beq", "sed",
  "???" // must always be last
};

extern instrtabletype instrtable[] = {
  /*00*/ { BRK, TYPEA },  /*01*/ { ORA, TYPEB },  /*02*/ { QQQ, TYPEA },
  /*03*/ { QQQ, TYPEA },  /*04*/ { QQQ, TYPEA },  /*05*/ { ORA, TYPEC },
  /*06*/ { ASL, TYPEC },  /*07*/ { QQQ, TYPEA },  /*08*/ { PHP, TYPEA },
  /*09*/ { ORA, TYPED },  /*0A*/ { ASL, TYPEA },  /*0B*/ { QQQ, TYPEA },
  /*0C*/ { QQQ, TYPEA },  /*0D*/ { ORA, TYPEG },  /*0E*/ { ASL, TYPEG },
  /*0F*/ { QQQ, TYPEA },

  /*10*/ { BPL, TYPEK },  /*11*/ { ORA, TYPEE },  /*12*/ { QQQ, TYPEA },
  /*13*/ { QQQ, TYPEA },  /*14*/ { QQQ, TYPEA },  /*15*/ { ORA, TYPEF },
  /*16*/ { ASL, TYPEF },  /*17*/ { QQQ, TYPEA },  /*18*/ { CLC, TYPEA },
  /*19*/ { ORA, TYPEH },  /*1A*/ { QQQ, TYPEA },  /*1B*/ { QQQ, TYPEA },
  /*1C*/ { QQQ, TYPEA },  /*1D*/ { ORA, TYPEI },  /*1E*/ { ASL, TYPEI },
  /*1F*/ { QQQ, TYPEA },

  /*20*/ { JSR, TYPEG },  /*21*/ { AND, TYPEB },  /*22*/ { QQQ, TYPEA },
  /*23*/ { QQQ, TYPEA },  /*24*/ { BIT, TYPEC },  /*25*/ { AND, TYPEC },
  /*26*/ { ROL, TYPEC },  /*27*/ { QQQ, TYPEA },  /*28*/ { PLP, TYPEA },
  /*29*/ { AND, TYPED },  /*2A*/ { ROL, TYPEA },  /*2B*/ { QQQ, TYPEA },
  /*2C*/ { BIT, TYPEG },  /*2D*/ { AND, TYPEG },  /*2E*/ { ROL, TYPEG },
  /*2F*/ { QQQ, TYPEA },

  /*30*/ { BMI, TYPEK },  /*31*/ { AND, TYPEE },  /*32*/ { QQQ, TYPEA },
  /*33*/ { QQQ, TYPEA },  /*34*/ { QQQ, TYPEA },  /*35*/ { AND, TYPEF },
  /*36*/ { ROL, TYPEF },  /*37*/ { QQQ, TYPEA },  /*38*/ { SEC, TYPEA },
  /*39*/ { AND, TYPEH },  /*3A*/ { QQQ, TYPEA },  /*3B*/ { QQQ, TYPEA },
  /*3C*/ { QQQ, TYPEA },  /*3D*/ { AND, TYPEI },  /*3E*/ { ROL, TYPEI },
  /*3F*/ { QQQ, TYPEA },

  /*40*/ { RTI, TYPEA },  /*41*/ { EOR, TYPEB },  /*42*/ { QQQ, TYPEA },
  /*43*/ { QQQ, TYPEA },  /*44*/ { QQQ, TYPEA },  /*45*/ { EOR, TYPEC },
  /*46*/ { LSR, TYPEC },  /*47*/ { QQQ, TYPEA },  /*48*/ { PHA, TYPEA },
  /*49*/ { EOR, TYPED },  /*4A*/ { LSR, TYPEA },  /*4B*/ { QQQ, TYPEA },
  /*4C*/ { JMP, TYPEG },  /*4D*/ { EOR, TYPEG },  /*4E*/ { LSR, TYPEG },
  /*4F*/ { QQQ, TYPEA },

  /*50*/ { BVC, TYPEK },  /*51*/ { EOR, TYPEE },  /*52*/ { QQQ, TYPEA },
  /*53*/ { QQQ, TYPEA },  /*54*/ { QQQ, TYPEA },  /*55*/ { EOR, TYPEF },
  /*56*/ { LSR, TYPEF },  /*57*/ { QQQ, TYPEA },  /*58*/ { CLI, TYPEA },
  /*59*/ { EOR, TYPEH },  /*5A*/ { QQQ, TYPEA },  /*5B*/ { QQQ, TYPEA },
  /*5C*/ { QQQ, TYPEA },  /*5D*/ { EOR, TYPEI },  /*5E*/ { LSR, TYPEI },
  /*5F*/ { QQQ, TYPEA },

  /*60*/ { RTS, TYPEA },  /*61*/ { ADC, TYPEB },  /*62*/ { QQQ, TYPEA },
  /*63*/ { QQQ, TYPEA },  /*64*/ { QQQ, TYPEA },  /*65*/ { ADC, TYPEC },
  /*66*/ { ROR, TYPEC },  /*67*/ { QQQ, TYPEA },  /*68*/ { PLA, TYPEA },
  /*69*/ { ADC, TYPED },  /*6A*/ { ROR, TYPEA },  /*6B*/ { QQQ, TYPEA },
  /*6C*/ { JMP, TYPEJ },  /*6D*/ { ADC, TYPEG },  /*6E*/ { ROR, TYPEG },
  /*6F*/ { QQQ, TYPEA },

  /*70*/ { BVS, TYPEK },  /*71*/ { ADC, TYPEE },  /*72*/ { QQQ, TYPEA },
  /*73*/ { QQQ, TYPEA },  /*74*/ { QQQ, TYPEA },  /*75*/ { ADC, TYPEF },
  /*76*/ { ROR, TYPEF },  /*77*/ { QQQ, TYPEA },  /*78*/ { SEI, TYPEA },
  /*79*/ { ADC, TYPEH },  /*7A*/ { QQQ, TYPEA },  /*7B*/ { QQQ, TYPEA },
  /*7C*/ { QQQ, TYPEA },  /*7D*/ { ADC, TYPEI },  /*7E*/ { ROR, TYPEI },
  /*7F*/ { QQQ, TYPEA },


  /*80*/ { QQQ, TYPEA },  /*81*/ { STA, TYPEB },  /*82*/ { QQQ, TYPEA },
  /*83*/ { QQQ, TYPEA },  /*84*/ { STY, TYPEC },  /*85*/ { STA, TYPEC },
  /*86*/ { STX, TYPEC },  /*87*/ { QQQ, TYPEA },  /*88*/ { DEY, TYPEA },
  /*89*/ { QQQ, TYPEA },  /*8A*/ { TXA, TYPEA },  /*8B*/ { QQQ, TYPEA },
  /*8C*/ { STY, TYPEG },  /*8D*/ { STA, TYPEG },  /*8E*/ { STX, TYPEG },
  /*8F*/ { QQQ, TYPEA },

  /*90*/ { BCC, TYPEK },  /*91*/ { STA, TYPEE },  /*92*/ { QQQ, TYPEA },
  /*93*/ { QQQ, TYPEA },  /*94*/ { STY, TYPEF },  /*95*/ { STA, TYPEF },
  /*96*/ { STX, TYPEL },  /*97*/ { QQQ, TYPEA },  /*98*/ { TYA, TYPEA },
  /*99*/ { STA, TYPEH },  /*9A*/ { TXS, TYPEA },  /*9B*/ { QQQ, TYPEA },
  /*9C*/ { QQQ, TYPEA },  /*9D*/ { STA, TYPEI },  /*9E*/ { QQQ, TYPEA },
  /*9F*/ { QQQ, TYPEA },

  /*A0*/ { LDY, TYPED },  /*A1*/ { LDA, TYPEB },  /*A2*/ { LDX, TYPED },
  /*A3*/ { QQQ, TYPEA },  /*A4*/ { LDY, TYPEC },  /*A5*/ { LDA, TYPEC },
  /*A6*/ { LDX, TYPEC },  /*A7*/ { QQQ, TYPEA },  /*A8*/ { TAY, TYPEA },
  /*A9*/ { LDA, TYPED },  /*AA*/ { TAX, TYPEA },  /*AB*/ { QQQ, TYPEA },
  /*AC*/ { LDY, TYPEG },  /*AD*/ { LDA, TYPEG },  /*AE*/ { LDX, TYPEG },
  /*AF*/ { QQQ, TYPEA },

  /*B0*/ { BCS, TYPEK },  /*B1*/ { LDA, TYPEE },  /*B2*/ { QQQ, TYPEA },
  /*B3*/ { QQQ, TYPEA },  /*B4*/ { LDY, TYPEF },  /*B5*/ { LDA, TYPEF },
  /*B6*/ { LDX, TYPEL },  /*B7*/ { QQQ, TYPEA },  /*B8*/ { CLV, TYPEA },
  /*B9*/ { LDA, TYPEH },  /*BA*/ { TSX, TYPEA },  /*BB*/ { QQQ, TYPEA },
  /*BC*/ { LDY, TYPEI },  /*BD*/ { LDA, TYPEI },  /*BE*/ { LDX, TYPEH },
  /*BF*/ { QQQ, TYPEA },

  /*C0*/ { CPY, TYPED },  /*C1*/ { CMP, TYPEB },  /*C2*/ { QQQ, TYPEA },
  /*C3*/ { QQQ, TYPEA },  /*C4*/ { CPY, TYPEC },  /*C5*/ { CMP, TYPEC },
  /*C6*/ { DEC, TYPEC },  /*C7*/ { QQQ, TYPEA },  /*C8*/ { INY, TYPEA },
  /*C9*/ { CMP, TYPED },  /*CA*/ { DEX, TYPEA },  /*CB*/ { QQQ, TYPEA },
  /*CC*/ { CPY, TYPEG },  /*CD*/ { CMP, TYPEG },  /*CE*/ { DEC, TYPEG },
  /*CF*/ { QQQ, TYPEA },

  /*D0*/ { BNE, TYPEK },  /*D1*/ { CMP, TYPEE },  /*D2*/ { QQQ, TYPEA },
  /*D3*/ { QQQ, TYPEA },  /*D4*/ { QQQ, TYPEA },  /*D5*/ { CMP, TYPEF },
  /*D6*/ { DEC, TYPEF },  /*D7*/ { QQQ, TYPEA },  /*D8*/ { CLD, TYPEA },
  /*D9*/ { CMP, TYPEH },  /*DA*/ { QQQ, TYPEA },  /*DB*/ { QQQ, TYPEA },
  /*DC*/ { QQQ, TYPEA },  /*DD*/ { CMP, TYPEI },  /*DE*/ { DEC, TYPEI },
  /*DF*/ { QQQ, TYPEA },

  /*E0*/ { CPX, TYPED },  /*E1*/ { SBC, TYPEB },  /*E2*/ { QQQ, TYPEA },
  /*E3*/ { QQQ, TYPEA },  /*E4*/ { CPX, TYPEC },  /*E5*/ { SBC, TYPEC },
  /*E6*/ { INC, TYPEC },  /*E7*/ { QQQ, TYPEA },  /*E8*/ { INX, TYPEA },
  /*E9*/ { SBC, TYPED },  /*EA*/ { NOP, TYPEA },  /*EB*/ { QQQ, TYPEA },
  /*EC*/ { CPX, TYPEG },  /*ED*/ { SBC, TYPEG },  /*EE*/ { INC, TYPEG },
  /*EF*/ { QQQ, TYPEA },

  /*F0*/ { BEQ, TYPEK },  /*F1*/ { SBC, TYPEE },  /*F2*/ { QQQ, TYPEA },
  /*F3*/ { QQQ, TYPEA },  /*F4*/ { QQQ, TYPEA },  /*F5*/ { SBC, TYPEF },
  /*F6*/ { INC, TYPEF },  /*F7*/ { QQQ, TYPEA },  /*F8*/ { SED, TYPEA },
  /*F9*/ { SBC, TYPEH },  /*FA*/ { QQQ, TYPEA },  /*FB*/ { QQQ, TYPEA },
  /*FC*/ { QQQ, TYPEA },  /*FD*/ { SBC, TYPEI },  /*FE*/ { INC, TYPEI },
  /*FF*/ { QQQ, TYPEA }
};

int GetInstrNum(const char *str) {
  int i=0;

  if (strlen(str) != 3) return -1;

  do {
    if (stricmp(str,instrstr[i]) == 0) return i;
  } while (instrstr[++i][0] != '?');  // stop at ??? instruction
  return -1; // not found
}
