/* 
  TABLES.H - Written by Peter Gonzalez [pbgonz@mail.wm.edu], 1995 
 
    CASM, CDASM, CLINK, and CDUMP are freeware; they may be freely 
  distributed, provided that no fee is charged and I am given due 
  credit for my work.  This source code is available directly from me upon 
  request; please do not distribute the source code or any compiled  
  modifications without my consent.  Support freeware!  
*/ 
 
#ifndef _TABLES_H
#define _TABLES_H

enum instrtype{
   BRK=0, ORA ,  ASL ,  PHP ,  BPL ,  CLC ,  JSR ,  AND ,  BIT ,  ROL ,
   PLP ,  BMI ,  SEC ,  RTI ,  EOR ,  LSR ,  PHA ,  JMP ,  BVC ,  CLI ,
   RTS ,  ADC ,  PLA ,  ROR ,  BVS ,  SEI ,

   STA ,  STY ,  STX ,  DEY ,  TXA ,  BCC ,  TYA ,  TXS ,  LDY ,  LDA ,
   LDX ,  TAY ,  TAX ,  BCS ,  CLV ,  TSX ,  CPY ,  CMP ,  DEC ,  INY ,
   DEX ,  BNE ,  CLD ,  SBC ,  CPX ,  INC ,  INX ,  NOP ,  BEQ ,  SED ,
   QQQ
};

extern char instrstr[][4];

enum paramtype {
/*
  NOTE: HI nibble represents # of extra bytes
*/
  TYPEA = 0x00, // nothing
  TYPEB = 0x10, // ($00,X)
  TYPEC = 0x11, // $00
  TYPED = 0x12, // #$00
  TYPEE = 0x13, // ($00),Y
  TYPEF = 0x14, // $00,X
  TYPEL = 0X15, // $00,Y
  TYPEK = 0x16, // $0000 for near jumps
  TYPEG = 0x20, // $0000
  TYPEH = 0x21, // $0000,Y
  TYPEI = 0x22, // $0000,X
  TYPEJ = 0x23 // ($0000)
};


struct instrtabletype {
  instrtype instr;
  paramtype param;
};

extern instrtabletype instrtable[];

int GetInstrNum(const char *str);

#endif
