/*
  VERSION.CPP - Written by Peter Gonzalez [pbgonz@mail.wm.edu], 1995

    CASM, CDASM, CLINK, and CDUMP are freeware; they may be freely
  distributed, provided that no fee is charged and I am given due
  credit for my work.  This source code is available directly from me upon
  request; please do not distribute the source code or any compiled
  modifications without my consent.  Support freeware!


  Revsision History
  ========= =======

  Version  Date      	Changes
  -------  --------  	-------
  1.45     01/06/97  	Finally added a revision history!
			Cleaned up the error messages and help text
			Prettied up the comments
			Added local aliases and automatic aliases ("VARS")

  1.46	   01/11/97	Added warning messages
			Fixed order of blocks in disassembly
			Added assemble statistics
			Added "JCC" and "JCS", which had been forgotten
			Looked into allowing scoping operator to be used
			  with local aliases, ("ParentBlock|LocalAlias"),
			  but concluded this would require too much
			  modification to the label fixup code.

  1.47	   01/11/97	Updated alias coded so that local aliases could be
			  assigned to other local aliases
			Moved error messages to before disassembly (this
			  required the creation of TBlockLayoutList)
			Added ";- inside block comment" warning
			Modified ErrStr to support warnings, and changed
			  warning code to use that
			Added "CONSTB" and "CONSTW" datatypes, and modified
			  TAlias to use bitfields

  1.48     03/10/97	Added total line count to output
			Made ",X" / ",Y" lowercase to match rest of output

  1.49	   03/11/97	Modified "dat" and "datw" to accept labels
			** This code is in DIRE need of an overhaul! **

*/

#include <iostream.h>
#include "general.h"

long _NameCheck = 0x13f55305L+50L;

//--------------------------------------------------------------------------
long _WriteName(ostream& os) {
//--------------------------------------------------------------------------
  char buf[] = "Peter Gonzalez <pbgonz@mail.wm.edu>";
  char *c = buf;
  long ret = 3141519L;
  while (*c) {
    ret += (*c) * 100001L;
    ret ^= *c;
    os << *c;
    c++;
  }
  return ret;
}

//--------------------------------------------------------------------------
const char *VersionID() {
//--------------------------------------------------------------------------
#ifdef __BCPLUSPLUS__
  return "1.49b";		// Old compiler is being used
#else
  return "1.49";
#endif
}

//--------------------------------------------------------------------------
void WriteFreewareMsg() {
//--------------------------------------------------------------------------
cout.flush();
con << '\n' <<
"     CASM and its supporting files CDASM, CLINK, and CDUMP are\n\
freeware.  This means that they may be copied and distributed freely\n\
provided that they are not modified and no fee is charged.  If you\n\
are missing some files, would like to report a bug, would like to see\n\
the source code, or have any comments/feedback, please contact the\n\
author via e-mail.  Support freeware!\n";
con.flush();
}
